/*

Copyright (C) 2018 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#include<iostream>
#include<iomanip>
#include"../board/bposition.h"
using namespace std;

//-------------------------------------------------------
//
//           unittest boardposition:
//

void test_bposition()
{
  bool r=true;

  cout << "Test BoardPosition ...................................." << flush;
  
  BoardPosition bp;
  /*
  //---------------- set piece on square ----------------------
  {
    bp.set_piece_on(a1,white_knight_id);
    bp.set_piece_on(a1,black_rook_id);
    bp.remove_piece_from(a1,white_knight_id);
    bp.remove_piece_from(a1,black_rook_id);
    if(bp.white_knight()){r=false;}
    if(bp.black_rook()){r=false;}
  }
  
  //---------------- make en passant move ----------------------
  {
    bp.clear();
    bp.set_piece_on(e5,white_pawn_id);
    bp.set_piece_on(d5,black_pawn_id);
    BitBoard wp1=bp.white_pawn();
    BitBoard bp1=bp.black_pawn();
    Move m(e5,d6,en_passant,WhitePawn(),BlackPawn());
    bp.make_move(m);
    bp.unmake_move(m);
    BitBoard wp2=bp.white_pawn();
    BitBoard bp2=bp.black_pawn();
    if(wp1!=wp2){r=false;}
    if(bp1!=bp2){r=false;}
  }


  //---------------- castling:   ----------------------
  {
    bp.clear();
    bp.set_piece_on(a1,white_rook_id);
    bp.set_piece_on(h1,white_rook_id);
    bp.set_piece_on(e1,white_king_id);
    bp.set_piece_on(a8,black_rook_id);
    bp.set_piece_on(h8,black_rook_id);
    bp.set_piece_on(e8,black_king_id);

    {
      Move m(e1,h1,castling,WhiteKing(),NoPiece());
      bp.make_move(m);
      if(BitBoard::to_ull(bp.white_king())!=0x40){cout << "castling error1" << endl;r=false;}
      if(BitBoard::to_ull(bp.white_rook())!=0x21){cout << "castling error2" << endl;r=false;}
      bp.unmake_move(m);
      if(BitBoard::to_ull(bp.white_king())!=0x10){cout << "castling error3" << endl;r=false;}
      if(BitBoard::to_ull(bp.white_rook())!=0x81){cout << "castling error4" << endl;r=false;}
    }
    
    {
      Move m(e1,a1,castling,WhiteKing(),NoPiece());
      bp.make_move(m);
      if(BitBoard::to_ull(bp.white_king())!=0x4){r=false;}
      if(BitBoard::to_ull(bp.white_rook())!=0x88){r=false;}
      bp.unmake_move(m);
      if(BitBoard::to_ull(bp.white_king())!=0x10){r=false;}
      if(BitBoard::to_ull(bp.white_rook())!=0x81){r=false;}
    }

    {
      Move m(e8,h8,castling,BlackKing(),NoPiece());
      bp.make_move(m);
      if(BitBoard::to_ull(bp.black_king())!=0x40ull<<56){r=false;}
      if(BitBoard::to_ull(bp.black_rook())!=0x21ull<<56){r=false;}
      bp.unmake_move(m);
      if(BitBoard::to_ull(bp.black_king())!=0x10ull<<56){r=false;}
      if(BitBoard::to_ull(bp.black_rook())!=0x81ull<<56){r=false;}
    }
    
    {
      Move m(e8,a8,castling,BlackKing(),NoPiece());
      bp.make_move(m);
      if(BitBoard::to_ull(bp.black_king())!=0x4ull<<56){r=false;}
      if(BitBoard::to_ull(bp.black_rook())!=0x88ull<<56){r=false;}
      bp.unmake_move(m);
      if(BitBoard::to_ull(bp.black_king())!=0x10ull<<56){r=false;}
      if(BitBoard::to_ull(bp.black_rook())!=0x81ull<<56){r=false;}
    }
    
    
  }

    
  //---------------- Promotion:  ----------------------
  {
    bp.clear();
    bp.set_piece_on(e7,white_pawn_id);
    bp.set_piece_on(d8,black_knight_id);
    bp.set_piece_on(f8,black_knight_id);
    
    {
      Move m(e7,d8,promo_queen,WhitePawn(),BlackKnight());
      bp.make_move(m);
      if(BitBoard::to_ull(bp.black_knight())!=0x20ull<<56){r=false;}
      if(BitBoard::to_ull(bp.white_queen())!=0x8ull<<56){r=false;}
      bp.unmake_move(m);
      if(BitBoard::to_ull(bp.black_knight())!=0x28ull<<56){r=false;}
      if(BitBoard::to_ull(bp.white_pawn())!=0x10ull<<48){r=false;}
    }
    
  }
    
  //---------------- nomove :    ----------------------
  {
    bp.clear();
    if(bp.black_to_move()){r=false;}
    Move m(a1,a1,nullmove,NoPiece(),NoPiece());
    bp.make_move(m);
    if(bp.white_to_move()){r=false;}
    bp.unmake_move(m);
    if(bp.black_to_move()){r=false;}
  }
    
  //---------------- nullmove :  ----------------------
  {
    bp.clear();
    if(bp.black_to_move()){r=false;}
    Move m(a1,a1,nullmove,NoPiece(),NoPiece());
    bp.make_move(m);
    if(bp.white_to_move()){r=false;}    
    bp.unmake_move(m);
    if(bp.black_to_move()){r=false;}    
  }
  */
  
  //---------------- flip board: ----------------------
  {
    bp.clear();
    bp.set_piece_on(h8,black_king_id);
    bp.set_piece_on(b6,white_pawn_id);
    bp.set_piece_on(c6,white_pawn_id);
    bp.set_piece_on(e4,white_knight_id);
    bp.set_piece_on(h1,white_king_id);
    bp.flip();
    if(bp[e5.id()]!=black_knight_id){r=false;}
    if(bp[h8.id()]!=black_king_id){r=false;}
    if(bp[h1.id()]!=white_king_id){r=false;}
  }
    

  if(r){cout << "OK" << endl;}else{cout << "FAIL" << endl;}

}






