/*

Copyright (C) 2018 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#include<iostream>
#include<iomanip>
#include<stdexcept>
#include"../common/rookmask.h"
#include"../common/magicmoves.h"
using std::cout;
using std::endl;
using std::flush;
using std::logic_error;


//-------------------------------------------------------
//
//           unittest magicmoves:
//

void test_magicmoves()
{
  bool r=true;
  cout << "Test MagicMoves ......................................." << flush;

  int magicsize;
  {
    MagicMoves mm;
    magicsize=mm.size();    

    BitBoard bb,moves;
    moves=mm.get_magic_moves<'B'>(d4,bb);
    if(BitBoard::to_ull(moves)!=0x8041221400142241ull){r=false;}

    bb.set_square(f6);
    moves=mm.get_magic_moves<'B'>(d4,bb);
    if(BitBoard::to_ull(moves)!=0x0001221400142241ull){r=false;}

    moves=mm.get_magic_moves<'B'>(b2,bb);
    if(BitBoard::to_ull(moves)!=0x0000201008050005ull){r=false;}

    moves=mm.get_magic_moves<'R'>(d4,bb);
    if(BitBoard::to_ull(moves)!=0x08080808f7080808ull){r=false;}

    moves=mm.get_magic_moves<'R'>(a1,bb);
    if(BitBoard::to_ull(moves)!=0x01010101010101feull){r=false;}

    bb.set_square(d1);
    moves=mm.get_magic_moves<'R'>(a1,bb);
    if(BitBoard::to_ull(moves)!=0x010101010101010eull){r=false;}
  }

  if(r){cout << "OK" << "  magics size: " << magicsize/1024 << "K" << endl;}else{cout << "FAIL" << endl;}
}






