/*

Copyright (C) 2018 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#include<iostream>
#include<iomanip>
#include<stdexcept>
#include"../common/magicnumber.h"
using std::cout;
using std::cerr;
using std::endl;
using std::flush;
using std::logic_error;


//-------------------------------------------------------
//
//           unittest magicnumber:
//

void test_magicnumber()
{
  bool r=true;

  {
    pair<unsigned long long,int> mag;
    MagicNumber mn;
    mag=mn.get_magic_number<'R'>(d4);
    if(mag.first!=657807162307772684ull){r=false;cerr << "rook: " << mag.first << endl;}
    if(mag.second!=54){r=false;cerr << "rook: " << mag.second << endl;}
  }

  {
    pair<unsigned long long,int> mag;
    MagicNumber mn;
    mag=mn.get_magic_number<'B'>(d4);
    if(mag.first!=864972681076818434ull){r=false;cerr << "bishop: " << mag.first << endl;}
    if(mag.second!=54){r=false;cerr << "bishop: " << mag.second << endl;}
  }


  cout << "Test MagicNumber ......................................" << flush;
  if(r){cout << "OK" << endl;}else{cout << "FAIL" << endl;}

}






