/*

Copyright (C) 2018 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#include<iostream>
#include<iomanip>
#include"../board/cposition.h"
#include"../eval/pst.h"
using namespace std;

//-------------------------------------------------------
//
//           unittest piece square tables:
//

void test_pst()
{
  cout << "Test PST .............................................." << flush;
  bool r=true;

  {
    ChessPosition cp;
    string s="7k/8/1PP5/8/4N3/8/8/7K w - - 0 1";
    cp.fen(s);
    PieceSquareTables pst;
    pst.init(cp);
    if(pst.get_pawn_mg()!= 35){r=false;cout << "error(1)    pawn_mg=" << pst.get_pawn_mg() << endl;}
    if(pst.get_knight_mg()!=68){r=false;cout << "error(2)  knight_mg=" << pst.get_knight_mg() << endl;}
    cp.flip();
    pst.init(cp);
    if(pst.get_pawn_mg() != -35){r=false;cout << "error(3)    pawn_mg=" << pst.get_pawn_mg() << endl;}
    if(pst.get_knight_mg()!=-68){r=false;cout << "error(4)  knight_mg=" << pst.get_knight_mg() << endl;}    
  }



  if(r){cout << "OK" << endl;}else{cout << "FAIL" << endl;}
}






