/*

Copyright (C) 2018 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#ifndef BKMOVE_H
#define BKMOVE_H

#include"../common/square.h"
#include"../movegen/move.h"
#include"../board/cposition.h"


class BKmove
{
 private:
  unsigned short int m;                // promotion (4 bits), from (6 bits), to (6 bits) ;

 public:
  BKmove();
  BKmove(const Move&);
  BKmove(const BKmove&)=default;
  Move operator()(const ChessPosition&)const;
  bool nomove()const;
  void clear();
  Square from()const;
  Square to()const;
  char code()const;
  void set_from(Square);
  void set_to(Square);
  void set_code(char);
  unsigned short int dump()const;
};



#endif
