/*

Copyright (C) 2018 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#ifndef BKRECORD_H
#define BKRECORD_H



#include"bkmove.h"


class Book_record
{
 private:
  unsigned char key[8];
  unsigned char move[2];
  unsigned char weight[2];
  unsigned char learn[4];

 public:
  Book_record();
  Book_record(char*);
  bool operator==(const Book_record&)const;
  bool operator<(const Book_record&)const;
  bool operator>(const Book_record&)const;
  bool operator<=(const Book_record&)const;
  bool operator>=(const Book_record&)const;
  void set_key(uint64_t);
  void set_move(const BKmove&);
  void set_weight(uint16_t);
  void set_learn(uint32_t);
  uint64_t get_key()const;
  BKmove get_move()const;
  uint16_t get_weight()const;
  uint32_t get_learn()const;
};

#endif
