/*

Copyright (C) 2018 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#include"bishopmask.h"
#include"prebb.h"

const array<BitBoard,64> BishopMask::bm=[]()->const array<BitBoard,64>
{
  array<BitBoard,64> r;
  BitBoard temp_bb;
  for(Square s=a1;s<=h8;s++){

    temp_bb.clear();
    temp_bb.set_square(s);
    for(int i=1;i<7;i++)
      {
	temp_bb|=temp_bb<<7 & not_h_file;
      }
    r[s.id()]|=temp_bb;

    temp_bb.clear();
    temp_bb.set_square(s);
    for(int i=1;i<7;i++)
      {
	temp_bb|=temp_bb<<9 & not_a_file;
      }
    r[s.id()]|=temp_bb;

    temp_bb.clear();
    temp_bb.set_square(s);
    for(int i=1;i<7;i++)
      {
	temp_bb|=temp_bb>>9 & not_h_file;
      }
    r[s.id()]|=temp_bb;

    temp_bb.clear();
    temp_bb.set_square(s);
    for(int i=1;i<7;i++)
      {
	temp_bb|=temp_bb>>7 & not_a_file;
      }
    r[s.id()]|=temp_bb;
    r[s.id()]&=~border;
    r[s.id()].reset_square(s);
  }
  return r;
}();


const BitBoard& BishopMask::get_mask(Square s)const
{
  return bm[s.id()];
}


