/*

Copyright (C) 2018 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#ifndef MAGICNUMBER_H
#define MAGICNUMBER_H

#include"square.h"
#include<vector>
#include<utility>
using std::pair;
using std::vector;

class MagicNumber
{
 private:
  static const vector<pair<unsigned long long,int>> bishop_magic;
  static const vector<pair<unsigned long long,int>> rook_magic;

 public:
  template<char> const pair<unsigned long long,int>& get_magic_number(const Square&)const;
};



template<char C>
const pair<unsigned long long,int>& MagicNumber::get_magic_number(const Square& s)const
{
  return C=='R'?rook_magic[s.id()]:bishop_magic[s.id()];
}


#endif
