/*

Copyright (C) 2018 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#ifndef MATERIAL_H
#define MATERIAL_H

#include"materialindex.h"
#include<utility>
using std::pair;
using std::vector;

constexpr int number_of_entries{1<<13};

class Material
{
 private:
  array<pair<uint64_t,int>,number_of_entries> m_material;
  
 public:
  Material();
  int get_eval(const MaterialIndex&);
  string dump()const;
};


#endif
