/*

Copyright (C) 2018 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#ifndef PST_H
#define PST_H

#include"../movegen/move.h"
#include<array>
using std::array;




class ChessPosition;

class PieceSquareTables
{
 public:
  PieceSquareTables();
  void init(const ChessPosition&);
  void make_move(const Move&);
  void unmake_move(const Move&);
  int get_pawn_mg()const;
  int get_pawn_eg()const;
  int get_knight_mg()const;
  int get_knight_eg()const;
  int get_bishop_mg()const;
  int get_bishop_eg()const;
  int get_rook_mg()const;
  int get_rook_eg()const;
  int get_queen_mg()const;
  int get_queen_eg()const;
  int get_king_mg()const;
  int get_king_eg()const;

 private:
  const ChessPosition* pcp;
  array<int,15> m_score_mg,m_score_eg;
  array<array<int,64>,15> pst_mg,pst_eg;

  static const array<int,64> pawn_mg,knight_mg,bishop_mg,rook_mg,queen_mg,king_mg;
  static const array<int,64> pawn_eg,knight_eg,bishop_eg,rook_eg,queen_eg,king_eg;
};


#endif
