/*

Copyright (C) 2018 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#ifndef WEIGHTS_H
#define WEIGHTS_H
#include<vector>
#include<string>
using std::vector;
using std::string;


enum
  {
    w_material,
    w_mobility,
    w_development,
    w_pst_pawn_mg,
    w_pst_pawn_eg,
    w_pst_knight_mg,
    w_pst_knight_eg,
    w_pst_bishop_mg,
    w_pst_bishop_eg,
    w_pst_rook_mg,
    w_pst_rook_eg,
    w_pst_queen_mg,
    w_pst_queen_eg,
    w_pst_king_mg,
    w_pst_king_eg,
    w_king_safety,
    w_king_activity,
    w_undefended_pieces,
    w_hanging_pieces,
    w_rookpawn,
    w_doubled_pawns,
    w_weak_pawns,
    w_isolated_pawns,
    w_blocked_pawns,
    w_passed_pawns,
    w_pawn_islands,
    w_pinned_pieces,
    w_bad_bishop,
    w_opposite_colored_bishops,
    w_stm
  };


class Weight
{
 public:
  float& mg(int i){return m_weight_mg[i];};
  float& eg(int i){return m_weight_eg[i];};
  vector<float>& weight_mg_vector(){return m_weight_mg;};
  vector<float>& weight_eg_vector(){return m_weight_eg;};
  unsigned size()const{return m_weight_mg.size();}
  
 private:
  vector<float> m_weight_mg{1.30363,0.612495,0.890153,0.155749,0.0882316,0.161098,0.0391935,0.0144269,0.686019,0.298932,
      0.23049,0.270484,0.437129,0.298932,0.829024,1.27601,0.473845,1.89847,37.4125,1.98441,
      20.4012,10.5494,7.43749,15.1052,2.2819,1.16594,23.679,0.386207,0,10};
  vector<float> m_weight_eg{1.27721,0.564299,1.20667,0.00620673,0.508402,0.0843491,0.00577419,0.0181719,0.0287135,0.23049,
      0.221452,0.437129,0.23049,0.221452,0.32383,0.964579,5.44392,0.266066,35.7356,0.12052,
      5.79934,0.305116,1.50198,10.809,2.54398,0.0601789,39.272,0.0541632,0,10};
};



#endif
