/*

Copyright (C) 2018 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#ifndef PAWNHASHTABLE_H
#define PAWNHASHTABLE_H

#include<vector>
#include<string>
#include<utility>
#include"phtrecord.h"
using std::string;
using std::vector;
using std::pair;


class PawnHashTable
{
 private:
  unsigned int number_of_entries;
  PHTrecord phtr;
  PHTrecord* pht;
  
  //---------------------- stats: ---------------------------------------
  uint64_t m_first_pht_read{0};
  uint64_t m_conflicting_pht_read{0};
  uint64_t m_total_read_count{0};
  //---------------------------------------------------------------------
  


 public:
  PawnHashTable();
  ~PawnHashTable();
  
  void clear();
  const PHTrecord& get_current()const;
  void set_current(PHTrecord);
  bool read(uint32_t);
  void write();
  string stats();
};


#endif
