/*

Copyright (C) 2018 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#ifndef TTRECORD_H
#define TTRECORD_H

#include"ttmove.h"


enum bound_t{upperbound,lowerbound,exact_value};


class TTrecord
{
 private:
  uint64_t key;
  TTmove move;
  int16_t score;
  unsigned char bound;
  unsigned char sd;                 // search_depth;
  unsigned char date;               // date;

 public:
  TTrecord();
  bool operator==(const TTrecord&);
  bool operator!=(const TTrecord&);
  void clear();
  const uint64_t& get_key()const;
  void set_key(const uint64_t&);
  const TTmove& get_move()const;
  void set_move(const TTmove&);
  int get_score(const int&)const;
  void set_score(const int&,const int&);
  bool is_exact_value()const;
  bool is_upperbound()const;
  bool is_lowerbound()const;
  void set_bound(bound_t);
  const unsigned char& get_draft()const;
  void set_draft(const unsigned char&);
  const unsigned char& get_date()const;
  void set_date(const unsigned char&);
};


#endif
