/*

Copyright (C) 2018 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#ifndef XMOVELIST_H
#define XMOVELIST_H

#include<array>
#include"mlist.h"
#include"../common/numerals.h"
using std::array;

class XMoveList
{
 private:
  Move m_vm[max_search_depth*100];
  Move* m_pvm{m_vm};

  array<MList,max_search_depth> m_ml;
  int m_current{0};

  
 public:
  XMoveList();
  void clear_all();
  int current()const{return m_current;}
  void increment();
  void decrement();

  //---------------------------------------------------------------------------
  Move& operator[](int);
  void set_chessposition(ChessPosition&);
  void set_analysis(Analysis*);
  void set_searchmoves(const vector<Move>&);
  void set_hashtable_move(const Move&);
  void set_killers(const Move&,const Move&);
  void set_killers_2(const Move&,const Move&);
  void set_xcodes();
  void sort();
  void add(const Move&);
  void remove(const Move&);
  void clear();
  void set_log(bool);
  const Move& first();
  const Move& next();
  Move& back();
  void insert(vector<Move>::iterator,vector<Move>::iterator);
  void pop_back();
  void push_back(const Move&);
  unsigned int size()const;
  string dump()const;
  //---------------------------------------------------------------------------
  
};

#endif
