/*

Copyright (C) 2018 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#ifndef COUNTERMOVE_H
#define COUNTERMOVE_H

#include"history.h"


using cm_array=array<array<HistoryTable,64>,15>;

class CounterMove
{
 private:
  cm_array* m_pcm;

 public:
  CounterMove();
  ~CounterMove();
  void clear();
  void increment(const Move&,const Move&,int);
  void decrement(const Move&,const Move&,int);
  const long long& value(const Move&,const Move&)const;
  const long long& value(const int&,const int&,const Move&)const;
};

#endif
