/*

Copyright (C) 2018 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#ifndef DURATION_H
#define DURATION_H

#include<ratio>
#include<chrono>


class Duration
{
 private:
  std::chrono::duration<double,std::ratio<1>> m_d;

 public:
  Duration()=default;
  Duration(const Duration&);
  Duration(const std::chrono::duration<double,std::ratio<1>>&);
  Duration& operator=(const Duration&);
  Duration& operator-=(const Duration&);
  Duration& operator+=(const Duration&);
  bool operator==(const Duration&)const;
  bool operator!=(const Duration&)const;
  long long nanoseconds()const;
  long long microseconds()const;
  long long milliseconds()const;
  long long centiseconds()const;
  long long minutes()const;
  long long seconds()const;
  void nanoseconds(long long);
  void milliseconds(long long);
  void centiseconds(long long);
  void minutes(long long);
  void seconds(float);
};

Duration operator-(Duration x,Duration y);
Duration operator+(Duration x,Duration y);

#endif
