/*

Copyright (C) 2018 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#ifndef TIMER_H
#define TIMER_H

#include<ratio>
#include<chrono>
#include"duration.h"
using std::nano;
using namespace std::chrono;


class Timer
{
 private:
  time_point<high_resolution_clock> m_t0;
  duration<double,nano> m_total_time;
  long long m_counter;
  bool m_stopped;

 public:
  Timer();
  void start();
  void stop();
  void reset();
  Duration total_time();
  Duration average_time()const;
  Duration running_time()const;
};


#endif
