/*

Copyright (C) 2018 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#ifndef GTKMM_BOARD_H
#define GTKMM_BOARD_H


#include"drawing.h"
#include<vector>
#include<utility>
#include<gtkmm/eventbox.h>
#include<gtkmm/window.h>
#include<gdkmm/pixbuf.h>
using std::vector;
using std::pair;


class Board : public Gtk::EventBox
{
 public:
  Board();
  virtual ~Board();
  sigc::signal<bool> signal_piece_moved;

  void set_parent_window(Gtk::Window*);
  void initialize(const vector<char>&);
  pair<int,int> get_move()const;
  void set_piece_on(char,int);
  void remove_piece_from(int);
  void flip();
  vector<Glib::RefPtr<Gdk::Pixbuf>> get_images()const;


 protected:
  virtual bool on_eventbox_button_press(GdkEventButton*);
  virtual bool on_eventbox_button_release(GdkEventButton*);
  virtual bool on_eventbox_motion_notify(GdkEventMotion*);
 
 private:
  bool m_flip;
  Drawing m_drawing;
  pair<int,int> m_move;
};



#endif // GTKMM_BOARD_H

