/*

Copyright (C) 2018 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#ifndef CECP_ENGINE_H
#define CECP_ENGINE_H

#include"../engine/board/cposition.h"
#include"level.h"
#include"guiengine.h"


class CecpEngine : public GuiEngine
{
 private:
  ChessPosition cecp_cp;
  Level m_level;
  bool m_forced{false};
  bool m_ping{false};
  int m_pingpong_number{0};
  string castle2move(string)const;
  
 public:
  CecpEngine();
  virtual ~CecpEngine();
  void newgame() override;
  void set_ponder(bool) override;
  void go() override;
  void go_infinite() override;
  void stop() override;
  string get_answer() override;
};


#endif
