/*

Copyright (C) 2018 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#ifndef GTKMM_CLOCKS_H
#define GTKMM_CLOCKS_H


#include<gdkmm/rgba.h>
#include<gtkmm/box.h>
#include<gtkmm/entry.h>
#include<string>
#include"../engine/search/timer.h"
using std::string;


class Clocks : public Gtk::Box
{
 public:
  Clocks();
  virtual ~Clocks();

  void reset();
  void set_white_to_move();
  void set_black_to_move();
  void set_white_clock(int);
  void set_black_clock(int);
  void start_white_clock();
  void start_black_clock();
  void stop_clocks();
  void update_clock_images();
  void set_level(int,string,float);

 private:
  Gtk::Label m_label_white;
  Gtk::Label m_label_black;
  Gtk::Label m_white_clock;
  Gtk::Label m_black_clock;
  Gdk::RGBA m_white;
  Gdk::RGBA m_green;
  Gdk::RGBA m_grey;

  Timer tim_white,tim_black;
  int m_white_centiseconds;
  int m_black_centiseconds;
  
  string m_white_time;
  string m_black_time;
  
  int m_white_steady_time{0};
  int m_black_steady_time{0};

  bool white_to_move;
  bool black_to_move;

  //----- level: --------------------
  int m_mps;
  int m_base;
  float m_inc;
  int m_white_moves,m_black_moves;
  //---------------------------------
};



#endif //GTKMM_CLOCKS_H
