/*

Copyright (C) 2018 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#include"commenteditor.h"
#include<iostream>


CommentEditor::CommentEditor()
{
  set_title("Comment");
  set_border_width(5);
  set_default_size(300, 150);
  add(m_ScrolledWindow);
  
  m_textview.set_editable(true);
  m_textview.set_cursor_visible(true);
  m_textview.set_wrap_mode(Gtk::WRAP_CHAR);
  m_ScrolledWindow.set_policy(Gtk::POLICY_NEVER, Gtk::POLICY_AUTOMATIC);
  m_ScrolledWindow.add(m_textview);

  m_textbuffer = m_textview.get_buffer();

  show_all_children();
};

CommentEditor::~CommentEditor()
{
};

void CommentEditor::set_text(string x)
{
  m_textbuffer->set_text(x);
}

string CommentEditor::get_text()
{
  Glib::ustring ux;
  ux=m_textbuffer->get_text();
  return static_cast<string>(ux);
}
