/*

Copyright (C) 2018 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#include"promochoicedialog.h"
#include<iostream>
using std::cout;
using std::endl;


PromoChoiceDialog::PromoChoiceDialog(Gtk::Window* ppw,
				     const Glib::RefPtr<Gdk::Pixbuf>& queen,
				     const Glib::RefPtr<Gdk::Pixbuf>& rook,
				     const Glib::RefPtr<Gdk::Pixbuf>& bishop,
				     const Glib::RefPtr<Gdk::Pixbuf>& knight) :
  m_event{PromoChoiceEvent(queen,rook,bishop,knight)}
{
  set_transient_for(*ppw);
  m_event.signal_choice_made.connect(sigc::mem_fun(*this,&PromoChoiceDialog::on_choice_made));
  m_event.show();
  m_content_box=get_content_area();
  m_content_box->pack_start(m_event);
  show();
  run();
}


PromoChoiceDialog::~PromoChoiceDialog()
{
}

int PromoChoiceDialog::get_choice()
{
  return m_choice;
}

bool PromoChoiceDialog::on_choice_made()
{
  m_choice=m_event.get_choice();
  response(m_choice);
  return true;
}
