/*

Copyright (C) 2018 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#include"ecocodes.h"
#include<cstdint>
#include<array>
#include<tuple>




array<tuple<uint64_t,string,string,string>,2014> EcoCodes::ecocodes{
tuple<uint64_t,string,string,string>{0xeccee3b4b02790b8,"A00","Polish (Sokolsky) opening",""},
tuple<uint64_t,string,string,string>{0x6d427c500aa5fdc1,"A00","Polish","Tuebingen variation"},
tuple<uint64_t,string,string,string>{0x7eb40e5bc7e74303,"A00","Polish","Outflank variation"},
tuple<uint64_t,string,string,string>{0x6add2d59f64624a4,"A00","Benko's opening",""},
tuple<uint64_t,string,string,string>{0x7783b322f16685d3,"A00","Lasker simul special",""},
tuple<uint64_t,string,string,string>{0x3bc1c9e50d45bdaf,"A00","Benko's opening","reversed Alekhine"},
tuple<uint64_t,string,string,string>{0xe57697cefee41181,"A00","Grob's attack",""},
tuple<uint64_t,string,string,string>{0xfc75c0c3a0d3eb8,"A00","Grob","spike attack"},
tuple<uint64_t,string,string,string>{0xa41b35ffd3ba36e3,"A00","Grob","Fritz gambit"},
tuple<uint64_t,string,string,string>{0x46765f911f851c04,"A00","Grob","Romford counter-gambit"},
tuple<uint64_t,string,string,string>{0xaec84ba6d432356e,"A00","Clemenz (Mead's, Basman's or de Klerk's) opening",""},
tuple<uint64_t,string,string,string>{0xef2c72ca0e9b4318,"A00","Global opening",""},
tuple<uint64_t,string,string,string>{0x2df54c975eb48346,"A00","Amar (Paris) opening",""},
tuple<uint64_t,string,string,string>{0xa9157a831899c583,"A00","Amar gambit",""},
tuple<uint64_t,string,string,string>{0xbdac8ebad4737e45,"A00","Dunst (Sleipner, Heinrichsen) opening",""},
tuple<uint64_t,string,string,string>{0x37d486f047968673,"A00","Dunst (Sleipner, Heinrichsen) opening",""},
tuple<uint64_t,string,string,string>{0xfc48b7d60eda0833,"A00","Battambang opening",""},
tuple<uint64_t,string,string,string>{0x77096d4f3ea595f,"A00","Novosibirsk opening",""},
tuple<uint64_t,string,string,string>{0x8da7a73e5fdd72dc,"A00","Anderssen's opening",""},
tuple<uint64_t,string,string,string>{0x2df2e8f47b022952,"A00","Ware (Meadow Hay) opening",""},
tuple<uint64_t,string,string,string>{0x3b297c9743d8a81a,"A00","Crab opening",""},
tuple<uint64_t,string,string,string>{0x30e16e80c6e1f31a,"A00","Saragossa opening",""},
tuple<uint64_t,string,string,string>{0xe89f55cd52014748,"A00","Mieses opening",""},
tuple<uint64_t,string,string,string>{0x62e75d87c1e4bf7e,"A00","Mieses opening",""},
tuple<uint64_t,string,string,string>{0x3b89e5e55b19174e,"A00","Valencia opening",""},
tuple<uint64_t,string,string,string>{0x7272ff629ee2b3d7,"A00","Venezolana opening",""},
tuple<uint64_t,string,string,string>{0xeb16d4aa32ce7438,"A00","Van't Kruijs opening",""},
tuple<uint64_t,string,string,string>{0x53c5414494586345,"A00","Amsterdam attack",""},
tuple<uint64_t,string,string,string>{0x288a7029b65b13ed,"A00","Gedult's opening",""},
tuple<uint64_t,string,string,string>{0xdadfba6dd24e067e,"A00","Hammerschlag (Fried fox/Pork chop opening)",""},
tuple<uint64_t,string,string,string>{0xda980a31bdae85e2,"A00","Anti-Borg (Desprez) opening",""},
tuple<uint64_t,string,string,string>{0x41dd464bfbc3d352,"A00","Durkin's attack",""},
tuple<uint64_t,string,string,string>{0xca9df64ccc1c97f1,"A01","Nimzovich-Larsen attack",""},
tuple<uint64_t,string,string,string>{0x40e5fe065ff96fc7,"A01","Nimzovich-Larsen attack","modern variation"},
tuple<uint64_t,string,string,string>{0x9173c2b961e6d667,"A01","Nimzovich-Larsen attack","Indian variation"},
tuple<uint64_t,string,string,string>{0x4ff7d45850c8d9d7,"A01","Nimzovich-Larsen attack","classical variation"},
tuple<uint64_t,string,string,string>{0x2cec27e2335b9c8c,"A01","Nimzovich-Larsen attack","English variation"},
tuple<uint64_t,string,string,string>{0x5ef290d57294ba2f,"A01","Nimzovich-Larsen attack","Dutch variation"},
tuple<uint64_t,string,string,string>{0xaa999c5957b12acc,"A01","Nimzovich-Larsen attack","Polish variation"},
tuple<uint64_t,string,string,string>{0xa1f4bf5c329f206a,"A01","Nimzovich-Larsen attack","symmetrical variation"},
tuple<uint64_t,string,string,string>{0xbb2deb150f00c115,"A02","Bird's opening",""},
tuple<uint64_t,string,string,string>{0x3155e35f9ce53923,"A02","Bird","From gambit"},
tuple<uint64_t,string,string,string>{0x225127ef4f644580,"A02","Bird","From gambit, Lasker variation"},
tuple<uint64_t,string,string,string>{0xe6ab677c709bfa31,"A02","Bird","From gambit, Lipke variation"},
tuple<uint64_t,string,string,string>{0x2a62054399b44058,"A02","Bird's opening, Swiss gambit",""},
tuple<uint64_t,string,string,string>{0x3b6e1bc89bb43e9f,"A02","Bird","Hobbs gambit"},
tuple<uint64_t,string,string,string>{0x3e47c90193d48f33,"A03","Bird's opening",""},
tuple<uint64_t,string,string,string>{0xb2645625d0db2434,"A03","Mujannah opening",""},
tuple<uint64_t,string,string,string>{0xfa40c44978543239,"A03","Bird's opening","Williams gambit"},
tuple<uint64_t,string,string,string>{0xf591821e8dd02c41,"A03","Bird's opening","Lasker variation"},
tuple<uint64_t,string,string,string>{0x9d5f7aee7e779da1,"A04","Reti opening",""},
tuple<uint64_t,string,string,string>{0x9301c77c0ffb07f,"A04","Reti v Dutch",""},
tuple<uint64_t,string,string,string>{0xcd37113f2b7f0d75,"A04","Reti","Pirc-Lisitsin gambit"},
tuple<uint64_t,string,string,string>{0x387de61fc215f737,"A04","Reti","Lisitsin gambit deferred"},
tuple<uint64_t,string,string,string>{0xa4e5ec8fac0fd4cc,"A04","Reti opening",""},
tuple<uint64_t,string,string,string>{0x62312bf5000a672c,"A04","Reti","Wade defence"},
tuple<uint64_t,string,string,string>{0x1d1c8a33eac3622b,"A04","Reti","Herrstroem gambit"},
tuple<uint64_t,string,string,string>{0xc6b14e1bd38ddc37,"A05","Reti opening",""},
tuple<uint64_t,string,string,string>{0x8a539f4fa8f7b932,"A05","Reti","King's Indian attack, Spassky's variation"},
tuple<uint64_t,string,string,string>{0x3e3a60148d59644,"A05","Reti","King's Indian attack"},
tuple<uint64_t,string,string,string>{0xa916d3adee63fa60,"A05","Reti","King's Indian attack, Reti-Smyslov variation"},
tuple<uint64_t,string,string,string>{0x183558fae2a3d387,"A06","Reti opening",""},
tuple<uint64_t,string,string,string>{0xb6919b2fa6336853,"A06","Reti","old Indian attack"},
tuple<uint64_t,string,string,string>{0xb2c02d564415bfa3,"A06","Santasiere's folly",""},
tuple<uint64_t,string,string,string>{0xdc3255b209236e8d,"A06","Tennison (Lemberg, Zukertort) gambit",""},
tuple<uint64_t,string,string,string>{0x949338ae382eb8ea,"A06","Reti","Nimzovich-Larsen attack"},
tuple<uint64_t,string,string,string>{0x34d3e3bb02740bbf,"A07","Reti","King's Indian attack (Barcza system)"},
tuple<uint64_t,string,string,string>{0x3411a8daaed59411,"A07","Reti","King's Indian attack, Yugoslav variation"},
tuple<uint64_t,string,string,string>{0xb01371a9e8b430e0,"A07","Reti","King's Indian attack, Keres variation"},
tuple<uint64_t,string,string,string>{0xdd67b0e079fb99f4,"A07","Reti","King's Indian attack"},
tuple<uint64_t,string,string,string>{0xbccda23ddf5e9968,"A07","Reti","King's Indian attack, Pachman system"},
tuple<uint64_t,string,string,string>{0xd2a23215fd3300c2,"A07","Reti","King's Indian attack (with ...c5)"},
tuple<uint64_t,string,string,string>{0x67521168b0ded8bb,"A08","Reti","King's Indian attack"},
tuple<uint64_t,string,string,string>{0x364e9256c5d337ec,"A08","Reti","King's Indian attack, French variation"},
tuple<uint64_t,string,string,string>{0x9416c7dea1ac7880,"A09","Reti opening",""},
tuple<uint64_t,string,string,string>{0x767badb06d935267,"A09","Reti","advance variation"},
tuple<uint64_t,string,string,string>{0x4610feecf3929663,"A09","Reti accepted",""},
tuple<uint64_t,string,string,string>{0xbf852e8a9f7865cf,"A09","Reti accepted","Keres variation"},
tuple<uint64_t,string,string,string>{0xca18093c559e579b,"A10","English opening",""},
tuple<uint64_t,string,string,string>{0x23ac5a672e11c5d0,"A10","English opening",""},
tuple<uint64_t,string,string,string>{0x6dd35f65567480ec,"A10","English","Adorjan defence"},
tuple<uint64_t,string,string,string>{0xaa1c6329ce33eaa6,"A10","English","Jaenisch gambit"},
tuple<uint64_t,string,string,string>{0x5e776fa5eb167a45,"A10","English","Anglo-Dutch defense"},
tuple<uint64_t,string,string,string>{0x5862e4d3225e8420,"A11","English","Caro-Kann defensive system"},
tuple<uint64_t,string,string,string>{0x8aca4a650ce1c056,"A12","English","Caro-Kann defensive system"},
tuple<uint64_t,string,string,string>{0xff110fe306495712,"A12","English","Torre defensive system"},
tuple<uint64_t,string,string,string>{0x7edbac5ff6295075,"A12","English","London defensive system"},
tuple<uint64_t,string,string,string>{0x115894956c871d2f,"A12","English","Caro-Kann defensive system"},
tuple<uint64_t,string,string,string>{0xf8ecc7ce17088f64,"A12","English","Bled variation"},
tuple<uint64_t,string,string,string>{0x9241fd1bdb6214a2,"A12","English","New York (London) defensive system"},
tuple<uint64_t,string,string,string>{0x138b5ea72b0213c5,"A12","English","Capablanca's variation"},
tuple<uint64_t,string,string,string>{0x881980574b64cebc,"A12","English","Caro-Kann defensive system, Bogolyubov variation"},
tuple<uint64_t,string,string,string>{0xbc6ffb0d4dbcc7c9,"A13","English opening",""},
tuple<uint64_t,string,string,string>{0x170020d45917a2c2,"A13","English","Romanishin gambit"},
tuple<uint64_t,string,string,string>{0xe26135efb98ee8d2,"A13","English opening","Agincourt variation"},
tuple<uint64_t,string,string,string>{0xbe091857d87ddd1f,"A13","English","Wimpey system"},
tuple<uint64_t,string,string,string>{0xce878eae595930ea,"A13","English opening","Agincourt variation"},
tuple<uint64_t,string,string,string>{0x5cfd63412e99e351,"A13","English","Kurajica defence"},
tuple<uint64_t,string,string,string>{0x9569ba5bf4a3717c,"A13","English","Neo-Catalan"},
tuple<uint64_t,string,string,string>{0xf29fa014eb7047e6,"A13","English","Neo-Catalan accepted"},
tuple<uint64_t,string,string,string>{0x4a2091fd0f16de84,"A14","English","Neo-Catalan declined"},
tuple<uint64_t,string,string,string>{0x6def61933e09fb62,"A14","English","Symmetrical, Keres defence"},
tuple<uint64_t,string,string,string>{0x91f63dc9f864160d,"A15","English, 1...Nf6 (Anglo-Indian defense)",""},
tuple<uint64_t,string,string,string>{0x3b0348655ed27a29,"A15","English orang-utan",""},
tuple<uint64_t,string,string,string>{0x4a92d13f90827730,"A15","English opening",""},
tuple<uint64_t,string,string,string>{0x6a61256b3a8694d4,"A16","English opening",""},
tuple<uint64_t,string,string,string>{0xef0b077fa652daf2,"A16","English","Anglo-Gruenfeld defense"},
tuple<uint64_t,string,string,string>{0x42fc0368f6494ffb,"A16","English","Anglo-Gruenfeld, Smyslov defense"},
tuple<uint64_t,string,string,string>{0x27f6a29775892af7,"A16","English","Anglo-Gruenfeld, Czech defense"},
tuple<uint64_t,string,string,string>{0xa5ab0a09d39fb28e,"A16","English","Anglo-Gruenfeld defense"},
tuple<uint64_t,string,string,string>{0xefcdf4926d881318,"A16","English","Anglo-Gruenfeld defense, Korchnoi variation"},
tuple<uint64_t,string,string,string>{0x1c16d75a22a40486,"A17","English opening",""},
tuple<uint64_t,string,string,string>{0xac1b72bcb4c1d220,"A17","English","Queens Indian formation"},
tuple<uint64_t,string,string,string>{0x8d8196d2149302c2,"A17","English","Queens Indian, Romanishin variation"},
tuple<uint64_t,string,string,string>{0xe3352aa01b5ad99,"A17","English","Nimzo-English opening"},
tuple<uint64_t,string,string,string>{0xd811da12c924b98c,"A18","English","Mikenas-Carls variation"},
tuple<uint64_t,string,string,string>{0x3c02eefb51eed1ce,"A18","English","Mikenas-Carls, Flohr variation"},
tuple<uint64_t,string,string,string>{0x73fc02f0d8b51c8f,"A18","English","Mikenas-Carls, Kevitz variation"},
tuple<uint64_t,string,string,string>{0x3e600bbc3663b2f1,"A19","English","Mikenas-Carls, Sicilian variation"},
tuple<uint64_t,string,string,string>{0x40600176c67bafad,"A20","English opening",""},
tuple<uint64_t,string,string,string>{0x9b04ed80ae9dce90,"A20","English, Nimzovich variation",""},
tuple<uint64_t,string,string,string>{0xb402d0ee9c981166,"A20","English, Nimzovich, Flohr variation",""},
tuple<uint64_t,string,string,string>{0xbbf719d404992d74,"A21","English opening",""},
tuple<uint64_t,string,string,string>{0xe40e5dbf22ffba53,"A21","English, Troeger defence",""},
tuple<uint64_t,string,string,string>{0x3cd1d91b41f66f9a,"A21","English, Keres variation",""},
tuple<uint64_t,string,string,string>{0x59296343be070524,"A21","English opening",""},
tuple<uint64_t,string,string,string>{0x5bfaa971f9820bce,"A21","English, Smyslov defence",""},
tuple<uint64_t,string,string,string>{0x72b670d24f6ee556,"A21","English, Kramnik-Shirov counterattack",""},
tuple<uint64_t,string,string,string>{0xe0192d21a9636ce2,"A22","English opening",""},
tuple<uint64_t,string,string,string>{0x22ad7779c1e197b0,"A22","English","Bellon gambit"},
tuple<uint64_t,string,string,string>{0xccff966049b4b4da,"A22","English","Carls' Bremen system"},
tuple<uint64_t,string,string,string>{0x4995b474d560fafc,"A22","English","Bremen, reverse dragon"},
tuple<uint64_t,string,string,string>{0x5beff6602437cf8,"A22","English","Bremen, Smyslov system"},
tuple<uint64_t,string,string,string>{0x5e857b8f3e746761,"A23","English","Bremen system, Keres variation"},
tuple<uint64_t,string,string,string>{0x254bc53b323b2691,"A24","English","Bremen system with ...g6"},
tuple<uint64_t,string,string,string>{0x101ac13615088877,"A25","English","Sicilian reversed"},
tuple<uint64_t,string,string,string>{0xd00437e738fad1d7,"A25","English","closed system"},
tuple<uint64_t,string,string,string>{0xd1bb971f5c747099,"A25","English","closed, Taimanov variation"},
tuple<uint64_t,string,string,string>{0x48f9a2fae4366e8,"A25","English","closed, Hort variation"},
tuple<uint64_t,string,string,string>{0x8357117ffecd14c3,"A25","English","closed, 5.Rb1"},
tuple<uint64_t,string,string,string>{0x2db8e9b444f79ba,"A25","English","closed, 5.Rb1 Taimanov variation"},
tuple<uint64_t,string,string,string>{0x7ea0f4327c6a6a03,"A25","English","closed system (without ...d6)"},
tuple<uint64_t,string,string,string>{0x471a6253ae12236e,"A26","English","closed system"},
tuple<uint64_t,string,string,string>{0x831d6f1b45929e64,"A26","English","Botvinnik system"},
tuple<uint64_t,string,string,string>{0xcb7e2dc07deee94a,"A27","English","three knights system"},
tuple<uint64_t,string,string,string>{0x90901935d014a8dc,"A28","English","four knights system"},
tuple<uint64_t,string,string,string>{0xf49d70a9f48beceb,"A28","English","Nenarokov variation"},
tuple<uint64_t,string,string,string>{0x7aa30bf1f3d85a68,"A28","English","Bradley Beach variation"},
tuple<uint64_t,string,string,string>{0x5497147d3b9415d6,"A28","English","four knights, Nimzovich variation"},
tuple<uint64_t,string,string,string>{0x5b0c28139958269c,"A28","English","four knights, Marini variation"},
tuple<uint64_t,string,string,string>{0x3e34dae094841308,"A28","English","four knights, Capablanca variation"},
tuple<uint64_t,string,string,string>{0x3dbd5b87f44b2078,"A28","English","four knights, 4.e3"},
tuple<uint64_t,string,string,string>{0xfb2de157c006c56c,"A28","English","four knights, Stean variation"},
tuple<uint64_t,string,string,string>{0x64dc3b9ab0d28634,"A28","English","four knights, Romanishin variation"},
tuple<uint64_t,string,string,string>{0xbc76a27430c370e4,"A29","English","four knights, kingside fianchetto"},
tuple<uint64_t,string,string,string>{0x2c69d892aad95ce6,"A30","English","symmetrical variation"},
tuple<uint64_t,string,string,string>{0x9557b7122b60106,"A30","English","symmetrical, hedgehog system"},
tuple<uint64_t,string,string,string>{0x57e3b574edd26ba0,"A30","English","symmetrical, hedgehog, flexible formation"},
tuple<uint64_t,string,string,string>{0x69d62f3b7e0c510f,"A31","English","symmetrical, Benoni formation"},
tuple<uint64_t,string,string,string>{0x272b3a620aeb3ab5,"A32","English","symmetrical variation"},
tuple<uint64_t,string,string,string>{0x7751fa22d9981d6f,"A33","English","symmetrical variation"},
tuple<uint64_t,string,string,string>{0x9c48bf34f304138d,"A33","English","symmetrical, Geller variation"},
tuple<uint64_t,string,string,string>{0xd7fec030683bde3f,"A34","English","symmetrical variation"},
tuple<uint64_t,string,string,string>{0x43dadba72cd8b9f3,"A34","English","symmetrical, three knights system"},
tuple<uint64_t,string,string,string>{0xa0f64f8425164791,"A34","English","symmetrical variation"},
tuple<uint64_t,string,string,string>{0xe3bf8d51bf599856,"A34","English","symmetrical, Rubinstein system"},
tuple<uint64_t,string,string,string>{0x7c1318d279aa7b3c,"A35","English","symmetrical variation"},
tuple<uint64_t,string,string,string>{0xfc99c0d1bcb65b97,"A35","English","symmetrical, four knights system"},
tuple<uint64_t,string,string,string>{0x50f5a393997da304,"A36","English","symmetrical variation"},
tuple<uint64_t,string,string,string>{0xbc0dee035458229c,"A36","English","ultra-symmetrical variation"},
tuple<uint64_t,string,string,string>{0x9b58a4fbe3e2520e,"A36","English","symmetrical, Botvinnik system reversed"},
tuple<uint64_t,string,string,string>{0x780ae34bbfd89f96,"A36","English","symmetrical, Botvinnik system"},
tuple<uint64_t,string,string,string>{0x676902f53cbe43a1,"A37","English","symmetrical variation"},
tuple<uint64_t,string,string,string>{0xed110abfaf5bbb97,"A37","English","symmetrical, Botvinnik system reversed"},
tuple<uint64_t,string,string,string>{0x3c87360091440237,"A38","English","symmetrical variation"},
tuple<uint64_t,string,string,string>{0xe6fe63567c7e8b18,"A38","English","symmetrical, main line with d3"},
tuple<uint64_t,string,string,string>{0xc4fcc0d7e2635ba1,"A38","English","symmetrical, main line with b3"},
tuple<uint64_t,string,string,string>{0x8d6f8f2929271d8e,"A39","English","symmetrical, main line with d4"},
tuple<uint64_t,string,string,string>{0x830eb9b20758d1de,"A40","Queen's pawn",""},
tuple<uint64_t,string,string,string>{0x28e3615016c974dd,"A40","Queen's pawn","Lundin (Kevitz-Mikenas) defence"},
tuple<uint64_t,string,string,string>{0x976b1f894bd29e8,"A40","Queen's pawn","Charlick (Englund) gambit"},
tuple<uint64_t,string,string,string>{0xc50204575909880f,"A40","Queen's pawn","Englund gambit"},
tuple<uint64_t,string,string,string>{0xe867f0a2f9db6645,"A40","Queen's pawn","English defence"},
tuple<uint64_t,string,string,string>{0xe30ad3a79cf56ce3,"A40","Polish defence",""},
tuple<uint64_t,string,string,string>{0xf5794b831f7a418c,"A40","Queen's pawn",""},
tuple<uint64_t,string,string,string>{0x12339db7a2f65d10,"A40","Queen's pawn","Keres defence"},
tuple<uint64_t,string,string,string>{0xb01bbda1178222a9,"A40","Queen's pawn","Franco-Indian (Keres) defence"},
tuple<uint64_t,string,string,string>{0x6abaeae97cd74395,"A40","Modern defence",""},
tuple<uint64_t,string,string,string>{0x76b5e13adec0afdd,"A40","Beefeater defence",""},
tuple<uint64_t,string,string,string>{0xbab42fd3d52098b3,"A41","Queen's Pawn",""},
tuple<uint64_t,string,string,string>{0x63030917fa43f764,"A41","Old Indian","Tartakower (Wade) variation"},
tuple<uint64_t,string,string,string>{0x3697b0f7962f33b4,"A41","Old Indian defence",""},
tuple<uint64_t,string,string,string>{0x9408c6b8d405e88c,"A41","Modern defence",""},
tuple<uint64_t,string,string,string>{0x722ff596d204b888,"A41","Robatsch defence","Rossolimo variation"},
tuple<uint64_t,string,string,string>{0x500fcbf03f855586,"A42","Modern defence","Averbakh system"},
tuple<uint64_t,string,string,string>{0xb46963f301561e49,"A42","Pterodactyl defence",""},
tuple<uint64_t,string,string,string>{0xc460ad69810d7858,"A42","Modern defence","Averbakh system, Randspringer variation"},
tuple<uint64_t,string,string,string>{0xfbe213122e14f085,"A42","Modern defence","Averbakh system, Kotov variation"},
tuple<uint64_t,string,string,string>{0x657f681cf81fdaa3,"A43","Old Benoni defence",""},
tuple<uint64_t,string,string,string>{0x6d07d436929b61a6,"A43","Old Benoni","Franco-Benoni defence"},
tuple<uint64_t,string,string,string>{0x4b184dd6dfb16120,"A43","Old Benoni","Mujannah formation"},
tuple<uint64_t,string,string,string>{0x84991fbaccc30d68,"A43","Old Benoni defence",""},
tuple<uint64_t,string,string,string>{0xa67d9243a753ae3e,"A43","Woozle defence",""},
tuple<uint64_t,string,string,string>{0x5ffdf34ca4256c55,"A43","Old Benoni defence",""},
tuple<uint64_t,string,string,string>{0x87e2492eccc9c6d8,"A43","Hawk (Habichd) defence",""},
tuple<uint64_t,string,string,string>{0xe6cdbd2eb3410593,"A43","Old Benoni defence",""},
tuple<uint64_t,string,string,string>{0xf4eef6d70a2c1501,"A43","Old Benoni","Schmid's system"},
tuple<uint64_t,string,string,string>{0x9a3e66dbf801f641,"A44","Old Benoni defence",""},
tuple<uint64_t,string,string,string>{0xa8b2b82ccb2440af,"A44","Semi-Benoni (`blockade variation')",""},
tuple<uint64_t,string,string,string>{0xd8e08d47aaa29048,"A45","Queen's pawn game",""},
tuple<uint64_t,string,string,string>{0x7bad8c9142d77d55,"A45","Queen's pawn","Bronstein gambit"},
tuple<uint64_t,string,string,string>{0x25f6f04ab333adc1,"A45","Canard opening",""},
tuple<uint64_t,string,string,string>{0xb6516b760a687f39,"A45","Paleface attack",""},
tuple<uint64_t,string,string,string>{0xf73c442a7d3c8c15,"A45","Blackmar-Diemer gambit",""},
tuple<uint64_t,string,string,string>{0x907648b47ec9dc02,"A45","Gedult attack",""},
tuple<uint64_t,string,string,string>{0x1ebada711a284b80,"A45","Trompovsky attack (Ruth, Opovcensky opening)",""},
tuple<uint64_t,string,string,string>{0x38461b1c244f175,"A46","Queen's pawn game",""},
tuple<uint64_t,string,string,string>{0xb3a9c4b66aecbaef,"A46","Queen's pawn","Torre attack"},
tuple<uint64_t,string,string,string>{0x91df18507e2b0c98,"A46","Queen's pawn","Torre attack, Wagner gambit"},
tuple<uint64_t,string,string,string>{0xd8ded132fe39e983,"A46","Queen's pawn","Yusupov-Rubinstein system"},
tuple<uint64_t,string,string,string>{0x398c2d2e700d7c8f,"A46","Doery defence",""},
tuple<uint64_t,string,string,string>{0x68ed28a13cc746ee,"A47","Queen's Indian defence",""},
tuple<uint64_t,string,string,string>{0xa71a29b71ce8e249,"A47","Queen's Indian","Marienbad system"},
tuple<uint64_t,string,string,string>{0x9901b621682cfb5,"A47","Queen's Indian","Marienbad system, Berg variation"},
tuple<uint64_t,string,string,string>{0xea3032eab9cb633e,"A48","King's Indian","East Indian defence"},
tuple<uint64_t,string,string,string>{0x2c6a65dc0941b8f6,"A48","King's Indian","Torre attack"},
tuple<uint64_t,string,string,string>{0x3164d46b20ab895d,"A48","King's Indian","London system"},
tuple<uint64_t,string,string,string>{0xc6d689ab591cbb06,"A49","King's Indian","fianchetto without c4"},
tuple<uint64_t,string,string,string>{0x54c31263e9ad3b4f,"A50","Queen's pawn game",""},
tuple<uint64_t,string,string,string>{0xff2eca81f83c9e4c,"A50","Kevitz-Trajkovich defence",""},
tuple<uint64_t,string,string,string>{0x3faa5b73172e8cd4,"A50","Queen's Indian accelerated",""},
tuple<uint64_t,string,string,string>{0xdebb1a297a48c379,"A51","Budapest defence declined",""},
tuple<uint64_t,string,string,string>{0x782ea9f4c034f9f3,"A51","Budapest","Fajarowicz variation"},
tuple<uint64_t,string,string,string>{0xc937dbe9d2e2c597,"A51","Budapest","Fajarowicz, Steiner variation"},
tuple<uint64_t,string,string,string>{0xdf05be0d7f37e565,"A52","Budapest defence",""},
tuple<uint64_t,string,string,string>{0x46152fb17d18458,"A52","Budapest","Adler variation"},
tuple<uint64_t,string,string,string>{0x451588ce6570f06,"A52","Budapest","Rubinstein variation"},
tuple<uint64_t,string,string,string>{0x1b02b34594b7586f,"A52","Budapest","Alekhine variation"},
tuple<uint64_t,string,string,string>{0x46e07a6c33e3c34,"A52","Budapest","Alekhine, Abonyi variation"},
tuple<uint64_t,string,string,string>{0x22b8252446cf1102,"A52","Budapest","Alekhine variation, Balogh gambit"},
tuple<uint64_t,string,string,string>{0x6d7984023bd57222,"A53","Old Indian defence",""},
tuple<uint64_t,string,string,string>{0x15f7f52e4ed2f976,"A53","Old Indian","Janowski variation"},
tuple<uint64_t,string,string,string>{0x1c9694ea6ad208cd,"A54","Old Indian","Ukrainian variation"},
tuple<uint64_t,string,string,string>{0xd7550ca797a5afd6,"A54","Old Indian","Dus-Khotimirsky variation"},
tuple<uint64_t,string,string,string>{0xc7f2781c023469f0,"A54","Old Indian","Ukrainian variation, 4.Nf3"},
tuple<uint64_t,string,string,string>{0x30160e09091c3936,"A55","Old Indian","main line"},
tuple<uint64_t,string,string,string>{0xb2b2c3cd16ea3032,"A56","Benoni defence",""},
tuple<uint64_t,string,string,string>{0x310016ff5db4ef02,"A56","Benoni defence, Hromodka system",""},
tuple<uint64_t,string,string,string>{0x32b2cc013d852b95,"A56","Vulture defence",""},
tuple<uint64_t,string,string,string>{0x4df3cd0a16f41cd0,"A56","Czech Benoni defence",""},
tuple<uint64_t,string,string,string>{0x6d5c58049cbcbaac,"A56","Czech Benoni","King's Indian system"},
tuple<uint64_t,string,string,string>{0x68beea8b14611b52,"A57","Benko gambit",""},
tuple<uint64_t,string,string,string>{0x4b810d7ea7c32ad9,"A57","Benko gambit half accepted",""},
tuple<uint64_t,string,string,string>{0xb01615dc6521a800,"A57","Benko gambit","Zaitsev system"},
tuple<uint64_t,string,string,string>{0xfcf3b5758569b0d6,"A57","Benko gambit","Nescafe Frappe attack"},
tuple<uint64_t,string,string,string>{0x39a691df7150ed3e,"A58","Benko gambit accepted",""},
tuple<uint64_t,string,string,string>{0xfa188ff4783dd380,"A58","Benko gambit","Nd2 variation"},
tuple<uint64_t,string,string,string>{0xbdcaf525a573532,"A58","Benko gambit","fianchetto variation"},
tuple<uint64_t,string,string,string>{0xd1eda6f64269a376,"A59","Benko gambit","7.e4"},
tuple<uint64_t,string,string,string>{0x49b9373df0e93023,"A59","Benko gambit","Ne2 variation"},
tuple<uint64_t,string,string,string>{0x71fb67b33815e5e5,"A59","Benko gambit",""},
tuple<uint64_t,string,string,string>{0x4f7b0081a28b4a17,"A59","Benko gambit","main line"},
tuple<uint64_t,string,string,string>{0x7ecd72af97ee363d,"A60","Benoni defence",""},
tuple<uint64_t,string,string,string>{0xbf0e01c82c76da29,"A61","Benoni defence",""},
tuple<uint64_t,string,string,string>{0x795456fe9cfc01e1,"A61","Benoni","Uhlmann variation"},
tuple<uint64_t,string,string,string>{0x622c9a2feecbe4a3,"A61","Benoni","Nimzovich (knight's tour) variation"},
tuple<uint64_t,string,string,string>{0x93e8ba89cca10211,"A61","Benoni","fianchetto variation"},
tuple<uint64_t,string,string,string>{0x9c0c49f5af52f829,"A62","Benoni","fianchetto variation"},
tuple<uint64_t,string,string,string>{0xd19a499c3309cef5,"A63","Benoni","fianchetto, 9...Nbd7"},
tuple<uint64_t,string,string,string>{0xa9d79a24497738ef,"A64","Benoni","fianchetto, 11...Re8"},
tuple<uint64_t,string,string,string>{0x49d9b32dd49f9455,"A65","Benoni","6.e4"},
tuple<uint64_t,string,string,string>{0x5d7b9d7bb6813b97,"A66","Benoni","pawn storm variation"},
tuple<uint64_t,string,string,string>{0x8cbeb63049d8d659,"A66","Benoni","Mikenas variation"},
tuple<uint64_t,string,string,string>{0xde197162285263be,"A67","Benoni","Taimanov variation"},
tuple<uint64_t,string,string,string>{0x3c0ba18cf07978eb,"A68","Benoni","four pawns attack"},
tuple<uint64_t,string,string,string>{0x53dae535c32cd7ca,"A69","Benoni","four pawns attack, main line"},
tuple<uint64_t,string,string,string>{0x7b090c80c7f66723,"A70","Benoni","classical with e4 and Nf3"},
tuple<uint64_t,string,string,string>{0xb835b2cf3d94e62a,"A70","Benoni","classical without 9.O-O"},
tuple<uint64_t,string,string,string>{0xdef66008c3b7741,"A71","Benoni","classical, 8.Bg5"},
tuple<uint64_t,string,string,string>{0xb29d5f78e8cd0fc1,"A72","Benoni","classical without 9.O-O"},
tuple<uint64_t,string,string,string>{0xcce8244c943ed4d1,"A73","Benoni","classical, 9.O-O"},
tuple<uint64_t,string,string,string>{0x75d6ab531e8df9c3,"A74","Benoni","classical, 9...a6, 10.a4"},
tuple<uint64_t,string,string,string>{0x770561615908f729,"A75","Benoni","classical with ...a6 and 10...Bg4"},
tuple<uint64_t,string,string,string>{0xd0b9e30ca64e3153,"A76","Benoni","classical, 9...Re8"},
tuple<uint64_t,string,string,string>{0xd9b78eb64f30fd9,"A77","Benoni","classical, 9...Re8, 10.Nd2"},
tuple<uint64_t,string,string,string>{0x431bd37be20c9365,"A78","Benoni","classical with ...Re8 and ...Na6"},
tuple<uint64_t,string,string,string>{0x2daa354a42c67c14,"A79","Benoni","classical, 11.f3"},
tuple<uint64_t,string,string,string>{0x1761df2bb9d0fc00,"A80","Dutch",""},
tuple<uint64_t,string,string,string>{0x1455f2aa3ebdd252,"A80","Dutch, Spielmann gambit",""},
tuple<uint64_t,string,string,string>{0xb70673e716926d77,"A80","Dutch, Manhattan (Alapin, Ulvestad) variation",""},
tuple<uint64_t,string,string,string>{0x623c8000e6c51038,"A80","Dutch, Von Pretzel gambit",""},
tuple<uint64_t,string,string,string>{0xff9202957b7335f2,"A80","Dutch, Korchnoi attack",""},
tuple<uint64_t,string,string,string>{0xb42cdefd51a5111d,"A80","Dutch, Krejcik gambit",""},
tuple<uint64_t,string,string,string>{0xd13b881d095a27c8,"A80","Dutch, 2.Bg5 variation",""},
tuple<uint64_t,string,string,string>{0x3b87646a59072438,"A81","Dutch defence",""},
tuple<uint64_t,string,string,string>{0xc8205b5ce917525f,"A81","Dutch defence, Blackburne variation",""},
tuple<uint64_t,string,string,string>{0x3c2d20b9c29f2f9c,"A81","Dutch defence",""},
tuple<uint64_t,string,string,string>{0x6198cc334d75a14f,"A81","Dutch","Leningrad, Basman system"},
tuple<uint64_t,string,string,string>{0xbcb1f375dc07da7a,"A81","Dutch","Leningrad, Karlsbad variation"},
tuple<uint64_t,string,string,string>{0xd366d2635250410a,"A82","Dutch","Staunton gambit"},
tuple<uint64_t,string,string,string>{0xeadc440280280867,"A82","Dutch","Balogh defence"},
tuple<uint64_t,string,string,string>{0x11757a6516817ec1,"A82","Dutch","Staunton gambit"},
tuple<uint64_t,string,string,string>{0x124157e491ec5093,"A82","Dutch","Staunton gambit, Tartakower variation"},
tuple<uint64_t,string,string,string>{0x77560104c9136646,"A83","Dutch","Staunton gambit, Staunton's line"},
tuple<uint64_t,string,string,string>{0x241ce7619a38d73,"A83","Dutch","Staunton gambit, Alekhine variation"},
tuple<uint64_t,string,string,string>{0xf053b46e12561b7c,"A83","Dutch","Staunton gambit, Lasker variation"},
tuple<uint64_t,string,string,string>{0xe52cecebbed3b5fd,"A83","Dutch","Staunton gambit, Chigorin variation"},
tuple<uint64_t,string,string,string>{0x1c3f48143790d1dd,"A83","Dutch","Staunton gambit, Nimzovich variation"},
tuple<uint64_t,string,string,string>{0x9b42400ffadf5707,"A84","Dutch defence",""},
tuple<uint64_t,string,string,string>{0x8ed9412f9302aec,"A84","Dutch defence","Bladel variation"},
tuple<uint64_t,string,string,string>{0xed35b23ee2fdc755,"A84","Dutch defence",""},
tuple<uint64_t,string,string,string>{0x16a2aa9c201f458c,"A84","Dutch defence, Rubinstein variation",""},
tuple<uint64_t,string,string,string>{0x2932bf76097d7a5f,"A84","Dutch","Staunton gambit deferred"},
tuple<uint64_t,string,string,string>{0xc0ac74fa57251691,"A84","Dutch defence",""},
tuple<uint64_t,string,string,string>{0x3b3b6c5895c79448,"A85","Dutch with c4 & Nc3",""},
tuple<uint64_t,string,string,string>{0xec4acfbbb7f2cea9,"A86","Dutch with c4 & g3",""},
tuple<uint64_t,string,string,string>{0xff2b0cbf10e41de,"A86","Dutch","Hort-Antoshin system"},
tuple<uint64_t,string,string,string>{0x5fe9ce0cc7d5ce2,"A86","Dutch","Leningrad variation"},
tuple<uint64_t,string,string,string>{0xdbd66edd12312e0c,"A87","Dutch","Leningrad, main variation"},
tuple<uint64_t,string,string,string>{0xff5c9b72dcc104f8,"A88","Dutch","Leningrad, main variation with c6"},
tuple<uint64_t,string,string,string>{0xc6cbae7fba907240,"A89","Dutch","Leningrad, main variation with Nc6"},
tuple<uint64_t,string,string,string>{0x2fcd1ef7e23d8682,"A90","Dutch defence",""},
tuple<uint64_t,string,string,string>{0xe68c77f1a9ca4ea0,"A90","Dutch defence","Dutch-Indian (Nimzo-Dutch) variation"},
tuple<uint64_t,string,string,string>{0xea5a110715d0c41e,"A90","Dutch-Indian, Alekhine variation",""},
tuple<uint64_t,string,string,string>{0x3b016d1828962a13,"A91","Dutch defence",""},
tuple<uint64_t,string,string,string>{0xeacd6c599529a2c5,"A92","Dutch defence",""},
tuple<uint64_t,string,string,string>{0xaeb05bf25b93f42f,"A92","Dutch defence, Alekhine variation",""},
tuple<uint64_t,string,string,string>{0x11d23579750e37f3,"A92","Dutch","stonewall variation"},
tuple<uint64_t,string,string,string>{0xea452ddbb7ecb52a,"A92","Dutch","stonewall with Nc3"},
tuple<uint64_t,string,string,string>{0x9d74552daf835c9e,"A93","Dutch","stonewall, Botwinnik variation"},
tuple<uint64_t,string,string,string>{0xad1d698452931e4c,"A94","Dutch","stonewall with Ba3"},
tuple<uint64_t,string,string,string>{0x783fc034c02c6691,"A95","Dutch","stonewall with Nc3"},
tuple<uint64_t,string,string,string>{0xf4fd690d5152a480,"A95","Dutch","stonewall: Chekhover variation"},
tuple<uint64_t,string,string,string>{0xad02810c3ba230b8,"A96","Dutch","classical variation"},
tuple<uint64_t,string,string,string>{0xad1415bcca6297dc,"A97","Dutch","Ilyin-Genevsky variation"},
tuple<uint64_t,string,string,string>{0x29a01b374dca3cc8,"A97","Dutch","Ilyin-Genevsky, Winter variation"},
tuple<uint64_t,string,string,string>{0x1c0d67a1d8b4abb8,"A98","Dutch","Ilyin-Genevsky variation with Qc2"},
tuple<uint64_t,string,string,string>{0x21b275e810effcb1,"A99","Dutch","Ilyin-Genevsky variation with b3"},
tuple<uint64_t,string,string,string>{0x823c9b50fd114196,"B00","King's pawn opening",""},
tuple<uint64_t,string,string,string>{0x6f47e12854312f9e,"B00","Hippopotamus defence",""},
tuple<uint64_t,string,string,string>{0x4262e919e8d4d06,"B00","Corn stalk defence",""},
tuple<uint64_t,string,string,string>{0xccbc30c07beedd2a,"B00","Lemming defence",""},
tuple<uint64_t,string,string,string>{0x1653fdc943996c48,"B00","Fred",""},
tuple<uint64_t,string,string,string>{0x4e699d19c7fa56e9,"B00","Barnes defence",""},
tuple<uint64_t,string,string,string>{0xee8b01ccbc8784b3,"B00","Fried fox defence",""},
tuple<uint64_t,string,string,string>{0x10cbd0366ac50883,"B00","Carr's defence",""},
tuple<uint64_t,string,string,string>{0x27f6b8d69a5be1c,"B00","Reversed Grob (Borg/Basman defence/macho Grob)",""},
tuple<uint64_t,string,string,string>{0x50cb6aa31a31b94a,"B00","St. George (Baker) defence",""},
tuple<uint64_t,string,string,string>{0xe955d2400392f60d,"B00","Owen defence",""},
tuple<uint64_t,string,string,string>{0xe370af0e597ad9b1,"B00","Guatemala defence",""},
tuple<uint64_t,string,string,string>{0x29d143b2ec80e495,"B00","KP","Nimzovich defence"},
tuple<uint64_t,string,string,string>{0x93ad04944ec0e2cd,"B00","KP","Nimzovich defence, Wheeler gambit"},
tuple<uint64_t,string,string,string>{0xf2b5af44846685a8,"B00","KP","Nimzovich defence"},
tuple<uint64_t,string,string,string>{0x66dac9dd3aeea876,"B00","KP","Colorado counter"},
tuple<uint64_t,string,string,string>{0xece46c18fd49c9d7,"B00","KP","Nimzovich defence"},
tuple<uint64_t,string,string,string>{0x31ea8dc9a0823ae4,"B00","KP","Nimzovich defence, Marshall gambit"},
tuple<uint64_t,string,string,string>{0x921956aea37f0528,"B00","KP","Nimzovich defence, Bogolyubov variation"},
tuple<uint64_t,string,string,string>{0x20b16a51c7a2dea8,"B00","KP","Neo-Mongoloid defence"},
tuple<uint64_t,string,string,string>{0x756b94461c50fb0,"B01","Scandinavian (centre counter) defence",""},
tuple<uint64_t,string,string,string>{0xeda5dcb5fc9c9f1,"B01","Scandinavian defence, Lasker variation",""},
tuple<uint64_t,string,string,string>{0x67e323c96d0a0764,"B01","Scandinavian defence",""},
tuple<uint64_t,string,string,string>{0x8bec103fa9325cb4,"B01","Scandinavian defence, Gruenfeld variation",""},
tuple<uint64_t,string,string,string>{0xee089a0e8c16d674,"B01","Scandinavian","Anderssen counter-attack"},
tuple<uint64_t,string,string,string>{0xe2d062eb24c2061c,"B01","Scandinavian","Anderssen counter-attack orthodox attack"},
tuple<uint64_t,string,string,string>{0x356c76f8e4f0b749,"B01","Scandinavian","Anderssen counter-attack, Goteborg system"},
tuple<uint64_t,string,string,string>{0x37bfbccaa375b9a3,"B01","Scandinavian","Anderssen counter-attack, Collijn variation"},
tuple<uint64_t,string,string,string>{0xbb0c842a88c6f24,"B01","Scandinavian, Mieses-Kotrvc gambit",""},
tuple<uint64_t,string,string,string>{0xcd5a4325af512e90,"B01","Scandinavian","Pytel-Wade variation"},
tuple<uint64_t,string,string,string>{0x7b6787fc16500c20,"B01","Scandinavian defence",""},
tuple<uint64_t,string,string,string>{0x8133eae94d7d3775,"B01","Scandinavian","Icelandic gambit"},
tuple<uint64_t,string,string,string>{0x653ef537229f749c,"B01","Scandinavian gambit",""},
tuple<uint64_t,string,string,string>{0xbe52a85607992162,"B01","Scandinavian defence",""},
tuple<uint64_t,string,string,string>{0x21bcd21bb87c3c3e,"B01","Scandinavian","Marshall variation"},
tuple<uint64_t,string,string,string>{0x12360b30d1336f82,"B01","Scandinavian","Kiel variation"},
tuple<uint64_t,string,string,string>{0x57e6fb0d7c16b329,"B01","Scandinavian","Richter variation"},
tuple<uint64_t,string,string,string>{0xd9d2afa550eb0000,"B02","Alekhine's defence",""},
tuple<uint64_t,string,string,string>{0xa72f95130eddccff,"B02","Alekhine's defence","Scandinavian variation"},
tuple<uint64_t,string,string,string>{0xbcd49c7757fae9a7,"B02","Alekhine's defence","Spielmann variation"},
tuple<uint64_t,string,string,string>{0x77766c70147bbbd4,"B02","Alekhine's defence","Maroczy variation"},
tuple<uint64_t,string,string,string>{0xba611b8d78a8d6a6,"B02","Alekhine's defence","Krejcik variation"},
tuple<uint64_t,string,string,string>{0x82a3f5c7e6bcab9e,"B02","Alekhine's defence","Mokele Mbembe (Buecker) variation"},
tuple<uint64_t,string,string,string>{0xe3458dadf90f67f2,"B02","Alekhine's defence","Brooklyn defence"},
tuple<uint64_t,string,string,string>{0x7cbb66a19a3753d1,"B02","Alekhine's defence",""},
tuple<uint64_t,string,string,string>{0xb7425fdf9ac00e74,"B02","Alekhine's defence","Kmoch variation"},
tuple<uint64_t,string,string,string>{0x872c7e0358d5d108,"B02","Alekhine's defence","Saemisch attack"},
tuple<uint64_t,string,string,string>{0xf01d06f540ba38bc,"B02","Alekhine's defence","Welling variation"},
tuple<uint64_t,string,string,string>{0xf098f985d938f8d6,"B02","Alekhine's defence",""},
tuple<uint64_t,string,string,string>{0x55a516de1bf0f8f5,"B02","Alekhine's defence","Steiner variation"},
tuple<uint64_t,string,string,string>{0xb6919cd2ef647e28,"B02","Alekhine's defence","two pawns' (Lasker's) attack"},
tuple<uint64_t,string,string,string>{0x48e3db07d7da9826,"B02","Alekhine's defence","two pawns' attack, Mikenas variation"},
tuple<uint64_t,string,string,string>{0xb98e490b8bfe7e93,"B03","Alekhine's defence",""},
tuple<uint64_t,string,string,string>{0xd98a231e1053c3ae,"B03","Alekhine's defence","O'Sullivan gambit"},
tuple<uint64_t,string,string,string>{0x8034df6a598637fe,"B03","Alekhine's defence",""},
tuple<uint64_t,string,string,string>{0xe3876b4271c5e158,"B03","Alekhine's defence","Balogh variation"},
tuple<uint64_t,string,string,string>{0xc17404e1a899cf9,"B03","Alekhine's defence",""},
tuple<uint64_t,string,string,string>{0x64534b53efb678a8,"B03","Alekhine's defence","exchange variation"},
tuple<uint64_t,string,string,string>{0xe7d594c774e30096,"B03","Alekhine's defence","exchange, Karpov variation"},
tuple<uint64_t,string,string,string>{0xd89ab24c1b5dca3e,"B03","Alekhine's defence","four pawns attack"},
tuple<uint64_t,string,string,string>{0x6479b5379b73c9ae,"B03","Alekhine's defence","four pawns attack, Korchnoi variation"},
tuple<uint64_t,string,string,string>{0xc5cd62e2d7eed520,"B03","Alekhine's defence","four pawns attack, 6...Nc6"},
tuple<uint64_t,string,string,string>{0x97e4b1099111d4a4,"B03","Alekhine's defence","four pawns attack, Ilyin-Genevsky var."},
tuple<uint64_t,string,string,string>{0xb6c5d90e56d4ceae,"B03","Alekhine's defence","four pawns attack, 7.Be3"},
tuple<uint64_t,string,string,string>{0x54c4ed4f52da08c2,"B03","Alekhine's defence","four pawns attack, Tartakower variation"},
tuple<uint64_t,string,string,string>{0x58d942918fe935b4,"B03","Alekhine's defence","four pawns attack, Planinc variation"},
tuple<uint64_t,string,string,string>{0x312ee11760d25875,"B03","Alekhine's defence","four pawns attack, fianchetto variation"},
tuple<uint64_t,string,string,string>{0x5b83dbc2acb8c3b3,"B03","Alekhine's defence","four pawns attack, Trifunovic variation"},
tuple<uint64_t,string,string,string>{0x5b50339c316056c3,"B04","Alekhine's defence","modern variation"},
tuple<uint64_t,string,string,string>{0x61753373802e184a,"B04","Alekhine's defence","modern, Larsen variation"},
tuple<uint64_t,string,string,string>{0x72cbbc9329253d8d,"B04","Alekhine's defence","modern, Schmid variation"},
tuple<uint64_t,string,string,string>{0xb2e460c74aefc488,"B04","Alekhine's defence","modern, fianchetto variation"},
tuple<uint64_t,string,string,string>{0xeabd0898671b37e0,"B04","Alekhine's defence","modern, Keres variation"},
tuple<uint64_t,string,string,string>{0x5983f9ae76e55829,"B05","Alekhine's defence","modern variation, 4...Bg4"},
tuple<uint64_t,string,string,string>{0xb87997b80000c131,"B05","Alekhine's defence","modern, Flohr variation"},
tuple<uint64_t,string,string,string>{0xb1702410b44691db,"B05","Alekhine's defence","modern, Panov variation"},
tuple<uint64_t,string,string,string>{0xd5a0668a35eaf32e,"B05","Alekhine's defence","modern, Alekhine variation"},
tuple<uint64_t,string,string,string>{0x4633aad6b4890e3d,"B05","Alekhine's defence","modern, Vitolins attack"},
tuple<uint64_t,string,string,string>{0x6b88c80b869ed3dd,"B06","Robatsch (modern) defence",""},
tuple<uint64_t,string,string,string>{0xaaca08fca77853a6,"B06","Norwegian defence",""},
tuple<uint64_t,string,string,string>{0x1e01da176c103535,"B06","Robatsch (modern) defence",""},
tuple<uint64_t,string,string,string>{0xe317a71a758108bc,"B06","Robatsch defence","three pawns attack"},
tuple<uint64_t,string,string,string>{0xe596c2b5aef2b7ec,"B06","Robatsch defence",""},
tuple<uint64_t,string,string,string>{0x73b7f8c55f4990eb,"B06","Robatsch defence","Gurgenidze variation"},
tuple<uint64_t,string,string,string>{0xdc2c54d47c8afe81,"B06","Robatsch (modern) defence",""},
tuple<uint64_t,string,string,string>{0x748b822146c9fbc,"B06","Robatsch defence","two knights variation"},
tuple<uint64_t,string,string,string>{0x953255cd63ac4c07,"B06","Robatsch defence","two knights, Suttles variation"},
tuple<uint64_t,string,string,string>{0x213a29d9651bc308,"B06","Robatsch defence","Pseudo-Austrian attack"},
tuple<uint64_t,string,string,string>{0xdeca0ecc51b8e6f6,"B07","Pirc defence",""},
tuple<uint64_t,string,string,string>{0x4cb0e3232678354d,"B07","Pirc","Ufimtsev-Pytel variation"},
tuple<uint64_t,string,string,string>{0x377e5d972a3774bd,"B07","Pirc defence",""},
tuple<uint64_t,string,string,string>{0xfe14441b1d746328,"B07","Pirc","150 attack"},
tuple<uint64_t,string,string,string>{0x1b98e6d6cae0ac85,"B07","Pirc","Sveshnikov system"},
tuple<uint64_t,string,string,string>{0x54cde9bf0274a21b,"B07","Pirc","Holmov system"},
tuple<uint64_t,string,string,string>{0xf1240aa19abdaf75,"B07","Pirc","Byrne variation"},
tuple<uint64_t,string,string,string>{0x44fede6e2b123e1e,"B07","Pirc defence",""},
tuple<uint64_t,string,string,string>{0x570fe20e382018a9,"B07","Pirc","Chinese variation"},
tuple<uint64_t,string,string,string>{0x68e17ff17b6a8cca,"B07","Pirc","bayonet (Mariotti) attack"},
tuple<uint64_t,string,string,string>{0x8a05581806fe12e3,"B07","Robatsch defence","Geller's system"},
tuple<uint64_t,string,string,string>{0xec1ab16142d11580,"B08","Pirc","classical (two knights) system"},
tuple<uint64_t,string,string,string>{0x5ca68cd7b996de2a,"B08","Pirc","classical (two knights) system"},
tuple<uint64_t,string,string,string>{0xb45551697b3517d8,"B08","Pirc","classical, h3 system"},
tuple<uint64_t,string,string,string>{0x2f260f2eb8b39489,"B08","Pirc","classical system, 5.Be2"},
tuple<uint64_t,string,string,string>{0xca68209a33a64934,"B09","Pirc","Austrian attack"},
tuple<uint64_t,string,string,string>{0xab181c6d755e0a48,"B09","Pirc","Austrian attack"},
tuple<uint64_t,string,string,string>{0xca610a9071402c2c,"B09","Pirc","Austrian attack, 6.e5"},
tuple<uint64_t,string,string,string>{0xd810a781f46411c6,"B09","Pirc","Austrian attack, 6.Be3"},
tuple<uint64_t,string,string,string>{0xfe15bdcf4cdec83b,"B09","Pirc","Austrian attack, 6.Bd3"},
tuple<uint64_t,string,string,string>{0x47c120745f40e8de,"B09","Pirc","Austrian attack, dragon formation"},
tuple<uint64_t,string,string,string>{0x1967a904e0a25438,"B09","Pirc","Austrian attack, Ljubojevic variation"},
tuple<uint64_t,string,string,string>{0x104676bf8ad1922d,"B10","Caro-Kann defence",""},
tuple<uint64_t,string,string,string>{0x73f5c297a292448b,"B10","Caro-Kann","Hillbilly attack"},
tuple<uint64_t,string,string,string>{0x9c65e99bc9de392a,"B10","Caro-Kann","anti-Caro-Kann defence"},
tuple<uint64_t,string,string,string>{0x190fcb8f550a770c,"B10","Caro-Kann","anti-anti-Caro-Kann defence"},
tuple<uint64_t,string,string,string>{0xbee2b56ace4129f9,"B10","Caro-Kann","closed (Breyer) variation"},
tuple<uint64_t,string,string,string>{0xebd16e1d483310f4,"B10","Caro-Kann defence",""},
tuple<uint64_t,string,string,string>{0xd499373af89a0869,"B10","Caro-Kann","Goldman (Spielmann) variation"},
tuple<uint64_t,string,string,string>{0xb5dfa0ffbc013fef,"B10","Caro-Kann","two knights variation"},
tuple<uint64_t,string,string,string>{0xb70c6acdfb843105,"B11","Caro-Kann","two knights, 3...Bg4"},
tuple<uint64_t,string,string,string>{0xd57359159b18bf6f,"B12","Caro-Kann defence",""},
tuple<uint64_t,string,string,string>{0xc247c4898c01ece3,"B12","de Bruycker defence",""},
tuple<uint64_t,string,string,string>{0x8e9d6de036e2fef9,"B12","Caro-Masi defence",""},
tuple<uint64_t,string,string,string>{0x50197b0107ccf149,"B12","Caro-Kann defence",""},
tuple<uint64_t,string,string,string>{0x3ea89d30a7061e38,"B12","Caro-Kann","Tartakower (fantasy) variation"},
tuple<uint64_t,string,string,string>{0x977c3639d315979,"B12","Caro-Kann","3.Nd2"},
tuple<uint64_t,string,string,string>{0xce883d34577a8fa3,"B12","Caro-Kann","Edinburgh variation"},
tuple<uint64_t,string,string,string>{0x31606dfc03d2d72d,"B12","Caro-Kann","advance variation"},
tuple<uint64_t,string,string,string>{0xc1548d227d400bd7,"B12","Caro-Kann","advance, Short variation"},
tuple<uint64_t,string,string,string>{0x77c6714cdda3b34f,"B13","Caro-Kann","exchange variation"},
tuple<uint64_t,string,string,string>{0xc368da9b1327df6,"B13","Caro-Kann","exchange, Rubinstein variation"},
tuple<uint64_t,string,string,string>{0x889541213ec615f2,"B13","Caro-Kann","Panov-Botvinnik attack"},
tuple<uint64_t,string,string,string>{0xbce99f8cbd25b9d4,"B13","Caro-Kann","Panov-Botvinnik, Gunderam attack"},
tuple<uint64_t,string,string,string>{0x28ec6d7651ded6bd,"B13","Caro-Kann","Panov-Botvinnik attack"},
tuple<uint64_t,string,string,string>{0x7842b23696e172c2,"B13","Caro-Kann","Panov-Botvinnik, Herzog defence"},
tuple<uint64_t,string,string,string>{0x332c1093e8e73824,"B13","Caro-Kann","Panov-Botvinnik, normal variation"},
tuple<uint64_t,string,string,string>{0x9c2877f959b789f9,"B13","Caro-Kann","Panov-Botvinnik, Czerniak variation"},
tuple<uint64_t,string,string,string>{0x82a41cf53a8e7eac,"B13","Caro-Kann","Panov-Botvinnik, Reifir (Spielmann) variation"},
tuple<uint64_t,string,string,string>{0x5e9b9f4749fc46ef,"B14","Caro-Kann","Panov-Botvinnik attack, 5...e6"},
tuple<uint64_t,string,string,string>{0xc1583e2d2a5144f6,"B14","Caro-Kann","Panov-Botvinnik attack, 5...g6"},
tuple<uint64_t,string,string,string>{0xab8e63a3c52e7390,"B15","Caro-Kann defence",""},
tuple<uint64_t,string,string,string>{0xcb8a09b65e83cead,"B15","Caro-Kann","Gurgenidze counter-attack"},
tuple<uint64_t,string,string,string>{0x423a30f8bea1e1db,"B15","Caro-Kann","Gurgenidze system"},
tuple<uint64_t,string,string,string>{0xdb51a9bac1d2cb1,"B15","Caro-Kann","Rasa-Studier gambit"},
tuple<uint64_t,string,string,string>{0xc9c6c2594c215257,"B15","Caro-Kann defence",""},
tuple<uint64_t,string,string,string>{0xc725570ed85bd1b2,"B15","Caro-Kann","Alekhine gambit"},
tuple<uint64_t,string,string,string>{0x62fa20a189c76fab,"B15","Caro-Kann","Tartakower (Nimzovich) variation"},
tuple<uint64_t,string,string,string>{0x1499489a184b90d,"B15","Caro-Kann","Forgacs variation"},
tuple<uint64_t,string,string,string>{0x3ecf958145a4756c,"B16","Caro-Kann","Bronstein-Larsen variation"},
tuple<uint64_t,string,string,string>{0xfa25b904ac89bf9b,"B17","Caro-Kann","Steinitz variation"},
tuple<uint64_t,string,string,string>{0x4adfabd7fbc45bda,"B18","Caro-Kann","classical variation"},
tuple<uint64_t,string,string,string>{0xccb30dac45725930,"B18","Caro-Kann","classical, Flohr variation"},
tuple<uint64_t,string,string,string>{0x5a6baa2e14c61b63,"B18","Caro-Kann","classical, Maroczy attack"},
tuple<uint64_t,string,string,string>{0x3bde4b0aa6685f94,"B18","Caro-Kann","classical, 6.h4"},
tuple<uint64_t,string,string,string>{0x41ae97c7b9f29a70,"B19","Caro-Kann","classical, 7...Nd7"},
tuple<uint64_t,string,string,string>{0x5794bd5eeddee2f3,"B19","Caro-Kann","classical, Spassky variation"},
tuple<uint64_t,string,string,string>{0x644d4afe02564aeb,"B20","Sicilian defence",""},
tuple<uint64_t,string,string,string>{0xb016a6c1a7a5f614,"B20","Sicilian","Gloria variation"},
tuple<uint64_t,string,string,string>{0x48abf1bfe28192d3,"B20","Sicilian","Steinitz variation"},
tuple<uint64_t,string,string,string>{0xceb83f52a4e026cf,"B20","Sicilian","wing gambit"},
tuple<uint64_t,string,string,string>{0x33b7f39c2bb44083,"B20","Sicilian","wing gambit, Santasiere variation"},
tuple<uint64_t,string,string,string>{0x7432ce4693770ca6,"B20","Sicilian","wing gambit, Marshall variation"},
tuple<uint64_t,string,string,string>{0x92d7dd30c1c2e1a3,"B20","Sicilian","wing gambit, Marienbad variation"},
tuple<uint64_t,string,string,string>{0x236e7c997a5d9b3a,"B20","Sicilian","wing gambit, Carlsbad variation"},
tuple<uint64_t,string,string,string>{0x70e9a1312a7d4715,"B20","Sicilian","Keres variation (2.Ne2)"},
tuple<uint64_t,string,string,string>{0x995b37f31bc77762,"B21","Sicilian","Grand Prix attack"},
tuple<uint64_t,string,string,string>{0xa1786554139f67a9,"B21","Sicilian","Smith-Morra gambit"},
tuple<uint64_t,string,string,string>{0xd9a0c345451898e2,"B21","Sicilian","Andreaschek gambit"},
tuple<uint64_t,string,string,string>{0x88bc27f9be1b01e9,"B21","Sicilian","Smith-Morra gambit"},
tuple<uint64_t,string,string,string>{0xa945fba8bdfeec41,"B21","Sicilian","Smith-Morra gambit, Chicago defence"},
tuple<uint64_t,string,string,string>{0x1297b266d226456d,"B22","Sicilian","Alapin's variation (2.c3)"},
tuple<uint64_t,string,string,string>{0x9b7fabd02125bcda,"B22","Sicilian","2.c3, Heidenfeld variation"},
tuple<uint64_t,string,string,string>{0x9fda525cc0b4c832,"B23","Sicilian","closed"},
tuple<uint64_t,string,string,string>{0x40213938a495ce7e,"B23","Sicilian","closed, Korchnoi variation"},
tuple<uint64_t,string,string,string>{0x34378abed1256d31,"B23","Sicilian","closed, 2...Nc6"},
tuple<uint64_t,string,string,string>{0x20936171f90e60cf,"B23","Sicilian","chameleon variation"},
tuple<uint64_t,string,string,string>{0xc921f7b3c8b450b8,"B23","Sicilian","Grand Prix attack"},
tuple<uint64_t,string,string,string>{0x35098e0ef8441f73,"B23","Sicilian","Grand Prix attack, Schofman variation"},
tuple<uint64_t,string,string,string>{0x18d131ff31f2b509,"B24","Sicilian","closed"},
tuple<uint64_t,string,string,string>{0x3894a69845743c98,"B24","Sicilian","closed, Smyslov variation"},
tuple<uint64_t,string,string,string>{0x633729db6a3fc628,"B25","Sicilian","closed"},
tuple<uint64_t,string,string,string>{0xfdebca5ed1f133e0,"B25","Sicilian","closed, 6.Ne2 e5 (Botvinnik)"},
tuple<uint64_t,string,string,string>{0x9e2154d673aefba1,"B25","Sicilian","closed, 6.f4"},
tuple<uint64_t,string,string,string>{0x14595c9ce04b0397,"B25","Sicilian","closed, 6.f4 e5 (Botvinnik)"},
tuple<uint64_t,string,string,string>{0x103f9237eb05dda6,"B26","Sicilian","closed, 6.Be3"},
tuple<uint64_t,string,string,string>{0xbf29a6086ab02bd6,"B27","Sicilian defence",""},
tuple<uint64_t,string,string,string>{0x665a3353c3c20a59,"B27","Sicilian","Stiletto (Althouse) variation"},
tuple<uint64_t,string,string,string>{0xb936992906fb64d7,"B27","Sicilian","Quinteros variation"},
tuple<uint64_t,string,string,string>{0xd440ef1894339c4d,"B27","Sicilian","Katalimov variation"},
tuple<uint64_t,string,string,string>{0x569df553113fb99d,"B27","Sicilian","Hungarian variation"},
tuple<uint64_t,string,string,string>{0x929a2f9b37a683f5,"B27","Sicilian","Acton extension"},
tuple<uint64_t,string,string,string>{0x6dde57fb8d90d30a,"B28","Sicilian","O'Kelly variation"},
tuple<uint64_t,string,string,string>{0xe4c792fdc74a6a40,"B29","Sicilian","Nimzovich-Rubinstein variation"},
tuple<uint64_t,string,string,string>{0x543fc291edd901cd,"B29","Sicilian","Nimzovich-Rubinstein; Rubinstein counter-gambit"},
tuple<uint64_t,string,string,string>{0x14c47eea7b218ed5,"B30","Sicilian defence",""},
tuple<uint64_t,string,string,string>{0x271aaf451eb51d56,"B30","Sicilian","Nimzovich-Rossolimo attack (without ...d6)"},
tuple<uint64_t,string,string,string>{0xceaefc1e653a8f1d,"B31","Sicilian","Nimzovich-Rossolimo attack (with ...g6, without ...d6)"},
tuple<uint64_t,string,string,string>{0xa45ec9f15075a0a1,"B31","Sicilian","Nimzovich-Rossolimo attack, Gurgenidze variation"},
tuple<uint64_t,string,string,string>{0xd1f151406ae8a397,"B32","Sicilian defence",""},
tuple<uint64_t,string,string,string>{0xef6489096a66177e,"B32","Sicilian","Flohr variation"},
tuple<uint64_t,string,string,string>{0x6c11943c9af91659,"B32","Sicilian","Nimzovich variation"},
tuple<uint64_t,string,string,string>{0x6303be6295c8a049,"B32","Sicilian","Labourdonnais-Loewenthal variation"},
tuple<uint64_t,string,string,string>{0xafd3c26e4620d372,"B32","Sicilian","Labourdonnais-Loewenthal (Kalashnikov) variation"},
tuple<uint64_t,string,string,string>{0xb29582ddabd719e9,"B33","Sicilian defence",""},
tuple<uint64_t,string,string,string>{0xc37a9235fad06306,"B33","Sicilian","Pelikan (Lasker/Sveshnikov) variation"},
tuple<uint64_t,string,string,string>{0x4718599f407d73cc,"B33","Sicilian","Pelikan, Bird variation"},
tuple<uint64_t,string,string,string>{0x73a4a15e9365b5f9,"B33","Sicilian","Pelikan, Chelyabinsk variation"},
tuple<uint64_t,string,string,string>{0x5b3ed61ff6794a0d,"B33","Sicilian","Sveshnikov variation"},
tuple<uint64_t,string,string,string>{0x4c4d592c0ab6c301,"B34","Sicilian","accelerated fianchetto, exchange variation"},
tuple<uint64_t,string,string,string>{0xfb58fdd1bf4048ed,"B34","Sicilian","accelerated fianchetto, modern variation"},
tuple<uint64_t,string,string,string>{0xb1fb5640840ff9,"B35","Sicilian","accelerated fianchetto, modern variation with Bc4"},
tuple<uint64_t,string,string,string>{0x8cec7a573ead6133,"B36","Sicilian","accelerated fianchetto, Maroczy bind"},
tuple<uint64_t,string,string,string>{0x47cd36fcffadbc5a,"B36","Sicilian","accelerated fianchetto, Gurgenidze variation"},
tuple<uint64_t,string,string,string>{0x3c5047e1c5eaaa99,"B37","Sicilian","accelerated fianchetto, Maroczy bind, 5...Bg7"},
tuple<uint64_t,string,string,string>{0xa2daf0145d6bd344,"B37","Sicilian","accelerated fianchetto, Simagin variation"},
tuple<uint64_t,string,string,string>{0x4f58fc0d44d0b117,"B38","Sicilian","accelerated fianchetto, Maroczy bind, 6.Be3"},
tuple<uint64_t,string,string,string>{0x72028b3c2682e334,"B39","Sicilian","accelerated fianchetto, Breyer variation"},
tuple<uint64_t,string,string,string>{0xc95e54397292bb84,"B40","Sicilian defence",""},
tuple<uint64_t,string,string,string>{0x89015987ff8fd8e0,"B40","Sicilian","Marshall variation"},
tuple<uint64_t,string,string,string>{0x5375c1a61eafff00,"B40","Sicilian defence",""},
tuple<uint64_t,string,string,string>{0x6f0fa80ea2642cb8,"B40","Sicilian","Anderssen variation"},
tuple<uint64_t,string,string,string>{0x5dd9d9aa2b716643,"B40","Sicilian","Pin variation (Sicilian counter-attack)"},
tuple<uint64_t,string,string,string>{0xc0da4d93611495d,"B40","Sicilian","Pin, Jaffe variation"},
tuple<uint64_t,string,string,string>{0x3ca0cf572f6f4027,"B40","Sicilian","Pin, Koch variation"},
tuple<uint64_t,string,string,string>{0xe6166d08e8be95f2,"B41","Sicilian","Kan variation"},
tuple<uint64_t,string,string,string>{0x6a35f22cabb13ef5,"B41","Sicilian","Kan, Maroczy bind (Reti variation)"},
tuple<uint64_t,string,string,string>{0xab88bb80bdfd25c,"B41","Sicilian","Kan, Maroczy bind - Bronstein variation"},
tuple<uint64_t,string,string,string>{0xb31bccaad13e5781,"B42","Sicilian","Kan, 5.Bd3"},
tuple<uint64_t,string,string,string>{0xcaadd975eacfbd26,"B42","Sicilian","Kan, Gipslis variation"},
tuple<uint64_t,string,string,string>{0x1e0688f11b0cbd02,"B42","Sicilian","Kan, Polugaievsky variation"},
tuple<uint64_t,string,string,string>{0x5aaf9ff1aab1c5ca,"B42","Sicilian","Kan, Swiss cheese variation"},
tuple<uint64_t,string,string,string>{0x1d8175aa2a5c172b,"B43","Sicilian","Kan, 5.Nc3"},
tuple<uint64_t,string,string,string>{0x9f0c44191e0fc82d,"B44","Sicilian defence",""},
tuple<uint64_t,string,string,string>{0x6a66ae741f9ff27b,"B44","Sicilian, Szen (`anti-Taimanov') variation",""},
tuple<uint64_t,string,string,string>{0xdd2ed6a7ec2d733d,"B44","Sicilian, Szen, hedgehog variation",""},
tuple<uint64_t,string,string,string>{0xe1d06bfd9101922d,"B44","Sicilian, Szen variation, Dely-Kasparov gambit",""},
tuple<uint64_t,string,string,string>{0x649b5cbbdced4af4,"B45","Sicilian","Taimanov variation"},
tuple<uint64_t,string,string,string>{0x880a67c600624874,"B45","Sicilian","Taimanov, American attack"},
tuple<uint64_t,string,string,string>{0xb66cad483bcdb228,"B46","Sicilian","Taimanov variation"},
tuple<uint64_t,string,string,string>{0x6284639ab0a605f5,"B47","Sicilian","Taimanov (Bastrikov) variation"},
tuple<uint64_t,string,string,string>{0x118cd876319c1e7b,"B48","Sicilian","Taimanov variation"},
tuple<uint64_t,string,string,string>{0xb0fbaa7cd799ac04,"B49","Sicilian","Taimanov variation"},
tuple<uint64_t,string,string,string>{0x86933069b8c862bb,"B50","Sicilian",""},
tuple<uint64_t,string,string,string>{0x2c6645c51e7e0e9f,"B50","Sicilian","wing gambit deferred"},
tuple<uint64_t,string,string,string>{0xb54de1c6dd5cf138,"B51","Sicilian","Canal-Sokolsky (Nimzovich-Rossolimo, Moscow) attack"},
tuple<uint64_t,string,string,string>{0x578c1f9407062109,"B52","Sicilian","Canal-Sokolsky attack, 3...Bd7"},
tuple<uint64_t,string,string,string>{0x488ea981bb2c57b0,"B52","Sicilian","Canal-Sokolsky attack, Bronstein gambit"},
tuple<uint64_t,string,string,string>{0xf93476b4f902e1f6,"B52","Sicilian","Canal-Sokolsky attack, Sokolsky variation"},
tuple<uint64_t,string,string,string>{0x610fb232e064c902,"B53","Sicilian, Chekhover variation",""},
tuple<uint64_t,string,string,string>{0xe4affea96dc72acd,"B53","Sicilian","Chekhover, Zaitsev variation"},
tuple<uint64_t,string,string,string>{0x7b2cf8abc5c4b411,"B54","Sicilian",""},
tuple<uint64_t,string,string,string>{0x4e732a6fc8f41af6,"B54","Sicilian","Prins (Moscow) variation"},
tuple<uint64_t,string,string,string>{0xf7d5f38a3e857143,"B55","Sicilian","Prins variation, Venice attack"},
tuple<uint64_t,string,string,string>{0xdb55d4fcaadc775e,"B56","Sicilian",""},
tuple<uint64_t,string,string,string>{0x62f30d195cad1ceb,"B56","Sicilian","Venice attack"},
tuple<uint64_t,string,string,string>{0x70b80c1ebb4dd25d,"B56","Sicilian",""},
tuple<uint64_t,string,string,string>{0x130bb836930e04fb,"B57","Sicilian","Sozin, not Scheveningen"},
tuple<uint64_t,string,string,string>{0xad299981e20f26a,"B57","Sicilian","Magnus Smith trap"},
tuple<uint64_t,string,string,string>{0xd4f446615945d221,"B57","Sicilian","Sozin, Benko variation"},
tuple<uint64_t,string,string,string>{0x3388fe7ba6898fe,"B58","Sicilian","classical"},
tuple<uint64_t,string,string,string>{0x894087ad298d60c8,"B58","Sicilian","Boleslavsky variation"},
tuple<uint64_t,string,string,string>{0xc5c23bf25e9969fd,"B58","Sicilian","Boleslavsky, Louma variation"},
tuple<uint64_t,string,string,string>{0x1d31bf80389aa602,"B59","Sicilian","Boleslavsky variation, 7.Nb3"},
tuple<uint64_t,string,string,string>{0xb6e25b280bc70995,"B60","Sicilian","Richter-Rauzer"},
tuple<uint64_t,string,string,string>{0x5f56087370489bde,"B60","Sicilian","Richter-Rauzer, Bondarevsky variation"},
tuple<uint64_t,string,string,string>{0x5423a57ad19dd9a4,"B60","Sicilian","Richter-Rauzer, Larsen variation"},
tuple<uint64_t,string,string,string>{0x7c3beaf510240604,"B61","Sicilian","Richter-Rauzer, Larsen variation, 7.Qd2"},
tuple<uint64_t,string,string,string>{0xc095a91913e599c7,"B62","Sicilian","Richter-Rauzer, 6...e6"},
tuple<uint64_t,string,string,string>{0x54e4913402f25f0d,"B62","Sicilian","Richter-Rauzer, Podvebrady variation"},
tuple<uint64_t,string,string,string>{0xf34b78b676710a44,"B62","Sicilian","Richter-Rauzer, Margate (Alekhine) variation"},
tuple<uint64_t,string,string,string>{0x8c17154664f190f2,"B62","Sicilian","Richter-Rauzer, Richter attack"},
tuple<uint64_t,string,string,string>{0x60f205d5bca708b0,"B62","Sicilian","Richter-Rauzer, Keres variation"},
tuple<uint64_t,string,string,string>{0xe88de696d25c4667,"B63","Sicilian","Richter-Rauzer, Rauzer attack"},
tuple<uint64_t,string,string,string>{0xfc41957918f7eaf6,"B63","Sicilian","Richter-Rauzer, Rauzer attack, 7...Be7"},
tuple<uint64_t,string,string,string>{0x33d240e0871d310c,"B64","Sicilian","Richter-Rauzer, Rauzer attack, 7...Be7 defence, 9.f4"},
tuple<uint64_t,string,string,string>{0x370b9c31a3fddc61,"B64","Sicilian","Richter-Rauzer, Rauzer attack, Geller variation"},
tuple<uint64_t,string,string,string>{0x9eb1c566eb2c084f,"B65","Sicilian","Richter-Rauzer, Rauzer attack, 7...Be7 defence, 9...Nxd4"},
tuple<uint64_t,string,string,string>{0xb1fedf5895e33cee,"B65","Sicilian","Richter-Rauzer, Rauzer attack, 7...Be7 defence, 9...Nxd4"},
tuple<uint64_t,string,string,string>{0x3a7a1765357cbebb,"B66","Sicilian","Richter-Rauzer, Rauzer attack, 7...a6"},
tuple<uint64_t,string,string,string>{0xe096ac14bc046112,"B67","Sicilian","Richter-Rauzer, Rauzer attack, 7...a6 defence, 8...Bd7"},
tuple<uint64_t,string,string,string>{0x94ca2f66f3ef00a,"B68","Sicilian","Richter-Rauzer, Rauzer attack, 7...a6 defence, 9...Be7"},
tuple<uint64_t,string,string,string>{0xb2105b3eed55ab18,"B69","Sicilian","Richter-Rauzer, Rauzer attack, 7...a6 defence, 11.Bxf6"},
tuple<uint64_t,string,string,string>{0x32e187a7d153e515,"B70","Sicilian","dragon variation"},
tuple<uint64_t,string,string,string>{0xcff7faaac8c2d89c,"B71","Sicilian","dragon, Levenfish variation"},
tuple<uint64_t,string,string,string>{0xfc1481f7286a3550,"B71","Sicilian","dragon, Levenfish; Flohr variation"},
tuple<uint64_t,string,string,string>{0x41e93c4b5069fe9b,"B72","Sicilian","dragon, 6.Be3"},
tuple<uint64_t,string,string,string>{0x82d58204aa0b7f92,"B72","Sicilian","dragon, classical attack"},
tuple<uint64_t,string,string,string>{0x12015697a230531,"B72","Sicilian","dragon, classical, Amsterdam variation"},
tuple<uint64_t,string,string,string>{0x33a5bdfdfc58e342,"B72","Sicilian","dragon, classical, Grigoriev variation"},
tuple<uint64_t,string,string,string>{0xbd4962cbaa8d1c5b,"B72","Sicilian","dragon, classical, Nottingham variation"},
tuple<uint64_t,string,string,string>{0x574d21d2c7690181,"B73","Sicilian","dragon, classical, 8.O-O"},
tuple<uint64_t,string,string,string>{0x67559c2c5f4255d,"B73","Sicilian","dragon, classical, Zollner gambit"},
tuple<uint64_t,string,string,string>{0x75fd83ead38937ca,"B73","Sicilian","dragon, classical, Richter variation"},
tuple<uint64_t,string,string,string>{0xc994f44803272ea0,"B74","Sicilian","dragon, classical, 9.Nb3"},
tuple<uint64_t,string,string,string>{0x74ac080c2224d32e,"B74","Sicilian","dragon, classical, Stockholm attack"},
tuple<uint64_t,string,string,string>{0xc3d088f251311a75,"B74","Sicilian","dragon, classical, Spielmann variation"},
tuple<uint64_t,string,string,string>{0x835cb356d9b78ffa,"B74","Sicilian","dragon, classical, Bernard defence"},
tuple<uint64_t,string,string,string>{0xb2153eb93d72b396,"B74","Sicilian","dragon, classical, Reti-Tartakower variation"},
tuple<uint64_t,string,string,string>{0x4f8e418960bb2230,"B74","Sicilian","dragon, classical, Alekhine variation"},
tuple<uint64_t,string,string,string>{0x9fe4e7cc0be4da40,"B75","Sicilian","dragon, Yugoslav attack"},
tuple<uint64_t,string,string,string>{0x954c0a7bdebd33ab,"B76","Sicilian","dragon, Yugoslav attack, 7...O-O"},
tuple<uint64_t,string,string,string>{0x2e94d8355db74690,"B76","Sicilian","dragon, Yugoslav attack, Rauser variation"},
tuple<uint64_t,string,string,string>{0x750a293e26d69fae,"B77","Sicilian","dragon, Yugoslav attack, 9.Bc4"},
tuple<uint64_t,string,string,string>{0xf3109cff454a933e,"B77","Sicilian","dragon, Yugoslav attack, Byrne variation"},
tuple<uint64_t,string,string,string>{0x97cbd76cfc8c4f9f,"B77","Sicilian","dragon, Yugoslav attack, 9...Bd7"},
tuple<uint64_t,string,string,string>{0xafe6924fafae4007,"B78","Sicilian","dragon, Yugoslav attack, 10.O-O-O"},
tuple<uint64_t,string,string,string>{0x8869b3903cc79859,"B79","Sicilian","dragon, Yugoslav attack, 12.h4"},
tuple<uint64_t,string,string,string>{0xad2226cdb2fee70c,"B80","Sicilian","Scheveningen variation"},
tuple<uint64_t,string,string,string>{0x24c5235d155ddbfe,"B80","Sicilian","Scheveningen, English variation"},
tuple<uint64_t,string,string,string>{0x9efcf762d76a748f,"B80","Sicilian","Scheveningen, Vitolins variation"},
tuple<uint64_t,string,string,string>{0x81c49d8c52293f34,"B80","Sicilian","Scheveningen, fianchetto variation"},
tuple<uint64_t,string,string,string>{0xe6f271b5a8b0a11,"B81","Sicilian","Scheveningen, Keres attack"},
tuple<uint64_t,string,string,string>{0x50345bc0ab6fda85,"B82","Sicilian","Scheveningen, 6.f4"},
tuple<uint64_t,string,string,string>{0x263f3012dd129e22,"B82","Sicilian","Scheveningen, Tal variation"},
tuple<uint64_t,string,string,string>{0xdea2a534b3dbadaf,"B83","Sicilian","Scheveningen, 6.Be2"},
tuple<uint64_t,string,string,string>{0x754f7dd6a24a08ac,"B83","Sicilian","modern Scheveningen"},
tuple<uint64_t,string,string,string>{0x9b405e5b59e0b0c1,"B83","Sicilian","modern Scheveningen, main line"},
tuple<uint64_t,string,string,string>{0xedf0982492ada63a,"B83","Sicilian","modern Scheveningen, main line with Nb3"},
tuple<uint64_t,string,string,string>{0xc5554c754fb5573,"B84","Sicilian","Scheveningen (Paulsen), classical variation"},
tuple<uint64_t,string,string,string>{0x41c354aec8a063af,"B84","Sicilian","Scheveningen, classical, Nd7 system"},
tuple<uint64_t,string,string,string>{0x743f10d24443c162,"B84","Sicilian","Scheveningen (Paulsen), classical variation"},
tuple<uint64_t,string,string,string>{0x22c4b53d4c4359e8,"B85","Sicilian","Scheveningen, classical variation with ...Qc7 and ...Nc6"},
tuple<uint64_t,string,string,string>{0x6c6a8b940b9d82f8,"B85","Sicilian","Scheveningen, classical, Maroczy system"},
tuple<uint64_t,string,string,string>{0x51cc0ed1cd794266,"B85","Sicilian","Scheveningen, classical"},
tuple<uint64_t,string,string,string>{0xb7dd541901ba0065,"B85","Sicilian","Scheveningen, classical main line"},
tuple<uint64_t,string,string,string>{0xce9192e59abd31aa,"B86","Sicilian","Sozin attack"},
tuple<uint64_t,string,string,string>{0xb56619216d1624af,"B87","Sicilian","Sozin with ...a6 and ...b5"},
tuple<uint64_t,string,string,string>{0x657c4a078b2c94a9,"B88","Sicilian","Sozin, Leonhardt variation"},
tuple<uint64_t,string,string,string>{0x3c02029c8753a730,"B88","Sicilian","Sozin, Fischer variation"},
tuple<uint64_t,string,string,string>{0x1674f1eb0a168f27,"B89","Sicilian","Sozin, 7.Be3"},
tuple<uint64_t,string,string,string>{0x94be0d268ef97832,"B89","Sicilian","Velimirovic attack"},
tuple<uint64_t,string,string,string>{0x9a2250f4dfc8f82,"B90","Sicilian","Najdorf"},
tuple<uint64_t,string,string,string>{0xe151f8b18f5f4670,"B90","Sicilian","Najdorf, Adams attack"},
tuple<uint64_t,string,string,string>{0x6a11912765bf5924,"B90","Sicilian","Najdorf, Lipnitzky attack"},
tuple<uint64_t,string,string,string>{0x7aaa9ee3ccc6940c,"B90","Sicilian","Najdorf, Byrne (English) attack"},
tuple<uint64_t,string,string,string>{0x25449e4ead2b57ba,"B91","Sicilian","Najdorf, Zagreb (fianchetto) variation"},
tuple<uint64_t,string,string,string>{0x7a22a6f64cd9c521,"B92","Sicilian","Najdorf, Opovcensky variation"},
tuple<uint64_t,string,string,string>{0xf4b45802546db20b,"B93","Sicilian","Najdorf, 6.f4"},
tuple<uint64_t,string,string,string>{0xcff87239fd76544a,"B94","Sicilian","Najdorf, 6.Bg5"},
tuple<uint64_t,string,string,string>{0xe71152b568e66ab2,"B94","Sicilian","Najdorf, Ivkov variation"},
tuple<uint64_t,string,string,string>{0xb98f8008e554c418,"B95","Sicilian","Najdorf, 6...e6"},
tuple<uint64_t,string,string,string>{0x4499fd05fcc5f991,"B96","Sicilian","Najdorf, 7.f4"},
tuple<uint64_t,string,string,string>{0x249d9710676844ac,"B96","Sicilian","Najdorf, Polugayevsky variation"},
tuple<uint64_t,string,string,string>{0x634739a29c5bcc50,"B96","Sicilian","Najdorf, Polugayevsky, Simagin variation"},
tuple<uint64_t,string,string,string>{0x83660352368e2f4b,"B97","Sicilian","Najdorf, 7...Qb6"},
tuple<uint64_t,string,string,string>{0xb80cf946e9d31042,"B97","Sicilian","Najdorf, Poisoned pawn variation"},
tuple<uint64_t,string,string,string>{0x50558eea366e5500,"B98","Sicilian","Najdorf, 7...Be7"},
tuple<uint64_t,string,string,string>{0x2410e95d12322734,"B98","Sicilian","Najdorf, Browne variation"},
tuple<uint64_t,string,string,string>{0xa24c26a1eacd97bf,"B98","Sicilian","Najdorf, Goteborg (Argentine) variation"},
tuple<uint64_t,string,string,string>{0xec68caf876584cba,"B98","Sicilian","Najdorf variation"},
tuple<uint64_t,string,string,string>{0xe7a6f486c5d2aeee,"B99","Sicilian","Najdorf, 7...Be7 main line"},
tuple<uint64_t,string,string,string>{0xf44b6961e533d1c4,"C00","French defence",""},
tuple<uint64_t,string,string,string>{0x7868f645a63c7ac3,"C00","French defence, Steiner variation",""},
tuple<uint64_t,string,string,string>{0x78ed09353fbebaa9,"C00","French","Reti (Spielmann) variation"},
tuple<uint64_t,string,string,string>{0x95327f9ce12df7a0,"C00","French","Steinitz attack"},
tuple<uint64_t,string,string,string>{0x95d146cfca2ec4d,"C00","French","Labourdonnais variation"},
tuple<uint64_t,string,string,string>{0x2f2f85978dd5b0f9,"C00","French defence",""},
tuple<uint64_t,string,string,string>{0x87b8157c4ceebfe2,"C00","French","Wing gambit"},
tuple<uint64_t,string,string,string>{0xfdc71c327d1531d,"C00","French defence",""},
tuple<uint64_t,string,string,string>{0x77a02edaa29420b2,"C00","French","Pelikan variation"},
tuple<uint64_t,string,string,string>{0x51d2bf21d3e37c06,"C00","French","Two knights variation"},
tuple<uint64_t,string,string,string>{0x624de643ab778a40,"C00","French","Chigorin variation"},
tuple<uint64_t,string,string,string>{0x5aefaab4a1a36a10,"C00","French","King's Indian attack"},
tuple<uint64_t,string,string,string>{0xde0cb3da7222430d,"C00","French","Reversed Philidor formation"},
tuple<uint64_t,string,string,string>{0x317e46cbf4fafc86,"C00","French defence",""},
tuple<uint64_t,string,string,string>{0x8c4d0aa2682b5eb,"C00","Lengfellner system",""},
tuple<uint64_t,string,string,string>{0xe389b73813da045a,"C00","St. George defence",""},
tuple<uint64_t,string,string,string>{0xb41464df682eb2a0,"C00","French defence",""},
tuple<uint64_t,string,string,string>{0xe119c57d51ae70d3,"C00","French","Schlechter variation"},
tuple<uint64_t,string,string,string>{0xc71cdf33e914a92e,"C00","French","Alapin variation"},
tuple<uint64_t,string,string,string>{0x93cb6e92b241f0a6,"C01","French","exchange variation"},
tuple<uint64_t,string,string,string>{0xcafccc37777628ea,"C01","French","exchange, Svenonius variation"},
tuple<uint64_t,string,string,string>{0x611114d566e78de9,"C01","French","exchange, Bogolyubov variation"},
tuple<uint64_t,string,string,string>{0xd56d72226c3094c4,"C02","French","advance variation"},
tuple<uint64_t,string,string,string>{0x4cff815c706bc8d5,"C02","French","advance, Steinitz variation"},
tuple<uint64_t,string,string,string>{0x66a6d1224590c5b4,"C02","French","advance, Nimzovich variation"},
tuple<uint64_t,string,string,string>{0xe8784f7afb91fe84,"C02","French","advance, Nimzovich system"},
tuple<uint64_t,string,string,string>{0x45c65b144307903f,"C02","French","advance variation"},
tuple<uint64_t,string,string,string>{0xbb9cb7e73bf0f7e9,"C02","French","advance, Wade variation"},
tuple<uint64_t,string,string,string>{0xee2b83f65296353c,"C02","French","advance variation"},
tuple<uint64_t,string,string,string>{0x354f6f003a705401,"C02","French","advance, Paulsen attack"},
tuple<uint64_t,string,string,string>{0xa7bd30f5c9bb40a8,"C02","French","advance, Milner-Barry gambit"},
tuple<uint64_t,string,string,string>{0xd78e9152e02a8430,"C02","French","advance, Euwe variation"},
tuple<uint64_t,string,string,string>{0xed7adcbdf2d31a90,"C03","French","Tarrasch"},
tuple<uint64_t,string,string,string>{0x7915ba244c5b374e,"C03","French","Tarrasch, Haberditz variation"},
tuple<uint64_t,string,string,string>{0x4697045fe342bf93,"C03","French","Tarrasch, Guimard variation"},
tuple<uint64_t,string,string,string>{0xc61ddc5c265e9f38,"C04","French","Tarrasch, Guimard main line"},
tuple<uint64_t,string,string,string>{0xb694e8485f295b06,"C05","French","Tarrasch, closed variation"},
tuple<uint64_t,string,string,string>{0x80653c971ecf0584,"C05","French","Tarrasch, Botvinnik variation"},
tuple<uint64_t,string,string,string>{0x40e1ad65f1dd171c,"C05","French","Tarrasch, closed variation"},
tuple<uint64_t,string,string,string>{0xa7ed29d3c0aa7f02,"C06","French","Tarrasch, closed variation, main line"},
tuple<uint64_t,string,string,string>{0xb3217a83bbe1680c,"C06","French","Tarrasch, Leningrad variation"},
tuple<uint64_t,string,string,string>{0xb0b0d130d9411ed,"C07","French","Tarrasch, open variation"},
tuple<uint64_t,string,string,string>{0x90e340019b8de55f,"C07","French","Tarrasch, Eliskases variation"},
tuple<uint64_t,string,string,string>{0x13c0de9acd5e9320,"C08","French","Tarrasch, open, 4.ed ed"},
tuple<uint64_t,string,string,string>{0x6349ea8eb429571e,"C09","French","Tarrasch, open variation, main line"},
tuple<uint64_t,string,string,string>{0x4f837c7daacc3079,"C10","French","Paulsen variation"},
tuple<uint64_t,string,string,string>{0xa9f2add3558b3b04,"C10","French","Marshall variation"},
tuple<uint64_t,string,string,string>{0x8709e37463358029,"C10","French","Rubinstein variation"},
tuple<uint64_t,string,string,string>{0x6f885037e86a9082,"C10","French","Fort Knox variation"},
tuple<uint64_t,string,string,string>{0x1e28a6dac36bfc72,"C10","French","Rubinstein variation"},
tuple<uint64_t,string,string,string>{0xf2e78b894de6c473,"C10","French","Rubinstein, Capablanca line"},
tuple<uint64_t,string,string,string>{0xf219a9198b76049d,"C10","French","Frere (Becker) variation"},
tuple<uint64_t,string,string,string>{0x146d4888073671ef,"C11","French defence",""},
tuple<uint64_t,string,string,string>{0x4160e92a3eb6b39c,"C11","French","Swiss variation"},
tuple<uint64_t,string,string,string>{0x6765f364860c6a61,"C11","French","Henneberger variation"},
tuple<uint64_t,string,string,string>{0x75145e750328578b,"C11","French","Steinitz variation"},
tuple<uint64_t,string,string,string>{0x297ebae1fafa9b23,"C11","French","Steinitz, Bradford attack"},
tuple<uint64_t,string,string,string>{0x433a0b42babf9ae5,"C11","French","Steinitz variation"},
tuple<uint64_t,string,string,string>{0x5496542d25732fc9,"C11","French","Steinitz, Brodsky-Jones variation"},
tuple<uint64_t,string,string,string>{0x4c501d8620d409b7,"C11","French","Steinitz variation"},
tuple<uint64_t,string,string,string>{0x94b57e88b07fb73a,"C11","French","Steinitz, Boleslavsky variation"},
tuple<uint64_t,string,string,string>{0xd9e92f7d78030473,"C11","French","Steinitz, Gledhill attack"},
tuple<uint64_t,string,string,string>{0x1abd80b77e451a77,"C11","French","Burn variation"},
tuple<uint64_t,string,string,string>{0x1b7676b8fc4b6205,"C12","French","MacCutcheon variation"},
tuple<uint64_t,string,string,string>{0x2689ba28c4f60cc5,"C12","French","MacCutcheon, Bogolyubov variation"},
tuple<uint64_t,string,string,string>{0x7a0f6045f8554461,"C12","French","MacCutcheon, advance variation"},
tuple<uint64_t,string,string,string>{0xfc1cc55d56425f11,"C12","French","MacCutcheon, Chigorin variation"},
tuple<uint64_t,string,string,string>{0x14f60958a8da458c,"C12","French","MacCutcheon, Grigoriev variation"},
tuple<uint64_t,string,string,string>{0xb27743e09c3f2fef,"C12","French","MacCutcheon, Bernstein variation"},
tuple<uint64_t,string,string,string>{0xa57ce153f116483b,"C12","French","MacCutcheon, Janowski variation"},
tuple<uint64_t,string,string,string>{0x2ea27c15df0bd6bc,"C12","French","MacCutcheon, Dr. Olland (Dutch) variation"},
tuple<uint64_t,string,string,string>{0x6be03ac4f813144,"C12","French","MacCutcheon, Tartakower variation"},
tuple<uint64_t,string,string,string>{0xdec07b0cfff56abb,"C12","French","MacCutcheon, Lasker variation"},
tuple<uint64_t,string,string,string>{0xf0ded8d3fc104dc0,"C12","French","MacCutcheon, Duras variation"},
tuple<uint64_t,string,string,string>{0x13137c574d88c047,"C12","French","MacCutcheon, Lasker variation, 8...g6"},
tuple<uint64_t,string,string,string>{0xc6fb6c517d1706b6,"C13","French","classical"},
tuple<uint64_t,string,string,string>{0x63c46580a6095856,"C13","French","classical, Anderssen variation"},
tuple<uint64_t,string,string,string>{0x5e86dd01e2585752,"C13","French","classical, Anderssen-Richter variation"},
tuple<uint64_t,string,string,string>{0xfc6c4e59d4f36144,"C13","French","classical, Vistaneckis (Nimzovich) variation"},
tuple<uint64_t,string,string,string>{0xda81cd39b4e79390,"C13","French","classical, Frankfurt variation"},
tuple<uint64_t,string,string,string>{0x9d8a3633cb40ad28,"C13","French","classical, Tartakower variation"},
tuple<uint64_t,string,string,string>{0xc266e5237ffa5059,"C13","French","Albin-Alekhine-Chatard attack"},
tuple<uint64_t,string,string,string>{0x109114d098daa885,"C13","French","Albin-Alekhine-Chatard attack, Maroczy variation"},
tuple<uint64_t,string,string,string>{0x2417348d80bd5b24,"C13","French","Albin-Alekhine-Chatard attack, Breyer variation"},
tuple<uint64_t,string,string,string>{0xe33e36a45114726,"C13","French","Albin-Alekhine-Chatard attack, Teichmann variation"},
tuple<uint64_t,string,string,string>{0xc8ce0894aaa3b9b2,"C13","French","Albin-Alekhine-Chatard attack, Spielmann variation"},
tuple<uint64_t,string,string,string>{0x2d401dd965fe75de,"C14","French","classical variation"},
tuple<uint64_t,string,string,string>{0x784dbc7b5c7eb7ad,"C14","French","classical, Tarrasch variation"},
tuple<uint64_t,string,string,string>{0x5585256a447aa7e,"C14","French","classical, Rubinstein variation"},
tuple<uint64_t,string,string,string>{0xd996569f3c14e324,"C14","French","classical, Alapin variation"},
tuple<uint64_t,string,string,string>{0x78fa6f77b3192fd3,"C14","French","classical, Pollock variation"},
tuple<uint64_t,string,string,string>{0xd05660d47c6f4857,"C14","French","classical, Steinitz variation"},
tuple<uint64_t,string,string,string>{0x842cd817d571144a,"C14","French","classical, Stahlberg variation"},
tuple<uint64_t,string,string,string>{0x86c2157be13bf85b,"C15","French","Winawer (Nimzovich) variation"},
tuple<uint64_t,string,string,string>{0xbfc0e4a5b660659d,"C15","French","Winawer, Kondratiyev variation"},
tuple<uint64_t,string,string,string>{0xaf4f4fce735a935f,"C15","French","Winawer, fingerslip variation"},
tuple<uint64_t,string,string,string>{0x9266feb4c910f5a5,"C15","French","Winawer, Alekhine (Maroczy) gambit"},
tuple<uint64_t,string,string,string>{0x448752a04860f43f,"C15","French","Winawer, Alekhine gambit, Alatortsev variation"},
tuple<uint64_t,string,string,string>{0xb0492b9d541d99bf,"C15","French","Winawer, Alekhine gambit"},
tuple<uint64_t,string,string,string>{0xbd4ac1be0e0657b3,"C15","French","Winawer, Alekhine gambit, Kan variation"},
tuple<uint64_t,string,string,string>{0xe7bb0386e525de3f,"C16","French","Winawer, advance variation"},
tuple<uint64_t,string,string,string>{0xfa2846501c830b70,"C16","French","Winawer, Petrosian variation"},
tuple<uint64_t,string,string,string>{0x1cad2281a62d542,"C17","French","Winawer, advance variation"},
tuple<uint64_t,string,string,string>{0x2847889d8803be46,"C17","French","Winawer, advance, Bogolyubov variation"},
tuple<uint64_t,string,string,string>{0x5470a086cc858f4f,"C17","French","Winawer, advance, Russian variation"},
tuple<uint64_t,string,string,string>{0xca56e30e532e5b02,"C17","French","Winawer, advance, 5.a3"},
tuple<uint64_t,string,string,string>{0x680cd2d062e94438,"C17","French","Winawer, advance, Rauzer variation"},
tuple<uint64_t,string,string,string>{0xa0baf239e3cae648,"C18","French","Winawer, advance variation"},
tuple<uint64_t,string,string,string>{0xa6a5cd188f81a949,"C18","French","Winawer, classical variation"},
tuple<uint64_t,string,string,string>{0x9ef54e8458436df5,"C19","French","Winawer, advance, 6...Ne7"},
tuple<uint64_t,string,string,string>{0xc67627e4d3bbb372,"C19","French","Winawer, advance, Smyslov variation"},
tuple<uint64_t,string,string,string>{0x4591a27230a50cc8,"C19","French","Winawer, advance, positional main line"},
tuple<uint64_t,string,string,string>{0xcb4f3c2a8ea437f8,"C19","French","Winawer, advance, poisoned pawn variation"},
tuple<uint64_t,string,string,string>{0x8b1107784cefb7c9,"C19","French","Winawer, advance, poisoned pawn, Euwe-Gligoric variation"},
tuple<uint64_t,string,string,string>{0xc8d4778bde03d279,"C19","French","Winawer, advance, poisoned pawn, Konstantinopolsky variation"},
tuple<uint64_t,string,string,string>{0x844931a6ef4b9a0,"C20","King's pawn game",""},
tuple<uint64_t,string,string,string>{0xa6e050cf2a640274,"C20","KP","Indian opening"},
tuple<uint64_t,string,string,string>{0xc3d8a23c27b837e0,"C20","KP","Mengarini's opening"},
tuple<uint64_t,string,string,string>{0x66f5752bce3e56d1,"C20","KP","King's head opening"},
tuple<uint64_t,string,string,string>{0xa849703c42999f3c,"C20","KP","Patzer opening"},
tuple<uint64_t,string,string,string>{0xb266e8294289ef1b,"C20","KP","Napoleon's opening"},
tuple<uint64_t,string,string,string>{0x7e9e6b82be84b626,"C20","KP","Lopez opening"},
tuple<uint64_t,string,string,string>{0x1ce078d546dfb45e,"C20","Alapin's opening",""},
tuple<uint64_t,string,string,string>{0x560fb632bb4680f7,"C21","Centre game",""},
tuple<uint64_t,string,string,string>{0x68ad55579f09812c,"C21","Centre game, Kieseritsky variation",""},
tuple<uint64_t,string,string,string>{0xab19cb3fa2d7bd7e,"C21","Halasz gambit",""},
tuple<uint64_t,string,string,string>{0x20d54eaa6b368f71,"C21","Danish gambit",""},
tuple<uint64_t,string,string,string>{0xa4e04ae20fa23855,"C21","Danish gambit","Collijn defence"},
tuple<uint64_t,string,string,string>{0xba75b786524ad819,"C21","Danish gambit","Schlechter defence"},
tuple<uint64_t,string,string,string>{0xa5bf6cbef7e2c157,"C21","Danish gambit","Soerensen defence"},
tuple<uint64_t,string,string,string>{0x2bb8a1f68fd76fca,"C21","Centre game",""},
tuple<uint64_t,string,string,string>{0x805579149e46cac9,"C22","Centre game",""},
tuple<uint64_t,string,string,string>{0x34f0f036da4cb529,"C22","Centre game","Paulsen attack"},
tuple<uint64_t,string,string,string>{0xae305deb6fb09337,"C22","Centre game","Charousek variation"},
tuple<uint64_t,string,string,string>{0xa09f96af64c498f7,"C22","Centre game","l'Hermet variation"},
tuple<uint64_t,string,string,string>{0x6f1ec4c377b6f4bf,"C22","Centre game","Berger variation"},
tuple<uint64_t,string,string,string>{0x6b5678c06ad736a0,"C22","Centre game","Kupreichik variation"},
tuple<uint64_t,string,string,string>{0x7627916466b956c6,"C22","Centre game","Hall variation"},
tuple<uint64_t,string,string,string>{0x6bf7273246b76f06,"C23","Bishop's opening",""},
tuple<uint64_t,string,string,string>{0xf98dcadd3177bcbd,"C23","Bishop's opening","Philidor counter-attack"},
tuple<uint64_t,string,string,string>{0x55968f7f5baf82a6,"C23","Bishop's opening","Lisitsyn variation"},
tuple<uint64_t,string,string,string>{0xff9841abf83f42d8,"C23","Bishop's opening","Calabrese counter-gambit"},
tuple<uint64_t,string,string,string>{0x513c827ebcaff90c,"C23","Bishop's opening","Calabrese counter-gambit, Jaenisch variation"},
tuple<uint64_t,string,string,string>{0xc6ea63698c858585,"C23","Bishop's opening","Classical variation"},
tuple<uint64_t,string,string,string>{0x2b2385c9b74b089b,"C23","Bishop's opening","Lopez gambit"},
tuple<uint64_t,string,string,string>{0xb0309bf15cf58a03,"C23","Bishop's opening","Philidor variation"},
tuple<uint64_t,string,string,string>{0xbd9348443bf1dfeb,"C23","Bishop's opening","Pratt variation"},
tuple<uint64_t,string,string,string>{0x355ab9e5c021c425,"C23","Bishop's opening","Lewis counter-gambit"},
tuple<uint64_t,string,string,string>{0xf2cdfcd87be9bbf3,"C23","Bishop's opening","del Rio variation"},
tuple<uint64_t,string,string,string>{0x3df4cc39d4ca8c7,"C23","Bishop's opening","Lewis gambit"},
tuple<uint64_t,string,string,string>{0x6c1f16c52a33e9a1,"C23","Bishop's opening","Wing gambit"},
tuple<uint64_t,string,string,string>{0xaee58587d80f3b38,"C23","Bishop's opening","MacDonnell double gambit"},
tuple<uint64_t,string,string,string>{0xd6023f8abfd1ee96,"C23","Bishop's opening","Four pawns' gambit"},
tuple<uint64_t,string,string,string>{0x301913c7eb4d2e90,"C24","Bishop's opening","Berlin defence"},
tuple<uint64_t,string,string,string>{0xcd0f6ecaf2dc1319,"C24","Bishop's opening","Greco gambit"},
tuple<uint64_t,string,string,string>{0xf52c3c6dfa8403d2,"C24","Bishop's opening","Ponziani gambit"},
tuple<uint64_t,string,string,string>{0xb536da19561976fa,"C24","Bishop's opening","Urusov gambit"},
tuple<uint64_t,string,string,string>{0x33e7bcae4a191314,"C24","Bishop's opening","Urusov gambit, Panov variation"},
tuple<uint64_t,string,string,string>{0xf3d38bb8ac163b79,"C25","Vienna game",""},
tuple<uint64_t,string,string,string>{0x34c6a4e59cfce8c0,"C25","Vienna","Zhuravlev countergambit"},
tuple<uint64_t,string,string,string>{0x583e535abd879e7a,"C25","Vienna game, Max Lange defence",""},
tuple<uint64_t,string,string,string>{0x74d8e81b5d504642,"C25","Vienna","Paulsen variation"},
tuple<uint64_t,string,string,string>{0x9d0b7cf0ac4eb338,"C25","Vienna","Fyfe gambit"},
tuple<uint64_t,string,string,string>{0xa5282e57a416a3f3,"C25","Vienna gambit",""},
tuple<uint64_t,string,string,string>{0x89973b6384108965,"C25","Vienna","Steinitz gambit"},
tuple<uint64_t,string,string,string>{0x659014dc3b530976,"C25","Vienna","Steinitz gambit, Zukertort defence"},
tuple<uint64_t,string,string,string>{0x8b937fd85904f0cb,"C25","Vienna","Steinitz gambit, Fraser-Minckwitz variation"},
tuple<uint64_t,string,string,string>{0x97c6f83ffd3fc51a,"C25","Vienna gambit",""},
tuple<uint64_t,string,string,string>{0xd912199feaf73b25,"C25","Vienna","Hamppe-Allgaier gambit"},
tuple<uint64_t,string,string,string>{0xe0a88ffe388f7248,"C25","Vienna","Hamppe-Allgaier gambit, Alapin variation"},
tuple<uint64_t,string,string,string>{0xea5ab7fbcb4b749,"C25","Vienna","Hamppe-Muzio gambit"},
tuple<uint64_t,string,string,string>{0x2df4a887b7d80317,"C25","Vienna","Hamppe-Muzio, Dubois variation"},
tuple<uint64_t,string,string,string>{0xd2b02748784217d2,"C25","Vienna","Pierce gambit"},
tuple<uint64_t,string,string,string>{0x12c7704e8235e903,"C25","Vienna","Pierce gambit, Rushmere attack"},
tuple<uint64_t,string,string,string>{0xa83dbf4d01ec7aef,"C26","Vienna","Falkbeer variation"},
tuple<uint64_t,string,string,string>{0x63a18e6b48a0f4af,"C26","Vienna","Mengarini variation"},
tuple<uint64_t,string,string,string>{0x84db040ce13ba2d7,"C26","Vienna","Paulsen-Mieses variation"},
tuple<uint64_t,string,string,string>{0xcb8e0b6529afac49,"C26","Vienna game",""},
tuple<uint64_t,string,string,string>{0x7639453c2f780b5a,"C27","Vienna game",""},
tuple<uint64_t,string,string,string>{0xc5a36f46d7c55be0,"C27","Vienna","`Frankenstein-Dracula' variation"},
tuple<uint64_t,string,string,string>{0xd590f8db845cce51,"C27","Vienna","Adams' gambit"},
tuple<uint64_t,string,string,string>{0xaf847c7c4eafea81,"C27","Vienna game",""},
tuple<uint64_t,string,string,string>{0x614ebc9393c68b89,"C27","Vienna","Alekhine variation"},
tuple<uint64_t,string,string,string>{0xad5da9ca479e6a67,"C27","Boden-Kieseritsky gambit",""},
tuple<uint64_t,string,string,string>{0x28378bdedb4a2441,"C27","Boden-Kieseritsky gambit","Lichtenhein defence"},
tuple<uint64_t,string,string,string>{0x6063d387383e094a,"C28","Vienna game",""},
tuple<uint64_t,string,string,string>{0xd041e05484a90940,"C29","Vienna gambit",""},
tuple<uint64_t,string,string,string>{0xaed80f488f356e94,"C29","Vienna gambit","Kaufmann variation"},
tuple<uint64_t,string,string,string>{0x2ec139b74c5f976b,"C29","Vienna gambit","Breyer variation"},
tuple<uint64_t,string,string,string>{0x5b4bdd9dc26f0c7c,"C29","Vienna gambit","Paulsen attack"},
tuple<uint64_t,string,string,string>{0x1fc0f97e29f3dad0,"C29","Vienna gambit","Bardeleben variation"},
tuple<uint64_t,string,string,string>{0xa1194ae6d2e0ce0,"C29","Vienna gambit","Heyde variation"},
tuple<uint64_t,string,string,string>{0x4fcd657baa82e113,"C29","Vienna gambit",""},
tuple<uint64_t,string,string,string>{0x6e2e1ec493eb6598,"C29","Vienna gambit, Wurzburger trap",""},
tuple<uint64_t,string,string,string>{0x7ee52381c039b294,"C29","Vienna gambit, Steinitz variation",""},
tuple<uint64_t,string,string,string>{0xf552ee1777658429,"C30","King's gambit",""},
tuple<uint64_t,string,string,string>{0xba9dac8cf9a97772,"C30","KGD","Keene's defence"},
tuple<uint64_t,string,string,string>{0x13233fb988228f54,"C30","KGD","Mafia defence"},
tuple<uint64_t,string,string,string>{0xf26a73d0128cc7c4,"C30","KGD","Norwalde variation"},
tuple<uint64_t,string,string,string>{0x5e1bece02c4ae808,"C30","KGD","Norwalde variation, Buecker gambit"},
tuple<uint64_t,string,string,string>{0x584faa4cbd576eaa,"C30","KGD","classical variation"},
tuple<uint64_t,string,string,string>{0x985a0e5c7f58f0b6,"C30","KGD","classical, Svenonius variation"},
tuple<uint64_t,string,string,string>{0x72e5b324258329ef,"C30","KGD","classical, Hanham variation"},
tuple<uint64_t,string,string,string>{0xcc4b2843d7b9497c,"C30","KGD","classical, 4.c3"},
tuple<uint64_t,string,string,string>{0xaa8657728d200ff0,"C30","KGD","classical, Marshall attack"},
tuple<uint64_t,string,string,string>{0x58244eda693164a2,"C30","KGD","classical counter-gambit"},
tuple<uint64_t,string,string,string>{0xd366d79649e2314e,"C30","KGD","classical, Reti variation"},
tuple<uint64_t,string,string,string>{0x360ed8786ba5b26e,"C30","KGD","classical, Soldatenkov variation"},
tuple<uint64_t,string,string,string>{0x1064a577a17f2ade,"C30","KGD","classical, Heath variation"},
tuple<uint64_t,string,string,string>{0xaebcdae2da9fc5bf,"C30","KGD","2...Nf6"},
tuple<uint64_t,string,string,string>{0x7038cc03ebb1ca0f,"C31","KGD","Falkbeer counter-gambit"},
tuple<uint64_t,string,string,string>{0xab5c20f58357ab32,"C31","KGD","Falkbeer, Tartakower variation"},
tuple<uint64_t,string,string,string>{0x8bafd4a1295348d6,"C31","KGD","Falkbeer, Milner-Barry variation"},
tuple<uint64_t,string,string,string>{0x57e7c64e31de8809,"C31","KGD","Falkbeer counter-gambit"},
tuple<uint64_t,string,string,string>{0xc59d2ba1461e5bb2,"C31","KGD","Nimzovich counter-gambit"},
tuple<uint64_t,string,string,string>{0x78e1fb2003db57ff,"C31","KGD","Falkbeer, 3...e4"},
tuple<uint64_t,string,string,string>{0x4e9e58552287cf34,"C31","KGD","Falkbeer, Rubinstein variation"},
tuple<uint64_t,string,string,string>{0x4b3f2a8f664fc47c,"C31","KGD","Falkbeer, Nimzovich variation"},
tuple<uint64_t,string,string,string>{0xd64538f5474bec2b,"C31","KGD","Falkbeer, 4.d3"},
tuple<uint64_t,string,string,string>{0x584a41d5444d2438,"C31","KGD","Falkbeer, Morphy gambit"},
tuple<uint64_t,string,string,string>{0x34d834ae81c675c9,"C32","KGD","Falkbeer, 5.de"},
tuple<uint64_t,string,string,string>{0xb60e32a6b341be1c,"C32","KGD","Falkbeer, Alapin variation"},
tuple<uint64_t,string,string,string>{0xea0934f6dc640b6d,"C32","KGD","Falkbeer, main line, 7...Bf5"},
tuple<uint64_t,string,string,string>{0x43ecd897e1480f9b,"C32","KGD","Falkbeer, Tarrasch variation"},
tuple<uint64_t,string,string,string>{0x1f69f5d5c955895e,"C32","KGD","Falkbeer, Charousek gambit"},
tuple<uint64_t,string,string,string>{0xf509fbd2dcc79c67,"C32","KGD","Falkbeer, Charousek variation"},
tuple<uint64_t,string,string,string>{0xd4c5b462704c058d,"C32","KGD","Falkbeer, Keres variation"},
tuple<uint64_t,string,string,string>{0x1bad8322a4f5f639,"C32","KGD","Falkbeer, Reti variation"},
tuple<uint64_t,string,string,string>{0x1cd8d48946aa83fd,"C33","King's gambit accepted",""},
tuple<uint64_t,string,string,string>{0x64f51687b15a6e58,"C33","KGA","Tumbleweed gambit"},
tuple<uint64_t,string,string,string>{0x907eb4dd9c27e890,"C33","KGA","Orsini gambit"},
tuple<uint64_t,string,string,string>{0x807b48a0ed95fa83,"C33","KGA","Pawn's gambit (Stamma gambit)"},
tuple<uint64_t,string,string,string>{0x49d5752b7f2a418e,"C33","KGA","Schurig gambit"},
tuple<uint64_t,string,string,string>{0x8ade5bab08eed879,"C33","KGA","Carrera (Basman) gambit"},
tuple<uint64_t,string,string,string>{0xd9edfb235763aebf,"C33","KGA","Villemson (Steinitz) gambit"},
tuple<uint64_t,string,string,string>{0xe74fcc2b84480124,"C33","KGA","Keres (Mason-Steinitz) gambit"},
tuple<uint64_t,string,string,string>{0xa6faafba6ad7d546,"C33","KGA","Breyer gambit"},
tuple<uint64_t,string,string,string>{0x6f585770478fc95e,"C33","KGA","Lesser bishop's (Petroff-Jaenisch-Tartakower) gambit"},
tuple<uint64_t,string,string,string>{0x7f6b60a16ee9555b,"C33","KGA","bishop's gambit"},
tuple<uint64_t,string,string,string>{0x564cd70e15bf3469,"C33","KGA","bishop's gambit, Chigorin's attack"},
tuple<uint64_t,string,string,string>{0x90e4413301ac4134,"C33","KGA","bishop's gambit, Greco variation"},
tuple<uint64_t,string,string,string>{0xbdbaf5b55f2a543d,"C33","KGA","bishop's gambit, classical defence"},
tuple<uint64_t,string,string,string>{0x6b677f97a1205f05,"C33","KGA","bishop's gambit, Grimm attack"},
tuple<uint64_t,string,string,string>{0xdeb43b6cccfbbb1,"C33","KGA","bishop's gambit, classical defence"},
tuple<uint64_t,string,string,string>{0x210df8f72c186389,"C33","KGA","bishop's gambit, McDonnell attack"},
tuple<uint64_t,string,string,string>{0xda776be08658c576,"C33","KGA","bishop's gambit, McDonnell attack"},
tuple<uint64_t,string,string,string>{0xa03e02ff1818f613,"C33","KGA","bishop's gambit, Fraser variation"},
tuple<uint64_t,string,string,string>{0x7988e8673570286,"C33","KGA","bishop's gambit, classical defence, Cozio attack"},
tuple<uint64_t,string,string,string>{0x9614dd8ada0f0eb4,"C33","KGA","bishop's gambit, Boden defence"},
tuple<uint64_t,string,string,string>{0x5dfd6f7d5033168a,"C33","KGA","bishop's gambit, Bryan counter-gambit"},
tuple<uint64_t,string,string,string>{0x1f6f0ab4f544e866,"C33","KGA","bishop's gambit, Bryan counter-gambit"},
tuple<uint64_t,string,string,string>{0x4124dc1cd560dee6,"C33","KGA","bishop's gambit, Steinitz defence"},
tuple<uint64_t,string,string,string>{0xd486b8437f78f058,"C33","KGA","bishop's gambit, Maurian defence"},
tuple<uint64_t,string,string,string>{0xed118d4e192986e0,"C33","KGA","bishop's gambit, Ruy Lopez defence"},
tuple<uint64_t,string,string,string>{0xeb040638d0617885,"C33","KGA","bishop's gambit, Lopez-Gianutio counter-gambit"},
tuple<uint64_t,string,string,string>{0x64f91812753b320a,"C33","KGA","Lopez-Gianutio counter-gambit, Hein variation"},
tuple<uint64_t,string,string,string>{0xfa0142b5f23d1b7d,"C33","KGA","bishop's gambit, Bledow variation"},
tuple<uint64_t,string,string,string>{0x564cd70e15bf3469,"C33","KGA","bishop's gambit, Gifford variation"},
tuple<uint64_t,string,string,string>{0x5eb1f110bec6c2ff,"C33","KGA","bishop's gambit, Boren-Svenonius variation"},
tuple<uint64_t,string,string,string>{0x2a0114b4b36b3e8c,"C33","KGA","bishop's gambit, Anderssen variation"},
tuple<uint64_t,string,string,string>{0xe395cdae6951aca1,"C33","KGA","bishop's gambit, Morphy variation"},
tuple<uint64_t,string,string,string>{0x24855454c31314cd,"C33","KGA","bishop's gambit, Cozio (Morphy) defence"},
tuple<uint64_t,string,string,string>{0xdf124cf601f19614,"C33","KGA","bishop's gambit, Bogolyubov variation"},
tuple<uint64_t,string,string,string>{0x772a330d4e187852,"C33","KGA","bishop's gambit, Paulsen attack"},
tuple<uint64_t,string,string,string>{0x4d68a119763145af,"C33","KGA","bishop's gambit, Jaenisch variation"},
tuple<uint64_t,string,string,string>{0xc7bc387f2e4ce2c0,"C34","King's knight's gambit",""},
tuple<uint64_t,string,string,string>{0xf9f384c295c5697d,"C34","KGA","Bonsch-Osmolovsky variation"},
tuple<uint64_t,string,string,string>{0x53d35ee690c4cf1e,"C34","KGA","Gianutio counter-gambit"},
tuple<uint64_t,string,string,string>{0xfe06ae1efc34abad,"C34","KGA","Fischer defence"},
tuple<uint64_t,string,string,string>{0x554b7319b998abd5,"C34","KGA","Becker defence"},
tuple<uint64_t,string,string,string>{0x9c520c8a83b6a356,"C34","KGA","Schallop defence"},
tuple<uint64_t,string,string,string>{0xd3704b90e4e74e51,"C35","KGA","Cunningham defence"},
tuple<uint64_t,string,string,string>{0x94d169d8686ce5d3,"C35","KGA","Cunningham, Bertin gambit"},
tuple<uint64_t,string,string,string>{0x1aa48034cde1e748,"C35","KGA","Cunningham, three pawns gambit"},
tuple<uint64_t,string,string,string>{0xeb2dcb4d615ed961,"C35","KGA","Cunningham, Euwe defence"},
tuple<uint64_t,string,string,string>{0x42d61a6bb298ace6,"C36","KGA","Abbazia defence (classical defence, modern defence[!])"},
tuple<uint64_t,string,string,string>{0x3ee724d3c50daf76,"C36","KGA","Abbazia defence, modern variation"},
tuple<uint64_t,string,string,string>{0x2462e29b8257024b,"C36","KGA","Abbazia defence, Botvinnik variation"},
tuple<uint64_t,string,string,string>{0xbc68d000781a9f93,"C37","KGA","Quaade gambit"},
tuple<uint64_t,string,string,string>{0x82cae708ab313008,"C37","KGA","Rosentreter gambit"},
tuple<uint64_t,string,string,string>{0x5b1454467133d511,"C37","KGA","Soerensen gambit"},
tuple<uint64_t,string,string,string>{0x244c7c8a92bbcbec,"C37","KGA","King's knight's gambit"},
tuple<uint64_t,string,string,string>{0x8fa1a468832a6eef,"C37","KGA","Blachly gambit"},
tuple<uint64_t,string,string,string>{0x81194027fbd5e9f6,"C37","KGA","Lolli gambit (wild Muzio gambit)"},
tuple<uint64_t,string,string,string>{0xac024bc70955c127,"C37","KGA","Lolli gambit, Young variation"},
tuple<uint64_t,string,string,string>{0xe59f3fa102fd66c1,"C37","KGA","Ghulam Kassim gambit"},
tuple<uint64_t,string,string,string>{0xdb3d08a9d1d6c95a,"C37","KGA","MacDonnell gambit"},
tuple<uint64_t,string,string,string>{0xfd92cfc448b92ef5,"C37","KGA","Salvio gambit"},
tuple<uint64_t,string,string,string>{0x8b4bb3593eb61783,"C37","KGA","Silberschmidt gambit"},
tuple<uint64_t,string,string,string>{0xc2038c2294fdd94f,"C37","KGA","Salvio gambit, Anderssen counter-attack"},
tuple<uint64_t,string,string,string>{0xcff2031795fd57b8,"C37","KGA","Cochrane gambit"},
tuple<uint64_t,string,string,string>{0x14ed72effc5f751a,"C37","KGA","Herzfeld gambit"},
tuple<uint64_t,string,string,string>{0x5edf6b3f6fc79093,"C37","KGA","Muzio gambit"},
tuple<uint64_t,string,string,string>{0xe6385b99ed0b5896,"C37","KGA","Muzio gambit, Paulsen variation"},
tuple<uint64_t,string,string,string>{0x8871e46c5930e14,"C37","KGA","double Muzio gambit"},
tuple<uint64_t,string,string,string>{0xb23e90bf88227132,"C37","KGA","Muzio gambit, From defence"},
tuple<uint64_t,string,string,string>{0x822c972d588f7a5b,"C37","KGA","Muzio gambit, Holloway defence"},
tuple<uint64_t,string,string,string>{0xc520b44faefb3ef9,"C37","KGA","Muzio gambit, Kling and Horwitz counter-attack"},
tuple<uint64_t,string,string,string>{0xdbb5492bf313deb5,"C37","KGA","Muzio gambit, Brentano defence"},
tuple<uint64_t,string,string,string>{0x94f0413c69fc0046,"C38","King's knight's gambit",""},
tuple<uint64_t,string,string,string>{0xea853a08150fdb56,"C38","KGA","Hanstein gambit"},
tuple<uint64_t,string,string,string>{0x853dd15c2c37938,"C38","KGA","Philidor gambit"},
tuple<uint64_t,string,string,string>{0xade14caae2bfb01f,"C38","KGA","Greco gambit"},
tuple<uint64_t,string,string,string>{0xc64c837439e4c575,"C38","KGA","Philidor gambit, Schultz variation"},
tuple<uint64_t,string,string,string>{0xdb5c548b11c76434,"C39","King's knight's gambit",""},
tuple<uint64_t,string,string,string>{0x8968d9df39841cff,"C39","KGA","Allgaier gambit"},
tuple<uint64_t,string,string,string>{0x9ea6c0133df3387d,"C39","KGA","Allgaier, Horny defence"},
tuple<uint64_t,string,string,string>{0x746846d1ef1d9973,"C39","KGA","Allgaier, Thorold variation"},
tuple<uint64_t,string,string,string>{0x48fea0d63e2de06c,"C39","KGA","Allgaier, Cook variation"},
tuple<uint64_t,string,string,string>{0x4aca71d93c3636e8,"C39","KGA","Allgaier, Blackburne gambit"},
tuple<uint64_t,string,string,string>{0xd2eedd53d6976297,"C39","KGA","Allgaier, Walker attack"},
tuple<uint64_t,string,string,string>{0x856920a559b2bbaa,"C39","KGA","Allgaier, Urusov attack"},
tuple<uint64_t,string,string,string>{0xd286ed2a947e5d69,"C39","KGA","Allgaier, Schlechter defence"},
tuple<uint64_t,string,string,string>{0xb23eda7330824a87,"C39","KGA","Kieseritsky, Paulsen defence"},
tuple<uint64_t,string,string,string>{0x1fdc79becce5205a,"C39","KGA","Kieseritsky, long whip (Stockwhip, classical) defence"},
tuple<uint64_t,string,string,string>{0xe23afe58229c0d96,"C39","KGA","Kieseritsky, long whip defence, Jaenisch variation"},
tuple<uint64_t,string,string,string>{0x87e8c5d15711cf0b,"C39","KGA","Kieseritsky, Brentano (Campbell) defence"},
tuple<uint64_t,string,string,string>{0xf03bb643963a3b4d,"C39","KGA","Kieseritsky, Brentano defence, Kaplanek variation"},
tuple<uint64_t,string,string,string>{0xb96238a330463378,"C39","KGA","Kieseritsky, Brentano defence"},
tuple<uint64_t,string,string,string>{0x5dbbce98ac6c3c5b,"C39","KGA","Kieseritsky, Brentano defence, Caro variation"},
tuple<uint64_t,string,string,string>{0x997d38b50af92f47,"C39","KGA","Kieseritsky, Salvio (Rosenthal) defence"},
tuple<uint64_t,string,string,string>{0xab94c5ae8dfbf97d,"C39","KGA","Kieseritsky, Salvio defence, Cozio variation"},
tuple<uint64_t,string,string,string>{0x164e942a016e2dbc,"C39","KGA","Kieseritsky, Polerio defence"},
tuple<uint64_t,string,string,string>{0xa96f3f27da54242e,"C39","KGA","Kieseritsky, Neumann defence"},
tuple<uint64_t,string,string,string>{0x3b3871a419bdc840,"C39","KGA","Kieseritsky, Kolisch defence"},
tuple<uint64_t,string,string,string>{0x596cd330663fc0bb,"C39","KGA","Kieseritsky, Berlin defence"},
tuple<uint64_t,string,string,string>{0x6dd0cef4e508e23,"C39","KGA","Kieseritsky, Berlin defence, Riviere variation"},
tuple<uint64_t,string,string,string>{0x3adf67184e7c161d,"C39","KGA","Kieseritsky, Berlin defence, 6.Bc4"},
tuple<uint64_t,string,string,string>{0x424759f7ab2e1009,"C39","KGA","Kieseritsky, Rice gambit"},
tuple<uint64_t,string,string,string>{0xd3207fec0612d89d,"C40","King's knight opening",""},
tuple<uint64_t,string,string,string>{0x48dfa09cc72e76f7,"C40","Gunderam defence",""},
tuple<uint64_t,string,string,string>{0xd418e22b63fb9b70,"C40","Greco defence",""},
tuple<uint64_t,string,string,string>{0x1f7579a53cf9cfe2,"C40","Damiano's defence",""},
tuple<uint64_t,string,string,string>{0x564a5df89ac696bb,"C40","QP counter-gambit (elephant gambit)",""},
tuple<uint64_t,string,string,string>{0xd5cd3a379fb30599,"C40","QP counter-gambit","Maroczy gambit"},
tuple<uint64_t,string,string,string>{0x474f1975b89af543,"C40","Latvian counter-gambit",""},
tuple<uint64_t,string,string,string>{0x2059725d6b6e9785,"C40","Latvian","Nimzovich variation"},
tuple<uint64_t,string,string,string>{0x52e1356c0d15f576,"C40","Latvian","Fraser defence"},
tuple<uint64_t,string,string,string>{0x24fcad5d90d923e5,"C40","Latvian gambit, 3.Bc4",""},
tuple<uint64_t,string,string,string>{0xb1d315d13a7e33e1,"C40","Latvian","Behting variation"},
tuple<uint64_t,string,string,string>{0xddc6d3b4ecc2f73e,"C40","Latvian","Polerio variation"},
tuple<uint64_t,string,string,string>{0x342c555ddecf88e,"C40","Latvian","corkscrew counter-gambit"},
tuple<uint64_t,string,string,string>{0xea9ae98dd46a91f0,"C41","Philidor's defence",""},
tuple<uint64_t,string,string,string>{0xeb3fd6d2e6f2e441,"C41","Philidor","Steinitz variation"},
tuple<uint64_t,string,string,string>{0x1d463b3c42a16a88,"C41","Philidor","Lopez counter-gambit"},
tuple<uint64_t,string,string,string>{0xf6e9af1ac6abd05b,"C41","Philidor","Lopez counter-gambit, Jaenisch variation"},
tuple<uint64_t,string,string,string>{0x2fafc627c5a3bcb2,"C41","Philidor's defence",""},
tuple<uint64_t,string,string,string>{0xbbc0a0be7b2b916c,"C41","Philidor","Philidor counter-gambit"},
tuple<uint64_t,string,string,string>{0x745f98cf8f7d69f8,"C41","Philidor","Philidor counter-gambit, del Rio attack"},
tuple<uint64_t,string,string,string>{0x22d5c43687ad01a2,"C41","Philidor","Philidor counter-gambit, Berger variation"},
tuple<uint64_t,string,string,string>{0x4057b81cb9c913b5,"C41","Philidor","Philidor counter-gambit, Zukertort variation"},
tuple<uint64_t,string,string,string>{0xb4d1cca501d8a8a7,"C41","Philidor","exchange variation"},
tuple<uint64_t,string,string,string>{0x2ba72533ef1397ab,"C41","Philidor","Boden variation"},
tuple<uint64_t,string,string,string>{0xd34591f810e93a89,"C41","Philidor","exchange variation"},
tuple<uint64_t,string,string,string>{0xb09c096a2b0dfacd,"C41","Philidor","Paulsen attack"},
tuple<uint64_t,string,string,string>{0x88aba50dbd137b1f,"C41","Philidor","exchange variation"},
tuple<uint64_t,string,string,string>{0x450083134e4c306a,"C41","Philidor","Berger variation"},
tuple<uint64_t,string,string,string>{0x3af1c2a36b66a8c2,"C41","Philidor","Larsen variation"},
tuple<uint64_t,string,string,string>{0x7441f2d26859fd24,"C41","Philidor","Nimzovich (Jaenisch) variation"},
tuple<uint64_t,string,string,string>{0xbc35912d4a139231,"C41","Philidor","Improved Hanham variation"},
tuple<uint64_t,string,string,string>{0x4b5cd6ca913d9319,"C41","Philidor","Nimzovich, Sozin variation"},
tuple<uint64_t,string,string,string>{0x36830aa43c8f5b3c,"C41","Philidor","Nimzovich, Larobok variation"},
tuple<uint64_t,string,string,string>{0xe8dc0d90606c4a54,"C41","Philidor","Nimzovich variation"},
tuple<uint64_t,string,string,string>{0xc05fbabfc464577,"C41","Philidor","Nimzovich, Sokolsky variation"},
tuple<uint64_t,string,string,string>{0xce62188d855afbd5,"C41","Philidor","Nimzovich, Rellstab variation"},
tuple<uint64_t,string,string,string>{0x22931307c1950580,"C41","Philidor","Nimzovich, Locock variation"},
tuple<uint64_t,string,string,string>{0x17f246fa401a2b82,"C41","Philidor","Nimzovich, Klein variation"},
tuple<uint64_t,string,string,string>{0x1c4cbd7a250b517e,"C41","Philidor","Hanham variation"},
tuple<uint64_t,string,string,string>{0x93f09f89067b8f73,"C41","Philidor","Hanham, Krause variation"},
tuple<uint64_t,string,string,string>{0x1ba11324c4e59492,"C41","Philidor","Hanham, Steiner variation"},
tuple<uint64_t,string,string,string>{0xbb570568d344acc7,"C41","Philidor","Hanham, Kmoch variation"},
tuple<uint64_t,string,string,string>{0x950068aa22adef99,"C41","Philidor","Hanham, Berger variation"},
tuple<uint64_t,string,string,string>{0x1612fc1fb86ad6ba,"C41","Philidor","Hanham, Schlechter variation"},
tuple<uint64_t,string,string,string>{0x9b5f1c25aaf85be5,"C41","Philidor","Hanham, Delmar variation"},
tuple<uint64_t,string,string,string>{0x88ce4b19abe8990b,"C42","Petrov's defence",""},
tuple<uint64_t,string,string,string>{0xc11c7bc0c4440ce1,"C42","Petrov","French attack"},
tuple<uint64_t,string,string,string>{0xe39b2731c3db1c32,"C42","Petrov","Kaufmann attack"},
tuple<uint64_t,string,string,string>{0x942fa0b7423635ec,"C42","Petrov","Nimzovich attack"},
tuple<uint64_t,string,string,string>{0xf9be3737ce90ecb1,"C42","Petrov","Cozio (Lasker) attack"},
tuple<uint64_t,string,string,string>{0xaa8d97bf911d9a77,"C42","Petrov","classical attack"},
tuple<uint64_t,string,string,string>{0xfe667a706977a3d0,"C42","Petrov","classical attack, Chigorin variation"},
tuple<uint64_t,string,string,string>{0x476e9621daf72752,"C42","Petrov","classical attack, Berger variation"},
tuple<uint64_t,string,string,string>{0x1c2f6f557c52aeea,"C42","Petrov","classical attack, Krause variation"},
tuple<uint64_t,string,string,string>{0x14db4274384d0bf6,"C42","Petrov","classical attack, Maroczy variation"},
tuple<uint64_t,string,string,string>{0xf6f1ebdfadd0a3c3,"C42","Petrov","classical attack, Jaenisch variation"},
tuple<uint64_t,string,string,string>{0xdb9741ae2a17442c,"C42","Petrov","classical attack, Mason variation"},
tuple<uint64_t,string,string,string>{0x1fdec940960c0b62,"C42","Petrov","classical attack, Marshall variation"},
tuple<uint64_t,string,string,string>{0xe5f30ad53b2c9c74,"C42","Petrov","classical attack, Tarrasch variation"},
tuple<uint64_t,string,string,string>{0x5a7c9cb80175f59,"C42","Petrov","classical attack, Marshall trap"},
tuple<uint64_t,string,string,string>{0x9085db202354178d,"C42","Petrov","classical attack, close variation"},
tuple<uint64_t,string,string,string>{0xfbd062917a039c38,"C42","Petrov","Cochrane gambit"},
tuple<uint64_t,string,string,string>{0x466a9a880be8429d,"C42","Petrov","Paulsen attack"},
tuple<uint64_t,string,string,string>{0x8b3af1bb09219b2e,"C42","Petrov","Damiano variation"},
tuple<uint64_t,string,string,string>{0x735953bb690a1bd2,"C42","Petrov three knights game",""},
tuple<uint64_t,string,string,string>{0xeb7dff3183ab4fad,"C42","Petrov","Italian variation"},
tuple<uint64_t,string,string,string>{0x4dfb64b3ba21b449,"C43","Petrov","modern (Steinitz) attack"},
tuple<uint64_t,string,string,string>{0xf0432397fc9ce4ff,"C43","Petrov","modern attack, main line"},
tuple<uint64_t,string,string,string>{0x1bf2bb7186495046,"C43","Petrov","modern attack, Steinitz variation"},
tuple<uint64_t,string,string,string>{0x34826bc17e14a62e,"C43","Petrov","modern attack, Bardeleben variation"},
tuple<uint64_t,string,string,string>{0xb536da19561976fa,"C43","Petrov","Urusov gambit"},
tuple<uint64_t,string,string,string>{0xf04c2aeabcf6135a,"C43","Petrov","modern attack, Symmetrical variation"},
tuple<uint64_t,string,string,string>{0xa0dcd23d58dcf43,"C43","Petrov","modern attack, Trifunovic variation"},
tuple<uint64_t,string,string,string>{0x78cda70e17837d9e,"C44","King's pawn game",""},
tuple<uint64_t,string,string,string>{0x2aa7cdb0269b7bd1,"C44","Irish (Chicago) gambit",""},
tuple<uint64_t,string,string,string>{0x542b1c4ff754a5a6,"C44","Konstantinopolsky opening",""},
tuple<uint64_t,string,string,string>{0xf4ee382a548cd699,"C44","Dresden opening",""},
tuple<uint64_t,string,string,string>{0xb4d24f716a6373d,"C44","Inverted Hungarian",""},
tuple<uint64_t,string,string,string>{0x220349a1f9e52b69,"C44","Inverted Hanham",""},
tuple<uint64_t,string,string,string>{0x95963fa8aa955be9,"C44","Tayler opening",""},
tuple<uint64_t,string,string,string>{0xe175f96c7f37218,"C44","Ponziani opening",""},
tuple<uint64_t,string,string,string>{0xbb183e9f41431e74,"C44","Ponziani","Caro variation"},
tuple<uint64_t,string,string,string>{0x237f43836e38fd3,"C44","Ponziani","Leonhardt variation"},
tuple<uint64_t,string,string,string>{0x958cc684a1f2d93a,"C44","Ponziani","Steinitz variation"},
tuple<uint64_t,string,string,string>{0x55f96b636a09338e,"C44","Ponziani","Jaenisch counter-attack"},
tuple<uint64_t,string,string,string>{0x3a6e0d982e03c501,"C44","Ponziani","Fraser defence"},
tuple<uint64_t,string,string,string>{0x3058e32b7c7af9a5,"C44","Ponziani","Reti variation"},
tuple<uint64_t,string,string,string>{0x1adb2c790d58de89,"C44","Ponziani","Romanishin variation"},
tuple<uint64_t,string,string,string>{0x9a78390f797b5fc6,"C44","Ponziani counter-gambit",""},
tuple<uint64_t,string,string,string>{0xdcffc39723ecadb4,"C44","Ponziani counter-gambit, Schmidt attack",""},
tuple<uint64_t,string,string,string>{0x7a37501ff2299dfc,"C44","Ponziani counter-gambit, Cordel variation",""},
tuple<uint64_t,string,string,string>{0xbdf888a4064a50dc,"C44","Scotch opening",""},
tuple<uint64_t,string,string,string>{0x73a52408ff286bc0,"C44","Scotch","Lolli variation"},
tuple<uint64_t,string,string,string>{0xafe00f50106dbcf8,"C44","Scotch","Cochrane variation"},
tuple<uint64_t,string,string,string>{0x15585389a7a5d74a,"C44","Scotch","Relfsson gambit ('MacLopez')"},
tuple<uint64_t,string,string,string>{0x505c7abe12414b4f,"C44","Scotch","Goering gambit"},
tuple<uint64_t,string,string,string>{0x2503be1f99f0f99d,"C44","Scotch","Sea-cadet mate"},
tuple<uint64_t,string,string,string>{0xd71c1e1bb8da762f,"C44","Scotch","Goering gambit"},
tuple<uint64_t,string,string,string>{0xef419ec63d63e11f,"C44","Scotch","Goering gambit, Bardeleben variation"},
tuple<uint64_t,string,string,string>{0x4535360eea72926f,"C44","Scotch gambit",""},
tuple<uint64_t,string,string,string>{0xdbeeadaa193eebfd,"C44","Scotch gambit","Anderssen (Paulsen, Suhle) counter-attack"},
tuple<uint64_t,string,string,string>{0xbefa9380898c8048,"C44","Scotch gambit",""},
tuple<uint64_t,string,string,string>{0xbd82186550aa539a,"C44","Scotch gambit","Cochrane-Shumov defence"},
tuple<uint64_t,string,string,string>{0x9f7bef421f63cbad,"C44","Scotch gambit","Vitzhum attack"},
tuple<uint64_t,string,string,string>{0x8c745f08a1855a4d,"C44","Scotch gambit",""},
tuple<uint64_t,string,string,string>{0x7002b20485d4946a,"C44","Scotch gambit","Hanneken variation"},
tuple<uint64_t,string,string,string>{0x1218d67f6ec2debf,"C44","Scotch gambit",""},
tuple<uint64_t,string,string,string>{0x504dce408b48c5c9,"C44","Scotch gambit","Cochrane variation"},
tuple<uint64_t,string,string,string>{0x51f945e120d93efe,"C44","Scotch gambit","Benima defence"},
tuple<uint64_t,string,string,string>{0x1edb02fb4788d3f9,"C44","Scotch gambit","Dubois-Reti defence"},
tuple<uint64_t,string,string,string>{0x4112df7bd300d6e7,"C45","Scotch game",""},
tuple<uint64_t,string,string,string>{0x7f471e2544980ab2,"C45","Scotch","Ghulam Kassim variation"},
tuple<uint64_t,string,string,string>{0xbf157b8c88365e19,"C45","Scotch","Pulling counter-attack"},
tuple<uint64_t,string,string,string>{0x4a7f91e189a6644f,"C45","Scotch","Horwitz attack"},
tuple<uint64_t,string,string,string>{0xa8c1abdd657c20f8,"C45","Scotch","Berger variation"},
tuple<uint64_t,string,string,string>{0xaab3a2525030c769,"C45","Scotch game",""},
tuple<uint64_t,string,string,string>{0xa935889305059e33,"C45","Scotch","Rosenthal variation"},
tuple<uint64_t,string,string,string>{0xc172e1804aeee6d6,"C45","Scotch","Fraser attack"},
tuple<uint64_t,string,string,string>{0x4482632e4ad4dcc0,"C45","Scotch","Steinitz variation"},
tuple<uint64_t,string,string,string>{0x1afceb8e7efa9771,"C45","Scotch","Schmidt variation"},
tuple<uint64_t,string,string,string>{0xea91997b885bf3ab,"C45","Scotch","Mieses variation"},
tuple<uint64_t,string,string,string>{0xd28637e416b87dff,"C45","Scotch","Tartakower variation"},
tuple<uint64_t,string,string,string>{0xec0f9b2019323c64,"C45","Scotch game",""},
tuple<uint64_t,string,string,string>{0xf8b2b6a157a13f9c,"C45","Scotch","Blackburne attack"},
tuple<uint64_t,string,string,string>{0x450ef56bce0d9a33,"C45","Scotch","Gottschall variation"},
tuple<uint64_t,string,string,string>{0xe3742881f38c73bf,"C45","Scotch","Paulsen attack"},
tuple<uint64_t,string,string,string>{0x5679502a1627e45c,"C45","Scotch","Paulsen, Gunsberg defence"},
tuple<uint64_t,string,string,string>{0x8596c4a76746f756,"C45","Scotch","Meitner variation"},
tuple<uint64_t,string,string,string>{0x6d555766fc715e51,"C45","Scotch","Blumenfeld attack"},
tuple<uint64_t,string,string,string>{0x787ea30d0825faae,"C45","Scotch","Potter variation"},
tuple<uint64_t,string,string,string>{0xe4f4a8fa26c75d06,"C45","Scotch","Romanishin variation"},
tuple<uint64_t,string,string,string>{0x835abfacd561ff47,"C46","Three knights game",""},
tuple<uint64_t,string,string,string>{0xd1e04c73292d09a6,"C46","Three knights","Schlechter variation"},
tuple<uint64_t,string,string,string>{0x1735d9356be9d299,"C46","Three knights","Winawer defence (Gothic defence)"},
tuple<uint64_t,string,string,string>{0x6aeeecf7aeee6d0c,"C46","Three knights","Steinitz variation"},
tuple<uint64_t,string,string,string>{0xf4b067f3611d2b0e,"C46","Three knights","Steinitz, Rosenthal variation"},
tuple<uint64_t,string,string,string>{0xd8b48b59789bbed1,"C46","Four knights game",""},
tuple<uint64_t,string,string,string>{0x66f77fa2dc851be7,"C46","Four knights","Schultze-Mueller gambit"},
tuple<uint64_t,string,string,string>{0xbb073f7150d86877,"C46","Four knights","Italian variation"},
tuple<uint64_t,string,string,string>{0x1328ba7f31d73091,"C46","Four knights","Gunsberg variation"},
tuple<uint64_t,string,string,string>{0x1d81a4f369529393,"C47","Four knights","Scotch variation"},
tuple<uint64_t,string,string,string>{0x6a83390e86bbfe87,"C47","Four knights","Scotch, Krause variation"},
tuple<uint64_t,string,string,string>{0x86ffae71ad298786,"C47","Four knights","Scotch, 4...exd4"},
tuple<uint64_t,string,string,string>{0x46ea005db768f8d3,"C47","Four knights","Belgrade gambit"},
tuple<uint64_t,string,string,string>{0xeb6a5af61d0f2d52,"C48","Four knights","Spanish variation"},
tuple<uint64_t,string,string,string>{0x68b291e35c7905b5,"C48","Four knights","Ranken variation"},
tuple<uint64_t,string,string,string>{0xc10f12ad0c91a34d,"C48","Four knights","Spielmann variation"},
tuple<uint64_t,string,string,string>{0x46771eadd73dc7d1,"C48","Four knights","Spanish, classical defence"},
tuple<uint64_t,string,string,string>{0x68aeb9761c2ae049,"C48","Four knights","Bardeleben variation"},
tuple<uint64_t,string,string,string>{0x5b94103464cd10bd,"C48","Four knights","Marshall variation"},
tuple<uint64_t,string,string,string>{0x3c173617a34b6df3,"C48","Four knights","Rubinstein counter-gambit"},
tuple<uint64_t,string,string,string>{0xe4bd6091dff85b26,"C48","Four knights","Rubinstein counter-gambit, Bogolyubov variation"},
tuple<uint64_t,string,string,string>{0x849f42eb68dd31da,"C48","Four knights","Rubinstein counter-gambit, 5.Be2"},
tuple<uint64_t,string,string,string>{0x8bb4c010275177ff,"C48","Four knights","Rubinstein counter-gambit Maroczy variation"},
tuple<uint64_t,string,string,string>{0xd9b50f9596ba7ee8,"C48","Four knights","Rubinstein counter-gambit, exchange variation"},
tuple<uint64_t,string,string,string>{0x42624d23dfb8b6e3,"C48","Four knights","Rubinstein counter-gambit, Henneberger variation"},
tuple<uint64_t,string,string,string>{0x222b33f056f8e570,"C49","Four knights","double Ruy Lopez"},
tuple<uint64_t,string,string,string>{0xb343eff385eb075,"C49","Four knights","Gunsberg counter-attack"},
tuple<uint64_t,string,string,string>{0xf85266a6bbc26c5f,"C49","Four knights","double Ruy Lopez"},
tuple<uint64_t,string,string,string>{0x56dca7dc3c45f4b3,"C49","Four knights","Alatortsev variation"},
tuple<uint64_t,string,string,string>{0xd96b1da0a67a3e55,"C49","Four knights",""},
tuple<uint64_t,string,string,string>{0x2fb0ef7b5ef6336c,"C49","Four knights","Janowski variation"},
tuple<uint64_t,string,string,string>{0x17d4558597f29f33,"C49","Four knights","Svenonius variation"},
tuple<uint64_t,string,string,string>{0xc1e8f0c769ba2532,"C49","Four knights","symmetrical variation"},
tuple<uint64_t,string,string,string>{0xf6a169b6a8e8edda,"C49","Four knights","symmetrical, Metger unpin"},
tuple<uint64_t,string,string,string>{0x568c1f717710cc58,"C49","Four knights","symmetrical, Capablanca variation"},
tuple<uint64_t,string,string,string>{0x35a8fa093b675eb,"C49","Four knights","symmetrical, Pillsbury variation"},
tuple<uint64_t,string,string,string>{0x30460d457d427a62,"C49","Four knights","symmetrical, Blake variation"},
tuple<uint64_t,string,string,string>{0x530a3525918585f2,"C49","Four knights","symmetrical, Tarrasch variation"},
tuple<uint64_t,string,string,string>{0x71f3ccd9b3d55d92,"C49","Four knights","symmetrical, Maroczy system"},
tuple<uint64_t,string,string,string>{0x7d99f95590407b0,"C49","Four knights","Nimzovich (Paulsen) variation"},
tuple<uint64_t,string,string,string>{0x1b7e13263fc0ab38,"C50","King's pawn game",""},
tuple<uint64_t,string,string,string>{0xa205c8bb0d1cf936,"C50","Blackburne shilling gambit",""},
tuple<uint64_t,string,string,string>{0x8f1175bf814886e6,"C50","Rousseau gambit",""},
tuple<uint64_t,string,string,string>{0xfb260c9f56b07a9,"C50","Hungarian defence",""},
tuple<uint64_t,string,string,string>{0x27bcd3eeeb04db70,"C50","Hungarian defence","Tartakower variation"},
tuple<uint64_t,string,string,string>{0xb663577df5f241bb,"C50","Giuoco Piano",""},
tuple<uint64_t,string,string,string>{0x161a7b2a9aea82f4,"C50","Giuoco Piano","four knights variation"},
tuple<uint64_t,string,string,string>{0x17d007511d13e3ce,"C50","Giuoco Piano","Jerome gambit"},
tuple<uint64_t,string,string,string>{0x18c794a8b162fa6f,"C50","Giuoco Pianissimo",""},
tuple<uint64_t,string,string,string>{0x5078897876dcda4c,"C50","Giuoco Pianissimo","Dubois variation"},
tuple<uint64_t,string,string,string>{0x4329a05d1c98bbf9,"C50","Giuoco Pianissimo",""},
tuple<uint64_t,string,string,string>{0xb8beb8ffde7a3920,"C50","Giuoco Pianissimo","Italian four knights variation"},
tuple<uint64_t,string,string,string>{0x475e79a8bc88ab85,"C50","Giuoco Pianissimo","Canal variation"},
tuple<uint64_t,string,string,string>{0x1c9622d153442d9f,"C51","Evans gambit declined",""},
tuple<uint64_t,string,string,string>{0x7ef7a45eff575b93,"C51","Evans gambit declined, Lange variation",""},
tuple<uint64_t,string,string,string>{0x516f64d39a4ca7ba,"C51","Evans gambit declined, Pavlov variation",""},
tuple<uint64_t,string,string,string>{0xbd865c9362c9071a,"C51","Evans gambit declined, Hirschbach variation",""},
tuple<uint64_t,string,string,string>{0x2b3e717189bc54a5,"C51","Evans gambit declined, Vasquez variation",""},
tuple<uint64_t,string,string,string>{0xc826e3f1daabb392,"C51","Evans gambit declined, Hicken variation",""},
tuple<uint64_t,string,string,string>{0x97a4747740071144,"C51","Evans gambit declined, 5.a4",""},
tuple<uint64_t,string,string,string>{0xbec49d2665c56b41,"C51","Evans gambit declined, Showalter variation",""},
tuple<uint64_t,string,string,string>{0x3c11e09ee0085865,"C51","Evans gambit declined, Cordel variation",""},
tuple<uint64_t,string,string,string>{0x99fc00c5cf9063b9,"C51","Evans counter-gambit",""},
tuple<uint64_t,string,string,string>{0x237acc9eb8e9c28f,"C51","Evans gambit",""},
tuple<uint64_t,string,string,string>{0x9ce30a8a273a24b8,"C51","Evans gambit","normal variation"},
tuple<uint64_t,string,string,string>{0xb3808929debc8c00,"C51","Evans gambit","Ulvestad variation"},
tuple<uint64_t,string,string,string>{0x8dcf3594653507bd,"C51","Evans gambit","Paulsen variation"},
tuple<uint64_t,string,string,string>{0x67741228e5d8a661,"C51","Evans gambit","Morphy attack"},
tuple<uint64_t,string,string,string>{0xf4396febf86edfa3,"C51","Evans gambit","Goering attack"},
tuple<uint64_t,string,string,string>{0x75e8a3d25c128d93,"C51","Evans gambit","Steinitz variation"},
tuple<uint64_t,string,string,string>{0x65a7d81aa25da88b,"C51","Evans gambit",""},
tuple<uint64_t,string,string,string>{0xb703655562635af0,"C51","Evans gambit","Fraser attack"},
tuple<uint64_t,string,string,string>{0x1b2a6f7e9fd8bb8a,"C51","Evans gambit","Fraser-Mortimer attack"},
tuple<uint64_t,string,string,string>{0xc06f162853535106,"C51","Evans gambit","Stone-Ware variation"},
tuple<uint64_t,string,string,string>{0x9ce15d00236e052b,"C51","Evans gambit","Mayet defence"},
tuple<uint64_t,string,string,string>{0x70fb084546e22cb3,"C51","Evans gambit","5...Be7"},
tuple<uint64_t,string,string,string>{0xe0d90d1afa17a3fb,"C51","Evans gambit","Cordel variation"},
tuple<uint64_t,string,string,string>{0x768c3ac4890df01b,"C52","Evans gambit",""},
tuple<uint64_t,string,string,string>{0x976dca2683dd88cc,"C52","Evans gambit","compromised defence"},
tuple<uint64_t,string,string,string>{0x5a25e99e6ca15eca,"C52","Evans gambit","compromised defence, Paulsen variation"},
tuple<uint64_t,string,string,string>{0x1514081d7ec439ac,"C52","Evans gambit","compromised defence, Potter variation"},
tuple<uint64_t,string,string,string>{0xd3bd7f7b03696064,"C52","Evans gambit","Leonhardt variation"},
tuple<uint64_t,string,string,string>{0x8a03830f4abc9434,"C52","Evans gambit",""},
tuple<uint64_t,string,string,string>{0xb0fa20b77f873cd2,"C52","Evans gambit","Tartakower attack"},
tuple<uint64_t,string,string,string>{0x63bec3cf71fd2e8e,"C52","Evans gambit","Levenfish variation"},
tuple<uint64_t,string,string,string>{0x4c59d439fa364ffc,"C52","Evans gambit","Sokolsky variation"},
tuple<uint64_t,string,string,string>{0x8f941f0f5fe2b0b,"C52","Evans gambit",""},
tuple<uint64_t,string,string,string>{0x22c943e3388a0b02,"C52","Evans gambit","Richardson attack"},
tuple<uint64_t,string,string,string>{0x3143d79127866266,"C52","Evans gambit",""},
tuple<uint64_t,string,string,string>{0x55f15101c70ff3d7,"C52","Evans gambit","Waller attack"},
tuple<uint64_t,string,string,string>{0xab2bd54487e93c8b,"C52","Evans gambit","Lasker defence"},
tuple<uint64_t,string,string,string>{0x16b70669ec159f15,"C52","Evans gambit","Sanders-Alapin variation"},
tuple<uint64_t,string,string,string>{0xf6a5320971ca41ce,"C52","Evans gambit","Alapin-Steinitz variation"},
tuple<uint64_t,string,string,string>{0xc0b9afe525824e3d,"C53","Giuoco Piano",""},
tuple<uint64_t,string,string,string>{0xeb05e1aa3830db34,"C53","Giuoco Piano","LaBourdonnais variation"},
tuple<uint64_t,string,string,string>{0x5b467095e4bee057,"C53","Giuoco Piano","close variation"},
tuple<uint64_t,string,string,string>{0x7e8877758ba72400,"C53","Giuoco Piano","centre-holding variation"},
tuple<uint64_t,string,string,string>{0xb7d0f2ff476eb81f,"C53","Giuoco Piano","Tarrasch variation"},
tuple<uint64_t,string,string,string>{0xb8d220433b2dffc8,"C53","Giuoco Piano","Mestel variation"},
tuple<uint64_t,string,string,string>{0xd4c4c0137eb7fb68,"C53","Giuoco Piano","Eisinger variation"},
tuple<uint64_t,string,string,string>{0x9b579b1088780fab,"C53","Giuoco Piano",""},
tuple<uint64_t,string,string,string>{0x31a2eebc2ece638f,"C53","Giuoco Piano","Bird's attack"},
tuple<uint64_t,string,string,string>{0x5e62b4ba99b122e9,"C53","Giuoco Piano",""},
tuple<uint64_t,string,string,string>{0x52ffde87170803c5,"C53","Giuoco Piano","Ghulam Kassim variation"},
tuple<uint64_t,string,string,string>{0x3d965402f9b8ce1f,"C53","Giuoco Piano",""},
tuple<uint64_t,string,string,string>{0x83805bd8dff3b8e6,"C53","Giuoco Piano","Anderssen variation"},
tuple<uint64_t,string,string,string>{0x69aa6b7439623ada,"C54","Giuoco Piano",""},
tuple<uint64_t,string,string,string>{0xf8cd054ab063c6f4,"C54","Giuoco Piano","Krause variation"},
tuple<uint64_t,string,string,string>{0x49b5a1bde9c1eb60,"C54","Giuoco Piano","Cracow variation"},
tuple<uint64_t,string,string,string>{0xeb77821d5621fab,"C54","Giuoco Piano","Greco's attack"},
tuple<uint64_t,string,string,string>{0x7ffcf0da484895a5,"C54","Giuoco Piano","Greco variation"},
tuple<uint64_t,string,string,string>{0x4db5041bdf39d44b,"C54","Giuoco Piano","Bernstein variation"},
tuple<uint64_t,string,string,string>{0x503554f1fc06a3e2,"C54","Giuoco Piano","Aitken variation"},
tuple<uint64_t,string,string,string>{0xec4c364ab2fe31a2,"C54","Giuoco Piano",""},
tuple<uint64_t,string,string,string>{0x80e0af2909a601ad,"C54","Giuoco Piano","Steinitz variation"},
tuple<uint64_t,string,string,string>{0x564475192bd8a7ff,"C54","Giuoco Piano","Moeller (Therkatz) attack"},
tuple<uint64_t,string,string,string>{0x16eeb90c7a2c97ca,"C54","Giuoco Piano","Therkatz-Herzog variation"},
tuple<uint64_t,string,string,string>{0x7f84c01ce83e9172,"C54","Giuoco Piano","Moeller, bayonet attack"},
tuple<uint64_t,string,string,string>{0x409027d3923aeaae,"C55","Two knights defence",""},
tuple<uint64_t,string,string,string>{0xc7ac015a02afc841,"C55","Giuoco piano","Rosentreter variation"},
tuple<uint64_t,string,string,string>{0x4b3b394e399828a1,"C55","Giuoco piano",""},
tuple<uint64_t,string,string,string>{0x60ff8bddfef58386,"C55","Giuoco piano","Holzhausen attack"},
tuple<uint64_t,string,string,string>{0xee34e406d6aa517a,"C55","Two knights defence (Modern bishop's opening)",""},
tuple<uint64_t,string,string,string>{0x85a5087983f3c7ec,"C55","Two knights defence",""},
tuple<uint64_t,string,string,string>{0x71712b146a7a6e32,"C55","Two knights defence, Keidanz variation",""},
tuple<uint64_t,string,string,string>{0x4809e32eee442b5d,"C55","Two knights defence, Perreux variation",""},
tuple<uint64_t,string,string,string>{0x60ae79cf3b7b08e9,"C55","Two knights defence",""},
tuple<uint64_t,string,string,string>{0xacca2b69f557c40e,"C55","two knights","Max Lange attack"},
tuple<uint64_t,string,string,string>{0xfc3a257853bd644d,"C55","two knights","Max Lange attack, Berger variation"},
tuple<uint64_t,string,string,string>{0x2d9c3fb7708893ec,"C55","two knights","Max Lange attack, Marshall variation"},
tuple<uint64_t,string,string,string>{0x80817becbaba796f,"C55","two knights","Max Lange attack, Rubinstein variation"},
tuple<uint64_t,string,string,string>{0x7adfbc0a6fbac7,"C55","two knights","Max Lange attack, Loman defence"},
tuple<uint64_t,string,string,string>{0xe980cea0b162e941,"C55","two knights","Max Lange attack, Schlechter variation"},
tuple<uint64_t,string,string,string>{0x31e9700ff81d5562,"C55","two knights","Max Lange attack, Steinitz variation"},
tuple<uint64_t,string,string,string>{0x47338897286d5ae4,"C55","two knights","Max Lange attack, Krause variation"},
tuple<uint64_t,string,string,string>{0xdd1937963dacaffa,"C56","Two knights defence",""},
tuple<uint64_t,string,string,string>{0xac0db539421c8825,"C56","two knights defence","Yurdansky attack"},
tuple<uint64_t,string,string,string>{0x275003abe432c811,"C56","two knights defence","Canal variation"},
tuple<uint64_t,string,string,string>{0x1642c6063bf6120a,"C57","Two knights defence",""},
tuple<uint64_t,string,string,string>{0xbb5f825df1c4f889,"C57","two knights defence","Wilkes Barre (Traxler) variation"},
tuple<uint64_t,string,string,string>{0xd4f3844ae6e0a317,"C57","two knights defence","Ulvestad variation"},
tuple<uint64_t,string,string,string>{0x638a82bec3095e8b,"C57","two knights defence","Fritz variation"},
tuple<uint64_t,string,string,string>{0xbe690aa70e5bc025,"C57","two knights defence","Fritz, Gruber variation"},
tuple<uint64_t,string,string,string>{0xee2cbbb8d3612e34,"C57","two knights defence","Lolli attack"},
tuple<uint64_t,string,string,string>{0x276dd2be9896e616,"C57","two knights defence","Pincus variation"},
tuple<uint64_t,string,string,string>{0x5414e11a976477cc,"C57","two knights defence","Fegatello attack"},
tuple<uint64_t,string,string,string>{0xc45657b95a41fbc6,"C57","two knights defence","Fegatello attack, Leonhardt variation"},
tuple<uint64_t,string,string,string>{0xc59b8f738d5963d9,"C57","two knights defence","Fegatello attack, Polerio defence"},
tuple<uint64_t,string,string,string>{0xe1e0c4aad071bc20,"C58","two knights defence",""},
tuple<uint64_t,string,string,string>{0x4f44077f94e107f4,"C58","two knights defence","Kieseritsky variation"},
tuple<uint64_t,string,string,string>{0xa91226c83d5674f0,"C58","two knights defence","Yankovich variation"},
tuple<uint64_t,string,string,string>{0xcde18a9bff720c68,"C58","two knights defence","Maroczy variation"},
tuple<uint64_t,string,string,string>{0x495b878732817c0c,"C58","Two knights defence",""},
tuple<uint64_t,string,string,string>{0xb68977871000a190,"C58","two knights defence","Bogolyubov variation"},
tuple<uint64_t,string,string,string>{0x2e931e018f783a68,"C58","two knights defence","Paoli variation"},
tuple<uint64_t,string,string,string>{0x30dc3abcf7a80833,"C58","two knights defence","Colman variation"},
tuple<uint64_t,string,string,string>{0xf79ca0a5d98a46c0,"C58","two knights defence","Blackburne variation"},
tuple<uint64_t,string,string,string>{0xb4237848f7ebab02,"C58","Two knights defence",""},
tuple<uint64_t,string,string,string>{0x26d4332e603fe217,"C59","Two knights defence",""},
tuple<uint64_t,string,string,string>{0xccc717e690827850,"C59","two knights defence","Knorre variation"},
tuple<uint64_t,string,string,string>{0x84270f7bcc30ef32,"C59","two knights defence","Goering variation"},
tuple<uint64_t,string,string,string>{0xc0ace482e9300454,"C59","two knights defence","Steinitz variation"},
tuple<uint64_t,string,string,string>{0x4b1376a17217ee1d,"C60","Ruy Lopez (Spanish opening)",""},
tuple<uint64_t,string,string,string>{0x874670e848fcf962,"C60","Ruy Lopez","Nuernberg variation"},
tuple<uint64_t,string,string,string>{0x1e045c54df2b4c17,"C60","Ruy Lopez","Pollock defence"},
tuple<uint64_t,string,string,string>{0x5fdf054eb8bc428c,"C60","Ruy Lopez","Lucena defence"},
tuple<uint64_t,string,string,string>{0xd0eca9d1b32b4077,"C60","Ruy Lopez","Vinogradov variation"},
tuple<uint64_t,string,string,string>{0xcb50867ce6a31197,"C60","Ruy Lopez","Brentano defence"},
tuple<uint64_t,string,string,string>{0xa2a725fa09987c56,"C60","Ruy Lopez","fianchetto (Smyslov/Barnes) defence"},
tuple<uint64_t,string,string,string>{0x755cca1cc99e65a0,"C60","Ruy Lopez","Cozio defence"},
tuple<uint64_t,string,string,string>{0x677f81e570f37532,"C60","Ruy Lopez","Cozio defence, Paulsen variation"},
tuple<uint64_t,string,string,string>{0x9c6e1a40cc53aebc,"C61","Ruy Lopez","Bird's defence"},
tuple<uint64_t,string,string,string>{0xc1b6c7e36ff0fb40,"C61","Ruy Lopez","Bird's defence, Paulsen variation"},
tuple<uint64_t,string,string,string>{0x72a9e0c0a06fa770,"C62","Ruy Lopez","old Steinitz defence"},
tuple<uint64_t,string,string,string>{0xa40b2789a2b24977,"C62","Ruy Lopez","old Steinitz defence, Nimzovich attack"},
tuple<uint64_t,string,string,string>{0xd97eae1c28f3f104,"C62","Ruy Lopez","old Steinitz defence, semi-Duras variation"},
tuple<uint64_t,string,string,string>{0xdf7c1038cc9fc3c3,"C63","Ruy Lopez","Schliemann defence"},
tuple<uint64_t,string,string,string>{0x24eb089a0e7d411a,"C63","Ruy Lopez","Schliemann defence, Berger variation"},
tuple<uint64_t,string,string,string>{0xe60e32fab825049e,"C64","Ruy Lopez","classical (Cordel) defence"},
tuple<uint64_t,string,string,string>{0xe5f35083dc24f30b,"C64","Ruy Lopez","classical defence, Zaitsev variation"},
tuple<uint64_t,string,string,string>{0x90d4ca6268550b18,"C64","Ruy Lopez","classical defence, 4.c3"},
tuple<uint64_t,string,string,string>{0x9a296ff4031cbc22,"C64","Ruy Lopez","classical defence, Benelux variation  "},
tuple<uint64_t,string,string,string>{0x702fe2281685e20d,"C64","Ruy Lopez","classical defence, Charousek variation"},
tuple<uint64_t,string,string,string>{0xb2b1512a969a572,"C64","Ruy Lopez","classical defence, Boden variation"},
tuple<uint64_t,string,string,string>{0x4bbacfbd6dd26c6,"C64","Ruy Lopez","Cordel gambit"},
tuple<uint64_t,string,string,string>{0x10fd4254dfedaf8b,"C65","Ruy Lopez","Berlin defence"},
tuple<uint64_t,string,string,string>{0x30c31c4876ac4dcc,"C65","Ruy Lopez","Berlin defence, Nyholm attack"},
tuple<uint64_t,string,string,string>{0xbab1a9d0d1fb9f4e,"C65","Ruy Lopez","Berlin defence, Mortimer variation"},
tuple<uint64_t,string,string,string>{0x9688b0c40225e9c3,"C65","Ruy Lopez","Berlin defence, Mortimer trap"},
tuple<uint64_t,string,string,string>{0xd6cc2d06ef538d09,"C65","Ruy Lopez","Berlin defence, Anderssen variation"},
tuple<uint64_t,string,string,string>{0xbc088c40a0af635,"C65","Ruy Lopez","Berlin defence, Duras variation"},
tuple<uint64_t,string,string,string>{0x604c7e36d075e552,"C65","Ruy Lopez","Berlin defence, Kaufmann variation"},
tuple<uint64_t,string,string,string>{0x6e883960a31e749b,"C65","Ruy Lopez","Berlin defence, 4.O-O"},
tuple<uint64_t,string,string,string>{0xc3957d3b692c9e18,"C65","Ruy Lopez","Berlin defence, Beverwijk variation"},
tuple<uint64_t,string,string,string>{0x5732af0171663df6,"C66","Ruy Lopez","Berlin defence, 4.O-O, d6"},
tuple<uint64_t,string,string,string>{0x9f9d15b4b2bceecd,"C66","Ruy Lopez","Berlin defence, hedgehog variation"},
tuple<uint64_t,string,string,string>{0x1181f688e04dac32,"C66","Ruy Lopez","Berlin defence, Tarrasch trap"},
tuple<uint64_t,string,string,string>{0x59c7428202363505,"C66","Ruy Lopez","closed Berlin defence, Bernstein variation"},
tuple<uint64_t,string,string,string>{0xceb22f5214ea3ef6,"C66","Ruy Lopez","closed Berlin defence, Showalter variation"},
tuple<uint64_t,string,string,string>{0x102f6cd9bc6c5649,"C66","Ruy Lopez","closed Berlin defence, Wolf variation"},
tuple<uint64_t,string,string,string>{0x6b40830dcd631941,"C66","Ruy Lopez","closed Berlin defence, Chigorin variation"},
tuple<uint64_t,string,string,string>{0xd33f7739a5c9d388,"C67","Ruy Lopez","Berlin defence, open variation"},
tuple<uint64_t,string,string,string>{0x2eef1e7ab0027288,"C67","Ruy Lopez","open Berlin defence, l'Hermet variation"},
tuple<uint64_t,string,string,string>{0x8371af7b4c41bcd2,"C67","Ruy Lopez","open Berlin defence, Showalter variation"},
tuple<uint64_t,string,string,string>{0x2c62b7c7eab525b,"C67","Ruy Lopez","open Berlin defence, 5...Be7"},
tuple<uint64_t,string,string,string>{0x1d01c537cbf326d9,"C67","Ruy Lopez","Berlin defence, Rio de Janeiro variation"},
tuple<uint64_t,string,string,string>{0x201dffa38c8f474e,"C67","Ruy Lopez","Berlin defence, Zukertort variation"},
tuple<uint64_t,string,string,string>{0x209800d3150d8724,"C67","Ruy Lopez","Berlin defence, Pillsbury variation"},
tuple<uint64_t,string,string,string>{0xd259fa8b0d585486,"C67","Ruy Lopez","Berlin defence, Winawer attack"},
tuple<uint64_t,string,string,string>{0xefa92e906c77b14d,"C67","Ruy Lopez","Berlin defence, Cordel variation"},
tuple<uint64_t,string,string,string>{0x11aa864aac3b47f9,"C67","Ruy Lopez","Berlin defence, Trifunovic variation"},
tuple<uint64_t,string,string,string>{0x9e5bd43e769ee52b,"C67","Ruy Lopez","Berlin defence, Minckwitz variation"},
tuple<uint64_t,string,string,string>{0xc4fda96053200616,"C67","Ruy Lopez","Berlin defence, Rosenthal variation"},
tuple<uint64_t,string,string,string>{0xc8cbbdb43361c6fa,"C68","Ruy Lopez","exchange variation"},
tuple<uint64_t,string,string,string>{0xb3f976e26e428777,"C68","Ruy Lopez","exchange, Alekhine variation"},
tuple<uint64_t,string,string,string>{0x58c874168a1de5c,"C68","Ruy Lopez","exchange, Keres variation"},
tuple<uint64_t,string,string,string>{0x677d42dd16da72f7,"C68","Ruy Lopez","exchange, Romanovsky variation"},
tuple<uint64_t,string,string,string>{0x806ee4d7d6b08795,"C69","Ruy Lopez","exchange variation, 5.O-O"},
tuple<uint64_t,string,string,string>{0x77106d2054b6e1fa,"C69","Ruy Lopez","exchange variation, Alapin gambit"},
tuple<uint64_t,string,string,string>{0x4c3be29eec5b90ea,"C69","Ruy Lopez","exchange, Gligoric variation"},
tuple<uint64_t,string,string,string>{0x35028f47dea98b8a,"C69","Ruy Lopez","exchange, Bronstein variation"},
tuple<uint64_t,string,string,string>{0xa8e7c91161416feb,"C70","Ruy Lopez",""},
tuple<uint64_t,string,string,string>{0x41539a4a1acefda0,"C70","Ruy Lopez","fianchetto defence deferred"},
tuple<uint64_t,string,string,string>{0x96a875acdac8e456,"C70","Ruy Lopez","Cozio defence deferred"},
tuple<uint64_t,string,string,string>{0x7f9aa5f0df052f4a,"C70","Ruy Lopez","Bird's defence deferred"},
tuple<uint64_t,string,string,string>{0x61a6a0172ab6a7c9,"C70","Ruy Lopez","Alapin's defence deferred"},
tuple<uint64_t,string,string,string>{0x5fa8d4aab738568,"C70","Ruy Lopez","Classical defence deferred"},
tuple<uint64_t,string,string,string>{0xc8e3a304faecd2d6,"C70","Ruy Lopez","Caro variation"},
tuple<uint64_t,string,string,string>{0x3542fa13ad7ed1b7,"C70","Ruy Lopez","Graz variation"},
tuple<uint64_t,string,string,string>{0xcd4894bdca70993e,"C70","Ruy Lopez","Taimanov (chase/wing/accelerated counterthrust) variation"},
tuple<uint64_t,string,string,string>{0x3c88af88dfc94235,"C70","Ruy Lopez","Schliemann defence deferred"},
tuple<uint64_t,string,string,string>{0x915d5f70b3392686,"C71","Ruy Lopez","modern Steinitz defence"},
tuple<uint64_t,string,string,string>{0x2ca9776ff2908516,"C71","Ruy Lopez","Noah's ark trap"},
tuple<uint64_t,string,string,string>{0x6aca47d271dba45f,"C71","Ruy Lopez","modern Steinitz defence, Three knights variation"},
tuple<uint64_t,string,string,string>{0x1d7ec054f0368d81,"C71","Ruy Lopez","modern Steinitz defence, Duras (Keres) variation"},
tuple<uint64_t,string,string,string>{0xef282444cfcafd96,"C72","Ruy Lopez","modern Steinitz defence, 5.O-O"},
tuple<uint64_t,string,string,string>{0x8c24cc14dccc3f6,"C73","Ruy Lopez","modern Steinitz defence, Richter variation"},
tuple<uint64_t,string,string,string>{0xc4974a887727d489,"C73","Ruy Lopez","modern Steinitz defence, Alapin variation"},
tuple<uint64_t,string,string,string>{0xe787a7e863492900,"C74","Ruy Lopez","modern Steinitz defence"},
tuple<uint64_t,string,string,string>{0x73e8c171ddc104de,"C74","Ruy Lopez","modern Steinitz defence, siesta variation"},
tuple<uint64_t,string,string,string>{0xf83c4b3d30b77337,"C74","Ruy Lopez","Siesta, Kopayev variation"},
tuple<uint64_t,string,string,string>{0x54659bab913f931,"C75","Ruy Lopez","modern Steinitz defence"},
tuple<uint64_t,string,string,string>{0xfe3ccaad13535fce,"C75","Ruy Lopez","modern Steinitz defence, Rubinstein variation"},
tuple<uint64_t,string,string,string>{0x29c7254bd3554638,"C76","Ruy Lopez","modern Steinitz defence, fianchetto (Bronstein) variation"},
tuple<uint64_t,string,string,string>{0xf309fde4ccbb2e7d,"C77","Ruy Lopez","Morphy defence"},
tuple<uint64_t,string,string,string>{0x89ee5460e59aca4,"C77","Ruy Lopez","four knights (Tarrasch) variation"},
tuple<uint64_t,string,string,string>{0x6bf3afeb31bc0265,"C77","Ruy Lopez","Treybal (Bayreuth) variation (exchange var. deferred)"},
tuple<uint64_t,string,string,string>{0x650f72c682ff75f9,"C77","Ruy Lopez","Wormald (Alapin) attack"},
tuple<uint64_t,string,string,string>{0xc9fdfd111a1de8f4,"C77","Ruy Lopez","Wormald attack, Gruenfeld variation"},
tuple<uint64_t,string,string,string>{0x5dad3e31882b95a9,"C77","Ruy Lopez","Anderssen variation"},
tuple<uint64_t,string,string,string>{0xe8343774195c77c3,"C77","Ruy Lopez","Morphy defence, Duras variation"},
tuple<uint64_t,string,string,string>{0x8d7c86d0b048f56d,"C78","Ruy Lopez","5.O-O"},
tuple<uint64_t,string,string,string>{0xc2c1fc8a117dd8ed,"C78","Ruy Lopez","Wing attack"},
tuple<uint64_t,string,string,string>{0x847e67e8643de8df,"C78","Ruy Lopez","...b5 & ...d6"},
tuple<uint64_t,string,string,string>{0xca0c1aacc125622d,"C78","Ruy Lopez","Rabinovich variation"},
tuple<uint64_t,string,string,string>{0xd54b90dc4170e29,"C78","Ruy Lopez","Archangelsk (counterthrust) variation"},
tuple<uint64_t,string,string,string>{0x2061c28b7a7a1fee,"C78","Ruy Lopez","Moeller defence"},
tuple<uint64_t,string,string,string>{0xb4c610b16230bc00,"C79","Ruy Lopez","Steinitz defence deferred (Russian defence)"},
tuple<uint64_t,string,string,string>{0x2f8ac932db40579a,"C79","Ruy Lopez","Steinitz defence deferred, Lipnitsky variation"},
tuple<uint64_t,string,string,string>{0x90ee4d599a12fe63,"C79","Ruy Lopez","Steinitz defence deferred, Rubinstein variation"},
tuple<uint64_t,string,string,string>{0xa3395074886ecf42,"C79","Ruy Lopez","Steinitz defence deferred, Boleslavsky variation"},
tuple<uint64_t,string,string,string>{0x30cbc889b69f527e,"C80","Ruy Lopez","open (Tarrasch) defence"},
tuple<uint64_t,string,string,string>{0xa6cd47abf8db09fa,"C80","Ruy Lopez","open, Tartakower variation"},
tuple<uint64_t,string,string,string>{0xcb5cd02b747dd0a7,"C80","Ruy Lopez","open, Knorre variation"},
tuple<uint64_t,string,string,string>{0xf5fee723a7567f3c,"C80","Ruy Lopez","open, 6.d4"},
tuple<uint64_t,string,string,string>{0x6e80eda1632d6b29,"C80","Ruy Lopez","open, Riga variation"},
tuple<uint64_t,string,string,string>{0x95fa8d363cfbc201,"C80","Ruy Lopez","open, 6.d4 b5"},
tuple<uint64_t,string,string,string>{0x2bb979cd98e56737,"C80","Ruy Lopez","open, Friess attack"},
tuple<uint64_t,string,string,string>{0x2ff2ce65a5dd545c,"C80","Ruy Lopez","open, Richter variation"},
tuple<uint64_t,string,string,string>{0xc546907aa15b2be3,"C80","Ruy Lopez","open, 7.Bb3"},
tuple<uint64_t,string,string,string>{0xe5b8602ea97e8b17,"C80","Ruy Lopez","open, Schlechter defence"},
tuple<uint64_t,string,string,string>{0x3cd62a60f450c9f,"C80","Ruy Lopez","open, Berger variation"},
tuple<uint64_t,string,string,string>{0xcc0f2d4a7e80cec2,"C80","Ruy Lopez","open, Harksen gambit"},
tuple<uint64_t,string,string,string>{0xdcb14d2c35bad2b5,"C80","Ruy Lopez","open, 8.de"},
tuple<uint64_t,string,string,string>{0xd859657d7f3c59a4,"C80","Ruy Lopez","open, Zukertort variation"},
tuple<uint64_t,string,string,string>{0x8809dff87d0fa9bd,"C80","Ruy Lopez","open, 8...Be6"},
tuple<uint64_t,string,string,string>{0xd167679ae7f2018d,"C80","Ruy Lopez","open, Bernstein variation"},
tuple<uint64_t,string,string,string>{0xf00b41b6aa8c1d0d,"C80","Ruy Lopez","open, Bernstein variation, Karpov gambit"},
tuple<uint64_t,string,string,string>{0x1e0f50da334bf239,"C81","Ruy Lopez","open, Howell attack"},
tuple<uint64_t,string,string,string>{0xf7c70eacda0a9e5a,"C81","Ruy Lopez","open, Howell attack, Ekstroem variation"},
tuple<uint64_t,string,string,string>{0x86e0bc11baeff5af,"C81","Ruy Lopez","open, Howell attack, Adam variation"},
tuple<uint64_t,string,string,string>{0xfed32760ad7fa63b,"C82","Ruy Lopez","open, 9.c3"},
tuple<uint64_t,string,string,string>{0x1dda726f5582677e,"C82","Ruy Lopez","open, Berlin variation"},
tuple<uint64_t,string,string,string>{0x53ce633b674d4cb8,"C82","Ruy Lopez","open, Italian variation"},
tuple<uint64_t,string,string,string>{0xaa0db59fdb0e488,"C82","Ruy Lopez","open, St. Petersburg variation"},
tuple<uint64_t,string,string,string>{0xf0c7fc282d56d881,"C82","Ruy Lopez","open, Dilworth variation"},
tuple<uint64_t,string,string,string>{0xf3a9cff7c80fddcf,"C82","Ruy Lopez","open, Motzko attack"},
tuple<uint64_t,string,string,string>{0xf741e7a6828956de,"C82","Ruy Lopez","open, Motzko attack, Nenarokov variation"},
tuple<uint64_t,string,string,string>{0xea1f548f67d40aaa,"C83","Ruy Lopez","open, classical defence"},
tuple<uint64_t,string,string,string>{0x2fdf8e78663410f5,"C83","Ruy Lopez","open, Malkin variation"},
tuple<uint64_t,string,string,string>{0x6eab5a04e07ca1be,"C83","Ruy Lopez","open, 9...Be7, 10.Re1"},
tuple<uint64_t,string,string,string>{0xe69df64ecf695d7d,"C83","Ruy Lopez","open, Tarrasch trap"},
tuple<uint64_t,string,string,string>{0xf429026527b5537e,"C83","Ruy Lopez","open, Breslau variation"},
tuple<uint64_t,string,string,string>{0x99b0f53f7ae359fc,"C84","Ruy Lopez","closed defence"},
tuple<uint64_t,string,string,string>{0x5c85da956b2a74be,"C84","Ruy Lopez","closed, centre attack"},
tuple<uint64_t,string,string,string>{0xea5072edc976c4b3,"C84","Ruy Lopez","closed, Basque gambit (North Spanish variation)"},
tuple<uint64_t,string,string,string>{0x14aa73087e475e4,"C85","Ruy Lopez","Exchange variation doubly deferred (DERLD)"},
tuple<uint64_t,string,string,string>{0xfb67a1d34a70278,"C86","Ruy Lopez","Worrall attack"},
tuple<uint64_t,string,string,string>{0x35a6e0f3e7f3bf4c,"C86","Ruy Lopez","Worrall attack, sharp line"},
tuple<uint64_t,string,string,string>{0x6b49b25e0d21fca,"C86","Ruy Lopez","Worrall attack, solid line"},
tuple<uint64_t,string,string,string>{0x24be6dd52f33bb85,"C87","Ruy Lopez","closed, Averbach variation"},
tuple<uint64_t,string,string,string>{0x2dbc8cedfb46a637,"C88","Ruy Lopez","closed"},
tuple<uint64_t,string,string,string>{0x97854b06a6846578,"C88","Ruy Lopez","closed, Leonhardt variation"},
tuple<uint64_t,string,string,string>{0x896011af2276bfaa,"C88","Ruy Lopez","closed, Balla variation"},
tuple<uint64_t,string,string,string>{0xd133352638f7c218,"C88","Ruy Lopez","closed, 7...d6, 8.d4"},
tuple<uint64_t,string,string,string>{0x994a45ca6e9a1815,"C88","Ruy Lopez","Noah's ark trap"},
tuple<uint64_t,string,string,string>{0x9d2cc469891409ac,"C88","Ruy Lopez","Trajkovic counter-attack"},
tuple<uint64_t,string,string,string>{0x2714615a2e1f4fdc,"C88","Ruy Lopez","closed, 7...O-O"},
tuple<uint64_t,string,string,string>{0x4cdd1fb6438c9a12,"C88","Ruy Lopez","closed, anti-Marshall 8.a4"},
tuple<uint64_t,string,string,string>{0x51ce99c2fe6f405a,"C88","Ruy Lopez","closed, 8.c3"},
tuple<uint64_t,string,string,string>{0xd4a4bbd662bb0e7c,"C89","Ruy Lopez","Marshall counter-attack"},
tuple<uint64_t,string,string,string>{0x10771565b5a96f29,"C89","Ruy Lopez","Marshall counter-attack, 11...c6"},
tuple<uint64_t,string,string,string>{0x7c389edb972e428c,"C89","Ruy Lopez","Marshall, Kevitz variation"},
tuple<uint64_t,string,string,string>{0xd5423acfa460426b,"C89","Ruy Lopez","Marshall, main line, 12.d2d4"},
tuple<uint64_t,string,string,string>{0x523cfba827708e61,"C89","Ruy Lopez","Marshall, main line, 14...Qh3"},
tuple<uint64_t,string,string,string>{0x7a9bdf85d02f43b1,"C89","Ruy Lopez","Marshall, main line, Spassky variation"},
tuple<uint64_t,string,string,string>{0xdc7d8cf58ad1938c,"C89","Ruy Lopez","Marshall, Herman Steiner variation"},
tuple<uint64_t,string,string,string>{0x68740fa32c170937,"C90","Ruy Lopez","closed (with ...d6)"},
tuple<uint64_t,string,string,string>{0xc6d0cc766887b2e3,"C90","Ruy Lopez","closed, Pilnik variation"},
tuple<uint64_t,string,string,string>{0x984d6924b54548bb,"C90","Ruy Lopez","closed, Lutikov variation"},
tuple<uint64_t,string,string,string>{0xa3e83e85655b8777,"C90","Ruy Lopez","closed, Suetin variation"},
tuple<uint64_t,string,string,string>{0xad4120093dde2475,"C91","Ruy Lopez","closed, 9.d4"},
tuple<uint64_t,string,string,string>{0xaf92ea3b7a5b2a9f,"C91","Ruy Lopez","closed, Bogolyubov variation"},
tuple<uint64_t,string,string,string>{0x8087d21deeb4c0c5,"C92","Ruy Lopez","closed, 9.h3"},
tuple<uint64_t,string,string,string>{0x2cbcb085c52fb180,"C92","Ruy Lopez","closed, Keres (9...a5) variation"},
tuple<uint64_t,string,string,string>{0xd43f40c9a601bbcd,"C92","Ruy Lopez","closed, Kholmov variation"},
tuple<uint64_t,string,string,string>{0x79c0d1bb4378c930,"C92","Ruy Lopez","closed, Ragozin-Petrosian (`Keres') variation"},
tuple<uint64_t,string,string,string>{0x30179a999ce66f5e,"C92","Ruy Lopez","closed, Flohr-Zaitsev system (Lenzerheide variation)"},
tuple<uint64_t,string,string,string>{0x1270997b796089d0,"C93","Ruy Lopez","closed, Smyslov defence"},
tuple<uint64_t,string,string,string>{0x2b6a0affff2565c6,"C94","Ruy Lopez","closed, Breyer defence"},
tuple<uint64_t,string,string,string>{0xee5f2555eeec4884,"C95","Ruy Lopez","closed, Breyer, 10.d4"},
tuple<uint64_t,string,string,string>{0xddbc5e080e44a548,"C95","Ruy Lopez","closed, Breyer, Borisenko variation"},
tuple<uint64_t,string,string,string>{0x220a19c780fee812,"C95","Ruy Lopez","closed, Breyer, Gligoric variation"},
tuple<uint64_t,string,string,string>{0xec0f9b42173467ef,"C95","Ruy Lopez","closed, Breyer, Simagin variation"},
tuple<uint64_t,string,string,string>{0x25a99e6fdada2343,"C96","Ruy Lopez","closed (8...Na5)"},
tuple<uint64_t,string,string,string>{0x74f9630bd09892bb,"C96","Ruy Lopez","closed, Rossolimo defence"},
tuple<uint64_t,string,string,string>{0xc3d84fc1259d283e,"C96","Ruy Lopez","closed (10...c5)"},
tuple<uint64_t,string,string,string>{0x53fa4a9e9968a776,"C96","Ruy Lopez","closed, Borisenko defence"},
tuple<uint64_t,string,string,string>{0xffaa63cd99980c89,"C96","Ruy Lopez","closed, Keres (...Nd7) defence"},
tuple<uint64_t,string,string,string>{0xf25f4a581f4a7d,"C97","Ruy Lopez","closed, Chigorin defence"},
tuple<uint64_t,string,string,string>{0xae53da905d14c1b0,"C97","Ruy Lopez","closed, Chigorin, Yugoslav system"},
tuple<uint64_t,string,string,string>{0xc8bcddd6fde4047,"C98","Ruy Lopez","closed, Chigorin, 12...Nc6"},
tuple<uint64_t,string,string,string>{0x7368ef0d8cc2172b,"C98","Ruy Lopez","closed, Chigorin, Rauzer attack"},
tuple<uint64_t,string,string,string>{0xaa348851dbbe87ad,"C99","Ruy Lopez","closed, Chigorin, 12...c5d4"},
tuple<uint64_t,string,string,string>{0x6649ba69b8c9ff8,"D00","Queen's pawn game",""},
tuple<uint64_t,string,string,string>{0xdd307d2702ec759b,"D00","Queen's pawn, Mason variation",""},
tuple<uint64_t,string,string,string>{0x3b41ac89fdab7ee6,"D00","Queen's pawn, Mason variation, Steinitz counter-gambit",""},
tuple<uint64_t,string,string,string>{0xc03ecc902b064430,"D00","Levitsky attack (Queen's bishop attack)",""},
tuple<uint64_t,string,string,string>{0xc26396ee700c22f2,"D00","Blackmar gambit",""},
tuple<uint64_t,string,string,string>{0xa5aa4c432ba994b9,"D00","Queen's pawn","stonewall attack"},
tuple<uint64_t,string,string,string>{0xfdf38304596e1d21,"D00","Queen's pawn","Chigorin variation"},
tuple<uint64_t,string,string,string>{0xff2049361eeb13cb,"D00","Queen's pawn","Anti-Veresov"},
tuple<uint64_t,string,string,string>{0x621abab91f14e1bd,"D00","Blackmar-Diemer gambit",""},
tuple<uint64_t,string,string,string>{0xbfca678c5151bae4,"D00","Blackmar-Diemer","Euwe defence"},
tuple<uint64_t,string,string,string>{0xe862b2f38cf1198b,"D00","Blackmar-Diemer","Lemberg counter-gambit"},
tuple<uint64_t,string,string,string>{0x6047e0c7441e877f,"D01","Richter-Veresov attack",""},
tuple<uint64_t,string,string,string>{0x4661809828e5d012,"D01","Richter-Veresov attack, Veresov variation",""},
tuple<uint64_t,string,string,string>{0x8def6f7853316183,"D01","Richter-Veresov attack, Richter variation",""},
tuple<uint64_t,string,string,string>{0xdd007750f36afec5,"D02","Queen's pawn game",""},
tuple<uint64_t,string,string,string>{0x76edafb2e2fb5bc6,"D02","Queen's pawn game, Chigorin variation",""},
tuple<uint64_t,string,string,string>{0x3b71a6fe0c2df5b8,"D02","Queen's pawn game, Krause variation",""},
tuple<uint64_t,string,string,string>{0x86ee43a55e90bf53,"D02","Queen's pawn game",""},
tuple<uint64_t,string,string,string>{0x5dbaa524c7f05530,"D02","Queen's bishop game",""},
tuple<uint64_t,string,string,string>{0x40b41493ee1a649b,"D03","Torre attack (Tartakower variation)",""},
tuple<uint64_t,string,string,string>{0x2bc301177acf37f7,"D04","Queen's pawn game",""},
tuple<uint64_t,string,string,string>{0x5db4f32662eda7a5,"D05","Queen's pawn game",""},
tuple<uint64_t,string,string,string>{0x6e0dfabeddda6f85,"D05","Queen's pawn game, Zukertort variation",""},
tuple<uint64_t,string,string,string>{0x8b952845b6d65d6,"D05","Queen's pawn game",""},
tuple<uint64_t,string,string,string>{0x626ee37e7ea705c6,"D05","Queen's pawn game, Rubinstein (Colle-Zukertort) variation",""},
tuple<uint64_t,string,string,string>{0x98127bb2745a612d,"D05","Colle system",""},
tuple<uint64_t,string,string,string>{0x8a470482d88334ff,"D06","Queen's Gambit",""},
tuple<uint64_t,string,string,string>{0x95e6d0c6f663d72,"D06","QGD","Grau (Sahovic) defence"},
tuple<uint64_t,string,string,string>{0xd1a9307775797569,"D06","QGD","Marshall defence"},
tuple<uint64_t,string,string,string>{0x6c36d52c27c43f82,"D06","QGD","symmetrical (Austrian) defence"},
tuple<uint64_t,string,string,string>{0x21aadc60c91291fc,"D07","QGD","Chigorin defence"},
tuple<uint64_t,string,string,string>{0xd35f110631289cfb,"D07","QGD","Chigorin defence, Janowski variation"},
tuple<uint64_t,string,string,string>{0x3f0cc84b66ccc9,"D08","QGD","Albin counter-gambit"},
tuple<uint64_t,string,string,string>{0xbe5934bc0d347dbf,"D08","QGD","Albin counter-gambit, Lasker trap"},
tuple<uint64_t,string,string,string>{0xa5ab7512e78a3063,"D08","QGD","Albin counter-gambit"},
tuple<uint64_t,string,string,string>{0x572815926ce63d50,"D08","QGD","Albin counter-gambit, Alapin variation"},
tuple<uint64_t,string,string,string>{0x46d97ed4c188e28b,"D08","QGD","Albin counter-gambit, Krenosz variation"},
tuple<uint64_t,string,string,string>{0x9b7d13db560d2a2f,"D08","QGD","Albin counter-gambit, Janowski variation"},
tuple<uint64_t,string,string,string>{0xccd7cae2adda933a,"D08","QGD","Albin counter-gambit, Balogh variation"},
tuple<uint64_t,string,string,string>{0x22a016b116cc4d58,"D09","QGD","Albin counter-gambit, 5.g3"},
tuple<uint64_t,string,string,string>{0x183de96daf43e744,"D10","QGD Slav defence",""},
tuple<uint64_t,string,string,string>{0xf5abc5b5d41f3674,"D10","QGD Slav defence, Alekhine variation",""},
tuple<uint64_t,string,string,string>{0x69d2f985fe449dab,"D10","QGD Slav","Winawer counter-gambit"},
tuple<uint64_t,string,string,string>{0x161772a00d8df359,"D10","QGD Slav defence","exchange variation"},
tuple<uint64_t,string,string,string>{0xc359059bc7a58679,"D11","QGD Slav","3.Nf3"},
tuple<uint64_t,string,string,string>{0xc1d9890cf0a26fdf,"D11","QGD Slav","Breyer variation"},
tuple<uint64_t,string,string,string>{0x359a73dc4e004f4b,"D11","QGD Slav","4.e3"},
tuple<uint64_t,string,string,string>{0xb6831a52f9e546c6,"D12","QGD Slav","4.e3 Bf5"},
tuple<uint64_t,string,string,string>{0x7b13d091c61af8a8,"D12","QGD Slav","Landau variation"},
tuple<uint64_t,string,string,string>{0x304e367439a3ddb8,"D12","QGD Slav","exchange variation"},
tuple<uint64_t,string,string,string>{0x6246182cd7c02169,"D12","QGD Slav","Amsterdam variation"},
tuple<uint64_t,string,string,string>{0xe5ed05ea68fbde48,"D13","QGD Slav","exchange variation"},
tuple<uint64_t,string,string,string>{0xedda4aa5950d1a7c,"D14","QGD Slav","exchange variation, 6.Bf4 Bf5"},
tuple<uint64_t,string,string,string>{0xc5383098d7bc624e,"D14","QGD Slav","exchange, Trifunovic variation"},
tuple<uint64_t,string,string,string>{0x632029cca8bd4536,"D15","QGD Slav","4.Nc3"},
tuple<uint64_t,string,string,string>{0xa4dfd79b62f693ec,"D15","QGD Slav","Suechting variation"},
tuple<uint64_t,string,string,string>{0x8a947a97d332d77d,"D15","QGD Slav","Schlechter variation"},
tuple<uint64_t,string,string,string>{0xb12610fefa83abd5,"D15","QGD Slav accepted",""},
tuple<uint64_t,string,string,string>{0x1c0b524cdedc2371,"D15","QGD Slav","5.e3 (Alekhine variation)"},
tuple<uint64_t,string,string,string>{0x75211db6110316df,"D15","QGD Slav","Slav gambit"},
tuple<uint64_t,string,string,string>{0x745c615e8eb08d86,"D15","QGD Slav","Tolush-Geller gambit"},
tuple<uint64_t,string,string,string>{0xdaef6e1297107e1b,"D16","QGD Slav accepted","Alapin variation"},
tuple<uint64_t,string,string,string>{0x52bb02f8bdea5147,"D16","QGD Slav","Smyslov variation"},
tuple<uint64_t,string,string,string>{0xac989c238f32ee49,"D16","QGD Slav","Soultanbeieff variation"},
tuple<uint64_t,string,string,string>{0xd83ca420d09570f1,"D16","QGD Slav","Steiner variation"},
tuple<uint64_t,string,string,string>{0x59f6079c20f57796,"D17","QGD Slav","Czech defence"},
tuple<uint64_t,string,string,string>{0x84ced8537b7812e0,"D17","QGD Slav","Krause attack"},
tuple<uint64_t,string,string,string>{0xd9239b64d31835f9,"D17","QGD Slav","Carlsbad variation"},
tuple<uint64_t,string,string,string>{0xf2b92a62635a82b2,"D17","QGD Slav","Wiesbaden variation"},
tuple<uint64_t,string,string,string>{0xf4db452e04aaff32,"D18","QGD Slav","Dutch variation"},
tuple<uint64_t,string,string,string>{0xba5beebe8255638e,"D18","QGD Slav","Dutch, Lasker variation"},
tuple<uint64_t,string,string,string>{0xd1f9164e821838e3,"D19","QGD Slav","Dutch variation"},
tuple<uint64_t,string,string,string>{0x4d5774db19058a8c,"D19","QGD Slav","Dutch variation, main line"},
tuple<uint64_t,string,string,string>{0xd41239924339ea6b,"D19","QGD Slav","Dutch, Saemisch variation"},
tuple<uint64_t,string,string,string>{0x58413db08abdda1c,"D20","Queen's gambit accepted",""},
tuple<uint64_t,string,string,string>{0x9c4630f8613d6716,"D20","QGA","3.e4"},
tuple<uint64_t,string,string,string>{0x42e447f3e98444,"D20","QGA","Linares variation"},
tuple<uint64_t,string,string,string>{0x8295661dfb54ac8,"D20","QGA","Schwartz defence"},
tuple<uint64_t,string,string,string>{0x8325d146e25bbb21,"D21","QGA","3.Nf3"},
tuple<uint64_t,string,string,string>{0xe321bb5379f6061c,"D21","QGA","Ericson variation"},
tuple<uint64_t,string,string,string>{0x95d52dfdeefbfef7,"D21","QGA","Alekhine defense, Borisenko-Furman variation"},
tuple<uint64_t,string,string,string>{0x51d220b5057b43fd,"D22","QGA","Alekhine defence"},
tuple<uint64_t,string,string,string>{0xd632aa344e31870d,"D22","QGA","Alekhine defence, Alatortsev variation"},
tuple<uint64_t,string,string,string>{0x9cfb0812ba897664,"D22","QGA","Haberditz variation"},
tuple<uint64_t,string,string,string>{0xd8cbe5b34fa1fab7,"D23","Queen's gambit accepted",""},
tuple<uint64_t,string,string,string>{0xa6f58fc8f9f08cc,"D23","QGA","Mannheim variation"},
tuple<uint64_t,string,string,string>{0x235cfd118d43786e,"D24","QGA, 4.Nc3",""},
tuple<uint64_t,string,string,string>{0x35ac01aa81e33db8,"D24","QGA, Bogolyubov variation",""},
tuple<uint64_t,string,string,string>{0x75e6a7016bfe7213,"D25","QGA, 4.e3",""},
tuple<uint64_t,string,string,string>{0x9c52f45a1071e058,"D25","QGA, Smyslov variation",""},
tuple<uint64_t,string,string,string>{0x77356d332c7b7cf9,"D25","QGA, Janowsky-Larsen variation",""},
tuple<uint64_t,string,string,string>{0x215e35d5234b091b,"D25","QGA, Flohr variation",""},
tuple<uint64_t,string,string,string>{0x391553073dce241,"D26","QGA","4...e6"},
tuple<uint64_t,string,string,string>{0x18137fd250fad8d,"D26","QGA","classical variation"},
tuple<uint64_t,string,string,string>{0xeb99c67d7a6df29c,"D26","QGA","classical, Furman variation"},
tuple<uint64_t,string,string,string>{0x7ff44cc959fc769d,"D26","QGA","classical variation, 6.O-O"},
tuple<uint64_t,string,string,string>{0x20eaf6fc24081f5b,"D26","QGA","classical, Steinitz variation"},
tuple<uint64_t,string,string,string>{0xad03bd3abedc8e41,"D27","QGA","classical, 6...a6"},
tuple<uint64_t,string,string,string>{0xc6cac3d6d34f5b8f,"D27","QGA","classical, Rubinstein variation"},
tuple<uint64_t,string,string,string>{0x3cffd46ade243ee6,"D27","QGA","classical, Geller variation"},
tuple<uint64_t,string,string,string>{0x3b053218f098d5c5,"D28","QGA","classical, 7.Qe2"},
tuple<uint64_t,string,string,string>{0x5b01580d6b3568f8,"D28","QGA","classical, 7...b5"},
tuple<uint64_t,string,string,string>{0x777ea85603afa39a,"D28","QGA","classical, Flohr variation"},
tuple<uint64_t,string,string,string>{0x229500ab92419787,"D29","QGA","classical, 8...Bb7"},
tuple<uint64_t,string,string,string>{0xa39b3e13f7a4dfb9,"D29","QGA","classical, Smyslov variation"},
tuple<uint64_t,string,string,string>{0xfc30f6b3c0a1a4ad,"D30","Queen's gambit declined",""},
tuple<uint64_t,string,string,string>{0x1a83398fccdf7729,"D30","QGD Slav",""},
tuple<uint64_t,string,string,string>{0xe1e9b22bf99e157e,"D30","QGD","Stonewall variation"},
tuple<uint64_t,string,string,string>{0x296042d22c779ae5,"D30","QGD Slav",""},
tuple<uint64_t,string,string,string>{0xf0b0f99b32570559,"D30","QGD Slav","Semmering variation"},
tuple<uint64_t,string,string,string>{0xf3376ad4b750e562,"D30","QGD","Spielmann variation"},
tuple<uint64_t,string,string,string>{0xbae07986b5375fce,"D30","QGD",""},
tuple<uint64_t,string,string,string>{0xef3a15e49cfd412d,"D30","QGD","Capablanca variation"},
tuple<uint64_t,string,string,string>{0x73a11080fec097ec,"D30","QGD","Vienna variation"},
tuple<uint64_t,string,string,string>{0x281732e022e316db,"D30","QGD","Capablanca-Duras variation"},
tuple<uint64_t,string,string,string>{0xd0852cd18aa5813f,"D30","QGD","Hastings variation"},
tuple<uint64_t,string,string,string>{0x7a7ee1102432674,"D31","QGD","3.Nc3"},
tuple<uint64_t,string,string,string>{0xd5501fe2e563dea8,"D31","QGD","Janowski variation"},
tuple<uint64_t,string,string,string>{0x6ccea701fcc091ef,"D31","QGD","Alapin variation"},
tuple<uint64_t,string,string,string>{0x136b9dfec8e88ae5,"D31","QGD","Charousek (Petrosian) variation"},
tuple<uint64_t,string,string,string>{0x95dd03fe7583f5cf,"D31","QGD","semi-Slav"},
tuple<uint64_t,string,string,string>{0x9cbfd63a4f5b7a11,"D31","QGD","semi-Slav, Noteboom variation"},
tuple<uint64_t,string,string,string>{0x416c6cb28590970a,"D31","QGD","semi-Slav, Koomen variation"},
tuple<uint64_t,string,string,string>{0x1d6c4d958ee7efba,"D31","QGD","semi-Slav, Junge variation"},
tuple<uint64_t,string,string,string>{0x5c890603273035f0,"D31","QGD","semi-Slav, Abrahams variation"},
tuple<uint64_t,string,string,string>{0x51da0eb69e0348c5,"D31","QGD","semi-Slav, Marshall gambit"},
tuple<uint64_t,string,string,string>{0xe1d63fbffd042d09,"D32","QGD","Tarrasch defence"},
tuple<uint64_t,string,string,string>{0xb0e21e47223e50d2,"D32","QGD","Tarrasch, von Hennig-Schara gambit"},
tuple<uint64_t,string,string,string>{0xd0e87db6456ff9df,"D32","QGD","Tarrasch defence, 4.cd ed"},
tuple<uint64_t,string,string,string>{0xcecdd5d11c5c0f4,"D32","QGD","Tarrasch defence, Tarrasch gambit"},
tuple<uint64_t,string,string,string>{0x14ef70feaeef44d5,"D32","QGD","Tarrasch defence, Marshall gambit"},
tuple<uint64_t,string,string,string>{0xb8c91402d8998e2,"D32","QGD","Tarrasch defence"},
tuple<uint64_t,string,string,string>{0x8c87f2e3dccfe5d9,"D33","QGD","Tarrasch, Schlechter-Rubinstein system"},
tuple<uint64_t,string,string,string>{0x54984881b4234f54,"D33","QGD","Tarrasch, Folkestone (Swedish) variation"},
tuple<uint64_t,string,string,string>{0x909f45c95fa3f25e,"D33","QGD","Tarrasch, Schlechter-Rubinstein system, Rey Ardid variation"},
tuple<uint64_t,string,string,string>{0xd769c6167135a44f,"D33","QGD","Tarrasch, Prague variation"},
tuple<uint64_t,string,string,string>{0x604a2f597b5d72dc,"D33","QGD","Tarrasch, Wagner variation"},
tuple<uint64_t,string,string,string>{0x76559684f673d0a7,"D34","QGD","Tarrasch, Prague variation, 7...Be7"},
tuple<uint64_t,string,string,string>{0x28800075fd9e25c,"D34","QGD","Tarrasch, Prague variation, Normal position"},
tuple<uint64_t,string,string,string>{0xc6f685086152a12a,"D34","QGD","Tarrasch, Reti variation"},
tuple<uint64_t,string,string,string>{0xc4d25731ef533994,"D34","QGD","Tarrasch, Prague variation, 9.Bg5"},
tuple<uint64_t,string,string,string>{0xc68b054d93913d5f,"D34","QGD","Tarrasch, Bogolyubov variation"},
tuple<uint64_t,string,string,string>{0x75fdf63f05fe2049,"D34","QGD","Tarrasch, Stoltz variation"},
tuple<uint64_t,string,string,string>{0x5c49dae4afb967e2,"D35","QGD","3...Nf6"},
tuple<uint64_t,string,string,string>{0x871d3c6536d98d81,"D35","QGD","Harrwitz attack"},
tuple<uint64_t,string,string,string>{0x526341290d7773ff,"D35","QGD","exchange variation"},
tuple<uint64_t,string,string,string>{0x5ea4e9c706fcd5a6,"D35","QGD","exchange, Saemisch variation"},
tuple<uint64_t,string,string,string>{0xab2dcfdba75868fc,"D35","QGD","exchange, positional line"},
tuple<uint64_t,string,string,string>{0xb795f21962f4b6b0,"D35","QGD","exchange, chameleon variation"},
tuple<uint64_t,string,string,string>{0x39572234d098bb47,"D35","QGD","exchange, positional line, 5...c6"},
tuple<uint64_t,string,string,string>{0x884e5029c24e8723,"D36","QGD","exchange, positional line, 6.Qc2"},
tuple<uint64_t,string,string,string>{0x872d3612c75f06df,"D37","QGD","4.Nf3"},
tuple<uint64_t,string,string,string>{0x48b5a37c9494402d,"D37","QGD","classical variation (5.Bf4)"},
tuple<uint64_t,string,string,string>{0x4e6c5f148ca8cefd,"D38","QGD","Ragozin variation"},
tuple<uint64_t,string,string,string>{0x5a3031106e1cfbd6,"D39","QGD","Ragozin, Vienna variation"},
tuple<uint64_t,string,string,string>{0x615ce7bc38180da2,"D40","QGD","Semi-Tarrasch defence"},
tuple<uint64_t,string,string,string>{0xe214274f42e601a9,"D40","QGD","Semi-Tarrasch, symmetrical variation"},
tuple<uint64_t,string,string,string>{0xc96f6c5ab974b969,"D40","QGD","Semi-Tarrasch, Levenfish variation"},
tuple<uint64_t,string,string,string>{0xa706b08a8892d66a,"D40","QGD","Semi-Tarrasch defence, Pillsbury variation"},
tuple<uint64_t,string,string,string>{0x6f767c719ad619bf,"D41","QGD","Semi-Tarrasch, 5.cd"},
tuple<uint64_t,string,string,string>{0x23d614cdc1510a50,"D41","QGD","Semi-Tarrasch, Kmoch variation"},
tuple<uint64_t,string,string,string>{0x31eb5ec8cae7a8fb,"D41","QGD","Semi-Tarrasch, San Sebastian variation"},
tuple<uint64_t,string,string,string>{0x5db5448e016c8c47,"D41","QGD","Semi-Tarrasch with e3"},
tuple<uint64_t,string,string,string>{0xa3553dce297deb37,"D42","QGD","Semi-Tarrasch, 7.Bd3"},
tuple<uint64_t,string,string,string>{0x1557dbfdb09fd564,"D43","QGD semi-Slav",""},
tuple<uint64_t,string,string,string>{0xd0852cd18aa5813f,"D43","QGD semi-Slav","Hastings variation"},
tuple<uint64_t,string,string,string>{0x10bb5f9522be04f,"D44","QGD semi-Slav","5.Bg5 dc"},
tuple<uint64_t,string,string,string>{0xc50cb8b1b9ab5d45,"D44","QGD semi-Slav","Botvinnik system (anti-Meran)"},
tuple<uint64_t,string,string,string>{0x775fd85ec93ced60,"D44","QGD semi-Slav","Ekstrom variation"},
tuple<uint64_t,string,string,string>{0xefed90774bab7787,"D44","QGD semi-Slav","anti-Meran gambit"},
tuple<uint64_t,string,string,string>{0xfced72369a1c6e29,"D44","QGD semi-Slav","anti-Meran, Lilienthal variation"},
tuple<uint64_t,string,string,string>{0x6a29b24456b6e0aa,"D44","QGD semi-Slav","anti-Meran, Szabo variation"},
tuple<uint64_t,string,string,string>{0x2bfd4f8e85690232,"D44","QGD semi-Slav","anti-Meran, Alatortsev system"},
tuple<uint64_t,string,string,string>{0xb87a994f94c05dc0,"D45","QGD semi-Slav","5.e3"},
tuple<uint64_t,string,string,string>{0x431012eba1813f97,"D45","QGD semi-Slav","stonewall defence"},
tuple<uint64_t,string,string,string>{0x6a8d68bc73e0a51c,"D45","QGD semi-Slav","accelerated Meran (Alekhine variation)"},
tuple<uint64_t,string,string,string>{0x8b99e2127468b00c,"D45","QGD semi-Slav","5...Nd7"},
tuple<uint64_t,string,string,string>{0x3a80900f66be8c68,"D45","QGD semi-Slav","Stoltz variation"},
tuple<uint64_t,string,string,string>{0x56a13ddd2fe5d57a,"D45","QGD semi-Slav","Rubinstein (anti-Meran) system"},
tuple<uint64_t,string,string,string>{0xde9443b04de8727f,"D46","QGD semi-Slav","6.Bd3"},
tuple<uint64_t,string,string,string>{0xca58305f8743deee,"D46","QGD semi-Slav","Bogolyubov variation"},
tuple<uint64_t,string,string,string>{0x17d52ab6061fba5d,"D46","QGD semi-Slav","Romih variation"},
tuple<uint64_t,string,string,string>{0x7acc2e3292f2a35b,"D46","QGD semi-Slav","Chigorin defence"},
tuple<uint64_t,string,string,string>{0x45284ee920e59f57,"D47","QGD semi-Slav","7.Bc4"},
tuple<uint64_t,string,string,string>{0x252c24fcbb48226a,"D47","QGD semi-Slav","Meran variation"},
tuple<uint64_t,string,string,string>{0x8a892602c4b5eaf5,"D47","QGD semi-Slav","neo-Meran (Lundin variation)"},
tuple<uint64_t,string,string,string>{0x5bd45f5877fe1c2d,"D47","QGD semi-Slav","Meran, Wade variation"},
tuple<uint64_t,string,string,string>{0x39b3e62fe28c4b6a,"D48","QGD semi-Slav","Meran, 8...a6"},
tuple<uint64_t,string,string,string>{0xc982bea1436da28e,"D48","QGD semi-Slav","Meran, Pirc variation"},
tuple<uint64_t,string,string,string>{0x24929594a5d4a602,"D48","QGD semi-Slav","Meran"},
tuple<uint64_t,string,string,string>{0x9e9ad6c73cf2305f,"D48","QGD semi-Slav","Meran, Reynolds' variation"},
tuple<uint64_t,string,string,string>{0x45eb8369a1ca8066,"D48","QGD semi-Slav","Meran, old main line"},
tuple<uint64_t,string,string,string>{0xfa85fdcdb945771b,"D49","QGD semi-Slav","Meran, Blumenfeld variation"},
tuple<uint64_t,string,string,string>{0x67a6a6abb40fe677,"D49","QGD semi-Slav","Meran, Rabinovich variation"},
tuple<uint64_t,string,string,string>{0x8cc671a898349c30,"D49","QGD semi-Slav","Meran, Sozin variation"},
tuple<uint64_t,string,string,string>{0xd499fbdd778f6516,"D49","QGD semi-Slav","Meran, Stahlberg variation"},
tuple<uint64_t,string,string,string>{0x10cefbda2701e8bd,"D49","QGD semi-Slav","Meran, Sozin variation"},
tuple<uint64_t,string,string,string>{0x505005b43a5b7f2c,"D49","QGD semi-Slav","Meran, Rellstab attack"},
tuple<uint64_t,string,string,string>{0x9a138dd21f33bc2a,"D50","QGD","4.Bg5"},
tuple<uint64_t,string,string,string>{0x7c625c7ce074b757,"D50","QGD","Been-Koomen variation"},
tuple<uint64_t,string,string,string>{0x6e6c2de2e639f01e,"D50","QGD","Semi-Tarrasch, Krause variation"},
tuple<uint64_t,string,string,string>{0x85af1d7bc1f75091,"D50","QGD","Semi-Tarrasch, Primitive Pillsbury variation"},
tuple<uint64_t,string,string,string>{0x7248c7b142baa34a,"D50","QGD","Semi-Tarrasch"},
tuple<uint64_t,string,string,string>{0xb5b739e688f17590,"D50","QGD","Canal (Venice) variation"},
tuple<uint64_t,string,string,string>{0xa9f0f68fff9b51e6,"D51","QGD","4.Bg5 Nbd7"},
tuple<uint64_t,string,string,string>{0x510786a94711a3f4,"D51","QGD","Rochlin variation"},
tuple<uint64_t,string,string,string>{0x24e9fade0b3d5e6a,"D51","QGD","Alekhine variation"},
tuple<uint64_t,string,string,string>{0x4ddb43ddbc4d942,"D51","QGD",""},
tuple<uint64_t,string,string,string>{0xcd9cdd3b90331160,"D51","QGD","Manhattan variation"},
tuple<uint64_t,string,string,string>{0x96a759d2ac040af9,"D51","QGD","5...c6"},
tuple<uint64_t,string,string,string>{0x5d3b68f4e54884b9,"D51","QGD","Capablanca anti-Cambridge Springs variation"},
tuple<uint64_t,string,string,string>{0x4dc3b524c4e26bc4,"D52","QGD",""},
tuple<uint64_t,string,string,string>{0x94b0207f6d904a4b,"D52","QGD","Cambridge Springs defence"},
tuple<uint64_t,string,string,string>{0x31caa083f60c8087,"D52","QGD","Cambridge Springs defence, Bogoljubow variation"},
tuple<uint64_t,string,string,string>{0x61ed25f7d0eb4bf7,"D52","QGD","Cambridge Springs defence, Argentine variation"},
tuple<uint64_t,string,string,string>{0x9b9482aafd139a22,"D52","QGD","Cambridge Springs defence, Rubinstein variation"},
tuple<uint64_t,string,string,string>{0x318f29aeb68e14ab,"D52","QGD","Cambridge Springs defence, Capablanca variation"},
tuple<uint64_t,string,string,string>{0x9a9abbb2cf5e5e56,"D52","QGD","Cambridge Springs defence, 7.cd"},
tuple<uint64_t,string,string,string>{0x574c1ff70bb430a,"D52","QGD","Cambridge Springs defence, Yugoslav variation"},
tuple<uint64_t,string,string,string>{0x8edffe3dd59810bb,"D53","QGD","4.Bg5 Be7"},
tuple<uint64_t,string,string,string>{0x19faf010438e15e5,"D53","QGD","Lasker variation"},
tuple<uint64_t,string,string,string>{0x295a5138249e71f4,"D53","QGD","4.Bg5 Be7, 5.e3 O-O"},
tuple<uint64_t,string,string,string>{0x56c19e75a78c252a,"D54","QGD","Anti-neo-orthodox variation"},
tuple<uint64_t,string,string,string>{0xf23ebdce4c7810c9,"D55","QGD","6.Nf3"},
tuple<uint64_t,string,string,string>{0x90cc803e1acf7b1a,"D55","QGD","Pillsbury attack"},
tuple<uint64_t,string,string,string>{0x60c9f6a8dbac59dc,"D55","QGD","Neo-orthodox variation"},
tuple<uint64_t,string,string,string>{0xc5f6ff7900b2073c,"D55","QGD","Neo-orthodox variation, 7.Bxf6"},
tuple<uint64_t,string,string,string>{0x71c569b85e392bc2,"D55","QGD","Petrosian variation"},
tuple<uint64_t,string,string,string>{0x3a469e6b28127b47,"D55","QGD","Neo-orthodox variation, 7.Bh4"},
tuple<uint64_t,string,string,string>{0x4ed2f49a5bf6bd,"D56","QGD","Lasker defence"},
tuple<uint64_t,string,string,string>{0x608b8a53652f31b2,"D56","QGD","Lasker defence, Teichmann variation"},
tuple<uint64_t,string,string,string>{0xa838d6d85321c043,"D56","QGD","Lasker defence, Russian variation"},
tuple<uint64_t,string,string,string>{0xeec36cc8c45017df,"D57","QGD","Lasker defence, main line"},
tuple<uint64_t,string,string,string>{0x3d6b84fe8dcc588e,"D57","QGD","Lasker defence, Bernstein variation"},
tuple<uint64_t,string,string,string>{0x512fd77bd691ccdc,"D58","QGD","Tartakower (Makagonov-Bondarevsky) system"},
tuple<uint64_t,string,string,string>{0xc0eb36fbcbbac59d,"D59","QGD","Tartakower (Makagonov-Bondarevsky) system, 8.cd Nxd5"},
tuple<uint64_t,string,string,string>{0xccbdc56bd768b3b6,"D59","QGD","Tartakower variation"},
tuple<uint64_t,string,string,string>{0xc1ddc693acd0fd05,"D60","QGD","Orthodox defence"},
tuple<uint64_t,string,string,string>{0x94d0673195503f76,"D60","QGD","Orthodox defence, Botvinnik variation"},
tuple<uint64_t,string,string,string>{0xfb24652b99eb55e3,"D60","QGD","Orthodox defence, Rauzer variation"},
tuple<uint64_t,string,string,string>{0x70c4b48ebe06c161,"D61","QGD","Orthodox defence, Rubinstein variation"},
tuple<uint64_t,string,string,string>{0x989ffeede38fde01,"D62","QGD","Orthodox defence, 7.Qc2 c5, 8.cd (Rubinstein)"},
tuple<uint64_t,string,string,string>{0xbe4609de2fc2a9db,"D63","QGD","Orthodox defence, 7.Rc1"},
tuple<uint64_t,string,string,string>{0xb11ca36550aa08e5,"D63","QGD","Orthodox defence, Pillsbury attack"},
tuple<uint64_t,string,string,string>{0xd7cfd3680cbe5915,"D63","QGD","Orthodox defence, Capablanca variation"},
tuple<uint64_t,string,string,string>{0x6cb1f82dc8e25107,"D63","QGD","Orthodox defence, Swiss (Henneberger) variation"},
tuple<uint64_t,string,string,string>{0x629b63e06a2c451a,"D63","QGD","Orthodox defence, Swiss, Karlsbad variation"},
tuple<uint64_t,string,string,string>{0x2c3ce43158027a60,"D63","QGD","Orthodox defence"},
tuple<uint64_t,string,string,string>{0x9d25962c4ad44604,"D64","QGD","Orthodox defence, Rubinstein attack (with Rc1)"},
tuple<uint64_t,string,string,string>{0xa72ddab3f89dcbfe,"D64","QGD","Orthodox defence, Rubinstein attack, Wolf variation"},
tuple<uint64_t,string,string,string>{0x4fd267dfadf4bed8,"D64","QGD","Orthodox defence, Rubinstein attack, Karlsbad variation"},
tuple<uint64_t,string,string,string>{0x844e56f9e4b83098,"D64","QGD","Orthodox defence, Rubinstein attack, Gruenfeld variation"},
tuple<uint64_t,string,string,string>{0x41f8fc120f3aaac5,"D65","QGD","Orthodox defence, Rubinstein attack, main line"},
tuple<uint64_t,string,string,string>{0x793145936182b813,"D66","QGD","Orthodox defence, Bd3 line"},
tuple<uint64_t,string,string,string>{0x828922df9722e806,"D66","QGD","Orthodox defence, Bd3 line, fianchetto variation"},
tuple<uint64_t,string,string,string>{0x269d9733c24d208e,"D67","QGD","Orthodox defence, Bd3 line, Capablanca freeing manoevre"},
tuple<uint64_t,string,string,string>{0xba3e0b1a697259f0,"D67","QGD","Orthodox defence, Bd3 line, Janowski variation"},
tuple<uint64_t,string,string,string>{0x5518f3e073767c77,"D67","QGD","Orthodox defence, Bd3 line"},
tuple<uint64_t,string,string,string>{0x4b71fde35131775f,"D67","QGD","Orthodox defence, Bd3 line, Alekhine variation"},
tuple<uint64_t,string,string,string>{0xda083d53d00c26f7,"D67","QGD","Orthodox defence, Bd3 line, 11.O-O"},
tuple<uint64_t,string,string,string>{0x8f46bbe076558abb,"D68","QGD","Orthodox defence, classical variation"},
tuple<uint64_t,string,string,string>{0xa2b4512936c1291b,"D68","QGD","Orthodox defence, classical, 13.d1b1 (Maroczy)"},
tuple<uint64_t,string,string,string>{0x3e5fc9fd6483b6df,"D68","QGD","Orthodox defence, classical, 13.d1c2 (Vidmar)"},
tuple<uint64_t,string,string,string>{0xb967933177d7a46b,"D69","QGD","Orthodox defence, classical, 13.de"},
tuple<uint64_t,string,string,string>{0x56ac851dae3c0853,"D70","Neo-Gruenfeld defence",""},
tuple<uint64_t,string,string,string>{0x14fbd86dee213f1a,"D70","Neo-Gruenfeld (Kemeri) defence",""},
tuple<uint64_t,string,string,string>{0x8073272645a02588,"D71","Neo-Gruenfeld, 5.cd",""},
tuple<uint64_t,string,string,string>{0x794b4eae9e4efe32,"D72","Neo-Gruenfeld, 5.cd, main line",""},
tuple<uint64_t,string,string,string>{0xcad32a50306d4df4,"D73","Neo-Gruenfeld, 5.Nf3",""},
tuple<uint64_t,string,string,string>{0x2fca5d5384ec764e,"D74","Neo-Gruenfeld, 6.cd Nxd5, 7.O-O",""},
tuple<uint64_t,string,string,string>{0x322c945fb949ffea,"D75","Neo-Gruenfeld, 6.cd Nxd5, 7.O-O c5, 8.Nc3",""},
tuple<uint64_t,string,string,string>{0xb658ae2d98b72a5f,"D75","Neo-Gruenfeld, 6.cd Nxd5, 7.O-O c5, 8.dc",""},
tuple<uint64_t,string,string,string>{0x651d25c9ca91d00,"D76","Neo-Gruenfeld, 6.cd Nxd5, 7.O-O Nb6",""},
tuple<uint64_t,string,string,string>{0xbe0ebcd399c77f0f,"D77","Neo-Gruenfeld, 6.O-O",""},
tuple<uint64_t,string,string,string>{0x2c74513cee07acb4,"D78","Neo-Gruenfeld, 6.O-O c6",""},
tuple<uint64_t,string,string,string>{0x512e65b8eca3b513,"D79","Neo-Gruenfeld, 6.O-O, main line",""},
tuple<uint64_t,string,string,string>{0xc38a7b8ecc1465fb,"D80","Gruenfeld defence",""},
tuple<uint64_t,string,string,string>{0x60c77a58246188e6,"D80","Gruenfeld","Spike gambit"},
tuple<uint64_t,string,string,string>{0x5d02cb87c9ebe33,"D80","Gruenfeld","Stockholm variation"},
tuple<uint64_t,string,string,string>{0xd2df086ca0908f56,"D80","Gruenfeld","Lundin variation"},
tuple<uint64_t,string,string,string>{0xf973d836f92fcd1d,"D81","Gruenfeld","Russian variation"},
tuple<uint64_t,string,string,string>{0x18de9d0f55748f98,"D82","Gruenfeld","4.Bf4"},
tuple<uint64_t,string,string,string>{0xfe70fbc5f35257d,"D83","Gruenfeld","Gruenfeld gambit"},
tuple<uint64_t,string,string,string>{0x707cc0f1dc2771a3,"D83","Gruenfeld","Gruenfeld gambit, Capablanca variation"},
tuple<uint64_t,string,string,string>{0xbd56a15b88c956ba,"D83","Gruenfeld","Gruenfeld gambit, Botvinnik variation"},
tuple<uint64_t,string,string,string>{0xa08f71815daca1db,"D84","Gruenfeld","Gruenfeld gambit accepted"},
tuple<uint64_t,string,string,string>{0x524e9a0ed13f6cba,"D85","Gruenfeld","exchange variation"},
tuple<uint64_t,string,string,string>{0x32f2da2bc4f28d7c,"D85","Gruenfeld","modern exchange variation"},
tuple<uint64_t,string,string,string>{0x8a2582f584573ae7,"D86","Gruenfeld","exchange, classical variation"},
tuple<uint64_t,string,string,string>{0x9ca6f37f02f36736,"D86","Gruenfeld","exchange, Larsen variation"},
tuple<uint64_t,string,string,string>{0xff40cd9d87a66969,"D86","Gruenfeld","exchange, Simagin's lesser variation"},
tuple<uint64_t,string,string,string>{0x3fc45c6f68b47bf1,"D86","Gruenfeld","exchange, Simagin's improved variation"},
tuple<uint64_t,string,string,string>{0x725855238662d58f,"D87","Gruenfeld","exchange, Spassky variation"},
tuple<uint64_t,string,string,string>{0x4c0e1bc3c8a851f6,"D87","Gruenfeld","exchange, Seville variation"},
tuple<uint64_t,string,string,string>{0x276022607366d5f2,"D88","Gruenfeld","Spassky variation, main line, 10...cd, 11.cd"},
tuple<uint64_t,string,string,string>{0x7ec069fa27e6f754,"D89","Gruenfeld","Spassky variation, main line, 13.Bd3"},
tuple<uint64_t,string,string,string>{0xc4c82aa9bec06109,"D89","Gruenfeld","exchange, Sokolsky variation"},
tuple<uint64_t,string,string,string>{0x18ee9778a4f204c6,"D90","Gruenfeld","Three knights variation"},
tuple<uint64_t,string,string,string>{0x8a947a97d332d77d,"D90","Gruenfeld","Schlechter variation"},
tuple<uint64_t,string,string,string>{0xa852aace5fb5cf6c,"D90","Gruenfeld","Three knights variation"},
tuple<uint64_t,string,string,string>{0x7af617819f8b3d17,"D90","Gruenfeld","Flohr variation"},
tuple<uint64_t,string,string,string>{0x6e08fdf8ef3f14a4,"D91","Gruenfeld","5.Bg5"},
tuple<uint64_t,string,string,string>{0x73064c4fc6d5250f,"D92","Gruenfeld","5.Bf4"},
tuple<uint64_t,string,string,string>{0xd483e34a37d34440,"D93","Gruenfeld with Bf4    e3",""},
tuple<uint64_t,string,string,string>{0x57fe87c7bea47c8,"D94","Gruenfeld","5.e3"},
tuple<uint64_t,string,string,string>{0xa52270670805c207,"D94","Gruenfeld","Makogonov variation"},
tuple<uint64_t,string,string,string>{0x265a5f7e3cd2c527,"D94","Gruenfeld","Opovcensky variation"},
tuple<uint64_t,string,string,string>{0x5adaa46997336c50,"D94","Gruenfeld with e3    Bd3",""},
tuple<uint64_t,string,string,string>{0xb406f880db856a11,"D94","Gruenfeld","Smyslov defence"},
tuple<uint64_t,string,string,string>{0x35cc5b3c2be56d76,"D94","Gruenfeld","Flohr defence"},
tuple<uint64_t,string,string,string>{0x352ea6739b8806c5,"D95","Gruenfeld with e3 & Qb3",""},
tuple<uint64_t,string,string,string>{0x4359544283aa9697,"D95","Gruenfeld","Botvinnik variation"},
tuple<uint64_t,string,string,string>{0x6678b6aa2946b9ff,"D95","Gruenfeld","Pachman variation"},
tuple<uint64_t,string,string,string>{0x92ab09766a8e678a,"D96","Gruenfeld","Russian variation"},
tuple<uint64_t,string,string,string>{0xa11f4cadad02beaa,"D97","Gruenfeld","Russian variation with e4"},
tuple<uint64_t,string,string,string>{0x73e8bd5e4a224676,"D97","Gruenfeld","Russian, Alekhine (Hungarian) variation"},
tuple<uint64_t,string,string,string>{0x3365a142dac26d11,"D97","Gruenfeld","Russian, Szabo (Boleslavsky) variation"},
tuple<uint64_t,string,string,string>{0xca7605bd53810931,"D97","Gruenfeld","Russian, Levenfish variation"},
tuple<uint64_t,string,string,string>{0xaf2944fbc931ba9,"D97","Gruenfeld","Russian, Byrne (Simagin) variation"},
tuple<uint64_t,string,string,string>{0xef9fe73d2bfd2216,"D97","Gruenfeld","Russian, Prins variation"},
tuple<uint64_t,string,string,string>{0xa3cc869fea87b040,"D98","Gruenfeld","Russian, Smyslov variation"},
tuple<uint64_t,string,string,string>{0xef5ee7944e699da9,"D98","Gruenfeld","Russian, Keres variation"},
tuple<uint64_t,string,string,string>{0x814ca588eccd530e,"D99","Gruenfeld defence","Smyslov, main line"},
tuple<uint64_t,string,string,string>{0x673d7426138a5873,"D99","Gruenfeld defence","Smyslov, Yugoslav variation"},
tuple<uint64_t,string,string,string>{0x22b4e052f18fab1d,"E00","Queen's pawn game",""},
tuple<uint64_t,string,string,string>{0xe4eeb764410570d5,"E00","Neo-Indian (Seirawan) attack",""},
tuple<uint64_t,string,string,string>{0xe525b1311587325,"E00","Catalan opening",""},
tuple<uint64_t,string,string,string>{0x3ec85a7ac061e57a,"E01","Catalan","closed"},
tuple<uint64_t,string,string,string>{0x3e6ade075261f9e2,"E02","Catalan","open, 5.Qa4"},
tuple<uint64_t,string,string,string>{0x3b119cb006d6b0fa,"E03","Catalan","open, Alekhine variation"},
tuple<uint64_t,string,string,string>{0xcac927bbeca72d91,"E03","Catalan","open, 5.Qa4 Nbd7, 6.Qxc4"},
tuple<uint64_t,string,string,string>{0x37aa8fbefab96aa4,"E04","Catalan","open, 5.Nf3"},
tuple<uint64_t,string,string,string>{0x2366fc513012c635,"E05","Catalan","open, classical line"},
tuple<uint64_t,string,string,string>{0xf160c563622c28d6,"E06","Catalan","closed, 5.Nf3"},
tuple<uint64_t,string,string,string>{0xb65e28bd2b2ef7e1,"E07","Catalan","closed, 6...Nbd7"},
tuple<uint64_t,string,string,string>{0x7fd4713c314e37f4,"E07","Catalan","closed, Botvinnik variation"},
tuple<uint64_t,string,string,string>{0x7475aa039f8cb85,"E08","Catalan","closed, 7.Qc2"},
tuple<uint64_t,string,string,string>{0x78bfb076459d8c64,"E08","Catalan","closed, Zagoryansky variation"},
tuple<uint64_t,string,string,string>{0x199bd71b94b57353,"E08","Catalan","closed, Qc2 & b3"},
tuple<uint64_t,string,string,string>{0x276cfb47883a902a,"E08","Catalan","closed, Spassky gambit"},
tuple<uint64_t,string,string,string>{0xcc530f2dd4c5b00e,"E09","Catalan","closed, main line"},
tuple<uint64_t,string,string,string>{0xa2ea2b4915eafe79,"E09","Catalan","closed, Sokolsky variation"},
tuple<uint64_t,string,string,string>{0xf9d00ca49969ca20,"E10","Queen's pawn game",""},
tuple<uint64_t,string,string,string>{0xc5adf44c64a5ea3d,"E10","Blumenfeld counter-gambit",""},
tuple<uint64_t,string,string,string>{0x8f999943f1a2a7e6,"E10","Blumenfeld counter-gambit accepted",""},
tuple<uint64_t,string,string,string>{0x3f7a37ad42f31f5,"E10","Blumenfeld counter-gambit, Dus-Chotimursky variation",""},
tuple<uint64_t,string,string,string>{0xa03eaa15fb90ac36,"E10","Blumenfeld counter-gambit, Spielmann variation",""},
tuple<uint64_t,string,string,string>{0x2b27fd577e4932fc,"E10","Dzindzikhashvili defence",""},
tuple<uint64_t,string,string,string>{0xc3d8403b2b2047da,"E10","Doery defence",""},
tuple<uint64_t,string,string,string>{0x309165a2d29e0202,"E11","Bogo-Indian defence",""},
tuple<uint64_t,string,string,string>{0x69ffddc04863aa32,"E11","Bogo-Indian defence, Gruenfeld variation",""},
tuple<uint64_t,string,string,string>{0x82e3e06781c3c76c,"E11","Bogo-Indian defence, Nimzovich variation",""},
tuple<uint64_t,string,string,string>{0xe770bb08e46506a7,"E11","Bogo-Indian defence, Monticelli trap",""},
tuple<uint64_t,string,string,string>{0x92b945b467ea7dbb,"E12","Queen's Indian defence",""},
tuple<uint64_t,string,string,string>{0x49eda335fe8a97d8,"E12","Queen's Indian","Miles variation"},
tuple<uint64_t,string,string,string>{0x592574922ea6f3fb,"E12","Queen's Indian","Petrosian system"},
tuple<uint64_t,string,string,string>{0x692e5d16a508ff62,"E12","Queen's Indian","4.Nc3"},
tuple<uint64_t,string,string,string>{0x465a47b04af79f9d,"E12","Queen's Indian","4.Nc3, Botvinnik variation"},
tuple<uint64_t,string,string,string>{0x1edd0807484d289d,"E13","Queen's Indian","4.Nc3, main line"},
tuple<uint64_t,string,string,string>{0x3f94070643b5f51f,"E14","Queen's Indian","4.e3"},
tuple<uint64_t,string,string,string>{0x2839b7dbeff5018a,"E14","Queen's Indian","Averbakh variation"},
tuple<uint64_t,string,string,string>{0xbe5ffef5873da583,"E15","Queen's Indian","4.g3"},
tuple<uint64_t,string,string,string>{0x714fac11cc1ca77d,"E15","Queen's Indian","Nimzovich variation (exaggerated fianchetto)"},
tuple<uint64_t,string,string,string>{0xecfb671f56f0a18,"E15","Queen's Indian","4.g3 Bb7"},
tuple<uint64_t,string,string,string>{0xe9e11b7fdd364d2d,"E15","Queen's Indian","Rubinstein variation"},
tuple<uint64_t,string,string,string>{0x8e803fe06d8a772e,"E15","Queen's Indian","Buerger variation"},
tuple<uint64_t,string,string,string>{0x727efc0af3751a43,"E16","Queen's Indian","Capablanca variation"},
tuple<uint64_t,string,string,string>{0xdde9137e02887dd7,"E16","Queen's Indian","Yates variation"},
tuple<uint64_t,string,string,string>{0x7ea89afc4f6f90fd,"E16","Queen's Indian","Riumin variation"},
tuple<uint64_t,string,string,string>{0xaff3e6e372297ef0,"E17","Queen's Indian","5.Bg2 Be7"},
tuple<uint64_t,string,string,string>{0x5464fe41b0cbfc29,"E17","Queen's Indian","anti-Queen's Indian system"},
tuple<uint64_t,string,string,string>{0x47e1e86b90e31ad7,"E17","Queen's Indian","Opovcensky variation"},
tuple<uint64_t,string,string,string>{0xd1869dd70edaa5e0,"E17","Queen's Indian","old main line, 6.O-O"},
tuple<uint64_t,string,string,string>{0x57881034010e2766,"E17","Queen's Indian","Euwe variation"},
tuple<uint64_t,string,string,string>{0x20b968c21961ced2,"E18","Queen's Indian","old main line, 7.Nc3"},
tuple<uint64_t,string,string,string>{0x2910a3204606afc5,"E19","Queen's Indian","old main line, 9.Qxc3"},
tuple<uint64_t,string,string,string>{0x106291f6789ae1e6,"E20","Nimzo-Indian defence",""},
tuple<uint64_t,string,string,string>{0x7ed377c7d8500e97,"E20","Nimzo-Indian","Kmoch variation"},
tuple<uint64_t,string,string,string>{0xb0053d3ad7d87091,"E20","Nimzo-Indian","Mikenas attack"},
tuple<uint64_t,string,string,string>{0x3c842ab7984d39de,"E20","Nimzo-Indian","Romanishin-Kasparov (Steiner) system"},
tuple<uint64_t,string,string,string>{0xcb067d00107c80db,"E21","Nimzo-Indian","three knights variation"},
tuple<uint64_t,string,string,string>{0x977feffd761d1dfb,"E21","Nimzo-Indian","three knights, Korchnoi variation"},
tuple<uint64_t,string,string,string>{0xad77a362c4549001,"E21","Nimzo-Indian","three knights, Euwe variation"},
tuple<uint64_t,string,string,string>{0x2a9b324e4da14900,"E22","Nimzo-Indian","Spielmann variation"},
tuple<uint64_t,string,string,string>{0x18e419d2406bb012,"E23","Nimzo-Indian","Spielmann, 4...c5, 5.dc Nc6"},
tuple<uint64_t,string,string,string>{0xd13987351057a106,"E23","Nimzo-Indian","Spielmann, Karlsbad variation"},
tuple<uint64_t,string,string,string>{0xa02e9b5bd59e2df,"E23","Nimzo-Indian","Spielmann, San Remo variation"},
tuple<uint64_t,string,string,string>{0xc1bdc3626bcc06b2,"E23","Nimzo-Indian","Spielmann, Staahlberg variation"},
tuple<uint64_t,string,string,string>{0xb112b1e78132d2ec,"E24","Nimzo-Indian","Saemisch variation"},
tuple<uint64_t,string,string,string>{0x8af9eae9ae4610c8,"E24","Nimzo-Indian","Saemisch, Botvinnik variation"},
tuple<uint64_t,string,string,string>{0xb2923fa1e0a56cdb,"E25","Nimzo-Indian","Saemisch variation"},
tuple<uint64_t,string,string,string>{0x529f673cbc5c26eb,"E25","Nimzo-Indian","Saemisch, Keres variation"},
tuple<uint64_t,string,string,string>{0xc6f001a502d40b35,"E25","Nimzo-Indian","Saemisch, Romanovsky variation"},
tuple<uint64_t,string,string,string>{0xfa4e22fb5a2a5135,"E26","Nimzo-Indian","Saemisch variation"},
tuple<uint64_t,string,string,string>{0x91276beba4a9e6ae,"E26","Nimzo-Indian","Saemisch, O'Kelly variation"},
tuple<uint64_t,string,string,string>{0xbbba5c50546b3b07,"E27","Nimzo-Indian","Saemisch variation"},
tuple<uint64_t,string,string,string>{0x16971ee27034b3a3,"E28","Nimzo-Indian","Saemisch variation"},
tuple<uint64_t,string,string,string>{0xe06b60ca762dfae,"E29","Nimzo-Indian","Saemisch, main line"},
tuple<uint64_t,string,string,string>{0xc97ab689e00bafd1,"E29","Nimzo-Indian","Saemisch, Capablanca variation"},
tuple<uint64_t,string,string,string>{0xd638c6c0c8103a2e,"E30","Nimzo-Indian","Leningrad variation"},
tuple<uint64_t,string,string,string>{0x223d1d8d51b671bd,"E30","Nimzo-Indian","Leningrad, ...b5 gambit"},
tuple<uint64_t,string,string,string>{0x7b83e1f9186385ed,"E31","Nimzo-Indian","Leningrad, main line"},
tuple<uint64_t,string,string,string>{0xa17be3eb6a4cdd82,"E32","Nimzo-Indian","classical variation"},
tuple<uint64_t,string,string,string>{0xd964be73338f64c3,"E32","Nimzo-Indian","classical, Adorjan gambit"},
tuple<uint64_t,string,string,string>{0xa963b097bdd7881,"E33","Nimzo-Indian","classical, 4...Nc6"},
tuple<uint64_t,string,string,string>{0xe848419ec14350d1,"E33","Nimzo-Indian","classical, Milner-Barry (Zurich) variation"},
tuple<uint64_t,string,string,string>{0x2411c1fff69893a4,"E34","Nimzo-Indian","classical, Noa variation"},
tuple<uint64_t,string,string,string>{0x152f83f64ef34772,"E35","Nimzo-Indian","classical, Noa variation, 5.cd ed"},
tuple<uint64_t,string,string,string>{0xef8df0d9bfd41de4,"E36","Nimzo-Indian","classical, Noa variation, 5.a3"},
tuple<uint64_t,string,string,string>{0x9d4fc327f03edb30,"E36","Nimzo-Indian","classical, Botvinnik variation"},
tuple<uint64_t,string,string,string>{0xcaa575a53e6f3c9,"E36","Nimzo-Indian","classical, Noa variation, main line"},
tuple<uint64_t,string,string,string>{0xe249c99f81c0d1bb,"E37","Nimzo-Indian","classical, Noa variation, main line, 7.Qc2"},
tuple<uint64_t,string,string,string>{0xe0508f1e90ee1171,"E37","Nimzo-Indian","classical, San Remo variation"},
tuple<uint64_t,string,string,string>{0x470a3245950bd6ff,"E38","Nimzo-Indian","classical, 4...c5"},
tuple<uint64_t,string,string,string>{0x3241fd22a34e6878,"E39","Nimzo-Indian","classical, Pirc variation"},
tuple<uint64_t,string,string,string>{0xbd4fd3445cc56942,"E40","Nimzo-Indian","4.e3"},
tuple<uint64_t,string,string,string>{0x16a20ba64d54cc41,"E40","Nimzo-Indian","4.e3, Taimanov variation"},
tuple<uint64_t,string,string,string>{0x5b3e02eaa382623f,"E41","Nimzo-Indian","4.e3 c5"},
tuple<uint64_t,string,string,string>{0x2dec100a81e99055,"E41","Nimzo-Indian","e3, Huebner variation"},
tuple<uint64_t,string,string,string>{0x4f9ae9258ba96fc1,"E42","Nimzo-Indian","4.e3 c5, 5.Ne2 (Rubinstein)"},
tuple<uint64_t,string,string,string>{0xd6269a54a246ded9,"E43","Nimzo-Indian","Fischer variation"},
tuple<uint64_t,string,string,string>{0xc282719b8a6dd327,"E44","Nimzo-Indian","Fischer variation, 5.Ne2"},
tuple<uint64_t,string,string,string>{0xd92237fc14cd1d9,"E45","Nimzo-Indian","4.e3, Bronstein (Byrne) variation"},
tuple<uint64_t,string,string,string>{0xb7e73ef3899c80a9,"E46","Nimzo-Indian","4.e3 O-O"},
tuple<uint64_t,string,string,string>{0xa343d53ca1b78d57,"E46","Nimzo-Indian","Reshevsky variation"},
tuple<uint64_t,string,string,string>{0x787ae4204fe5d13e,"E46","Nimzo-Indian","Simagin variation"},
tuple<uint64_t,string,string,string>{0xe2ea9f51b01c42da,"E47","Nimzo-Indian","4.e3 O-O, 5.Bd3"},
tuple<uint64_t,string,string,string>{0x6780bd452cc80cfc,"E48","Nimzo-Indian","4.e3 O-O, 5.Bd3 d5"},
tuple<uint64_t,string,string,string>{0xc6f09d54d5603ff6,"E49","Nimzo-Indian","4.e3, Botvinnik system"},
tuple<uint64_t,string,string,string>{0x6c83d205e17ae194,"E50","Nimzo-Indian","4.e3 e8g8, 5.Nf3, without ...d5"},
tuple<uint64_t,string,string,string>{0xe9e9f0117daeafb2,"E51","Nimzo-Indian","4.e3 e8g8, 5.Nf3 d7d5"},
tuple<uint64_t,string,string,string>{0xbb7acb577b72fd31,"E51","Nimzo-Indian","4.e3, Ragozin variation"},
tuple<uint64_t,string,string,string>{0xd78d18a3baadda5a,"E52","Nimzo-Indian","4.e3, main line with ...b6"},
tuple<uint64_t,string,string,string>{0x5a95801dbb6966bc,"E53","Nimzo-Indian","4.e3, main line with ...c5"},
tuple<uint64_t,string,string,string>{0x4f89b23939190a37,"E53","Nimzo-Indian","4.e3, Keres variation"},
tuple<uint64_t,string,string,string>{0x1703807427325060,"E53","Nimzo-Indian","4.e3, Gligoric system with 7...Nbd7"},
tuple<uint64_t,string,string,string>{0xbf5cf670aa975084,"E54","Nimzo-Indian","4.e3, Gligoric system with 7...dc"},
tuple<uint64_t,string,string,string>{0x24a329006babfeee,"E54","Nimzo-Indian","4.e3, Gligoric system, Smyslov variation"},
tuple<uint64_t,string,string,string>{0x8cbf8d2d4a3fbd48,"E55","Nimzo-Indian","4.e3, Gligoric system, Bronstein variation"},
tuple<uint64_t,string,string,string>{0x8f0d23cbd60b18af,"E56","Nimzo-Indian","4.e3, main line with 7...Nc6"},
tuple<uint64_t,string,string,string>{0x8033a5818fbe1201,"E57","Nimzo-Indian","4.e3, main line with 8...dc and 9...cd"},
tuple<uint64_t,string,string,string>{0x2e7d03da2fa32ba5,"E58","Nimzo-Indian","4.e3, main line with 8...Bxc3"},
tuple<uint64_t,string,string,string>{0xb5c10e8342aec68d,"E59","Nimzo-Indian","4.e3, main line"},
tuple<uint64_t,string,string,string>{0xbd7741389222a904,"E60","King's Indian defence",""},
tuple<uint64_t,string,string,string>{0x6613adcefac4c839,"E60","King's Indian, 3.Nf3",""},
tuple<uint64_t,string,string,string>{0xc6e332580f49560,"E60","Queen's pawn","Mengarini attack"},
tuple<uint64_t,string,string,string>{0x77f026b0b043f59,"E60","King's Indian","Anti-Gruenfeld"},
tuple<uint64_t,string,string,string>{0x677b687e90a98264,"E60","King's Indian","Danube gambit"},
tuple<uint64_t,string,string,string>{0x9191fa7972f5713c,"E60","King's Indian","3.g3"},
tuple<uint64_t,string,string,string>{0x11b7c6a6588b2cc9,"E60","King's Indian","3.g3, counterthrust variation"},
tuple<uint64_t,string,string,string>{0x46e0599a50c02bdd,"E61","King's Indian defence, 3.Nc3",""},
tuple<uint64_t,string,string,string>{0xd2d8498da19313ef,"E61","King's Indian","Smyslov system"},
tuple<uint64_t,string,string,string>{0x3864a5faf1ce101f,"E62","King's Indian","fianchetto variation"},
tuple<uint64_t,string,string,string>{0xe82a9465d5ac20ab,"E62","King's Indian","fianchetto, Larsen system"},
tuple<uint64_t,string,string,string>{0xb24068b0cb3b08a9,"E62","King's Indian","fianchetto, Kavalek (Bronstein) variation"},
tuple<uint64_t,string,string,string>{0x2cd1b3d278eb848e,"E62","King's Indian","fianchetto with ...Nc6"},
tuple<uint64_t,string,string,string>{0xd8dcc0ac97fda7a8,"E62","King's Indian","fianchetto, Uhlmann (Szabo) variation"},
tuple<uint64_t,string,string,string>{0xd1bda168b3fd5613,"E62","King's Indian","fianchetto, lesser Simagin (Spassky) variation"},
tuple<uint64_t,string,string,string>{0x507702d4439d5174,"E62","King's Indian","fianchetto, Simagin variation"},
tuple<uint64_t,string,string,string>{0x80533915e338a742,"E63","King's Indian","fianchetto, Panno variation"},
tuple<uint64_t,string,string,string>{0x614dba9e963d2af0,"E64","King's Indian","fianchetto, Yugoslav system"},
tuple<uint64_t,string,string,string>{0x1f38c1aaeacef1e0,"E65","King's Indian","fianchetto, Yugoslav, 7.O-O"},
tuple<uint64_t,string,string,string>{0xedd5a1b6279c2be,"E66","King's Indian","fianchetto, Yugoslav Panno"},
tuple<uint64_t,string,string,string>{0xb4df106d89d2cc41,"E67","King's Indian","fianchetto with ...Nd7"},
tuple<uint64_t,string,string,string>{0x40d2631366c4ef67,"E67","King's Indian","fianchetto, classical variation"},
tuple<uint64_t,string,string,string>{0x84d56e5b8d44526d,"E68","King's Indian","fianchetto, classical variation, 8.e4"},
tuple<uint64_t,string,string,string>{0xfe5c5e0a38274824,"E69","King's Indian","fianchetto, classical main line"},
tuple<uint64_t,string,string,string>{0x325b696440075d7d,"E70","King's Indian","4.e4"},
tuple<uint64_t,string,string,string>{0x1f4514caba5419ee,"E70","King's Indian","Kramer system"},
tuple<uint64_t,string,string,string>{0xcdbba83322f5cfd8,"E70","King's Indian","accelerated Averbakh system"},
tuple<uint64_t,string,string,string>{0xe31222bb50dcdde2,"E71","King's Indian","Makagonov system (5.h3)"},
tuple<uint64_t,string,string,string>{0x2707444472a8cc28,"E72","King's Indian with e4 & g3",""},
tuple<uint64_t,string,string,string>{0x683690b51d20872,"E72","King's Indian","Pomar system"},
tuple<uint64_t,string,string,string>{0x78617cfc935a5eb3,"E73","King's Indian","5.Be2"},
tuple<uint64_t,string,string,string>{0x1c12aa7c739acd6,"E73","King's Indian","Semi-Averbakh system"},
tuple<uint64_t,string,string,string>{0xb493c67df6896c90,"E73","King's Indian","Averbakh system"},
tuple<uint64_t,string,string,string>{0x52e217d309ce67ed,"E74","King's Indian","Averbakh, 6...c5"},
tuple<uint64_t,string,string,string>{0x9e9da6b188ca61e2,"E75","King's Indian","Averbakh, main line"},
tuple<uint64_t,string,string,string>{0xf6f782088bee2999,"E76","King's Indian","Four pawns attack"},
tuple<uint64_t,string,string,string>{0x7b4211b450303c6f,"E76","King's Indian","Four pawns attack, dynamic line"},
tuple<uint64_t,string,string,string>{0x8fdfec465f928ad1,"E77","King's Indian","Four pawns attack, 6.Be2"},
tuple<uint64_t,string,string,string>{0xf44908a2e5b7c69,"E77","King's Indian","Six pawns attack"},
tuple<uint64_t,string,string,string>{0x7eb5607c4937e69e,"E77","King's Indian","Four pawns attack"},
tuple<uint64_t,string,string,string>{0x20d8af45578c0031,"E77","King's Indian","Four pawns attack, Florentine gambit"},
tuple<uint64_t,string,string,string>{0xb2cad11ec833e091,"E78","King's Indian","Four pawns attack, with Be2 and Nf3"},
tuple<uint64_t,string,string,string>{0x52a55578345da5f4,"E79","King's Indian","Four pawns attack, main line"},
tuple<uint64_t,string,string,string>{0x6550193432b5fb61,"E80","King's Indian","Saemisch variation"},
tuple<uint64_t,string,string,string>{0x6ff8f483e7ec128a,"E81","King's Indian","Saemisch, 5...O-O"},
tuple<uint64_t,string,string,string>{0x970f2d1cfb6e010,"E81","King's Indian","Saemisch, Byrne variation"},
tuple<uint64_t,string,string,string>{0x7799067f9855be9f,"E82","King's Indian","Saemisch, double fianchetto variation"},
tuple<uint64_t,string,string,string>{0xb71d978d7747ac07,"E83","King's Indian","Saemisch, 6...Nc6"},
tuple<uint64_t,string,string,string>{0x3b1ad7a209521693,"E83","King's Indian","Saemisch, Ruban variation"},
tuple<uint64_t,string,string,string>{0x714e8db1b84c5925,"E83","King's Indian","Saemisch, Panno formation"},
tuple<uint64_t,string,string,string>{0xc1f569de2fcb31ef,"E84","King's Indian","Saemisch, Panno main line"},
tuple<uint64_t,string,string,string>{0x96884725f533f132,"E85","King's Indian","Saemisch, orthodox variation"},
tuple<uint64_t,string,string,string>{0x10564105aad82f77,"E86","King's Indian","Saemisch, orthodox, 7.Nge2 c6"},
tuple<uint64_t,string,string,string>{0x2c8004766c15676f,"E87","King's Indian","Saemisch, orthodox, 7.d5"},
tuple<uint64_t,string,string,string>{0x22e739c96f9e52fc,"E87","King's Indian","Saemisch, orthodox, Bronstein variation"},
tuple<uint64_t,string,string,string>{0xbefae9991bd5b4d4,"E88","King's Indian","Saemisch, orthodox, 7.d5 c6"},
tuple<uint64_t,string,string,string>{0xd92ead1f9394b490,"E89","King's Indian","Saemisch, orthodox main line"},
tuple<uint64_t,string,string,string>{0xd08513f3fa99752d,"E90","King's Indian","5.Nf3"},
tuple<uint64_t,string,string,string>{0xa92545a8aefa8748,"E90","King's Indian","Larsen variation"},
tuple<uint64_t,string,string,string>{0x1c77a9729f4a470e,"E90","King's Indian","Zinnowitz variation"},
tuple<uint64_t,string,string,string>{0xa9ad7dbd2ee5d665,"E91","King's Indian","6.Be2"},
tuple<uint64_t,string,string,string>{0xe72dd62da81a4ad9,"E91","King's Indian","Kazakh variation"},
tuple<uint64_t,string,string,string>{0x23d575f7bd002e53,"E92","King's Indian","classical variation"},
tuple<uint64_t,string,string,string>{0xbf488ab5b5359923,"E92","King's Indian","Andersson variation"},
tuple<uint64_t,string,string,string>{0x50ddce1b3c3a35dd,"E92","King's Indian","Gligoric-Taimanov system"},
tuple<uint64_t,string,string,string>{0x99dd36a42426b80e,"E92","King's Indian","Petrosian system"},
tuple<uint64_t,string,string,string>{0x1fc7836547bab49e,"E92","King's Indian","Petrosian system, Stein variation"},
tuple<uint64_t,string,string,string>{0xaa3e4df9c48e55c2,"E93","King's Indian","Petrosian system, main line"},
tuple<uint64_t,string,string,string>{0xb81bf60326b4f49a,"E93","King's Indian","Petrosian system, Keres variation"},
tuple<uint64_t,string,string,string>{0x5da00ec3c1f3f543,"E94","King's Indian","orthodox variation"},
tuple<uint64_t,string,string,string>{0xcfdae32cb63326f8,"E94","King's Indian","orthodox, Donner variation"},
tuple<uint64_t,string,string,string>{0x6e43759e215b188f,"E94","King's Indian","orthodox, 7...Nbd7"},
tuple<uint64_t,string,string,string>{0xeaf77b15a6f3b39b,"E95","King's Indian","orthodox, 7...Nbd7, 8.Re1"},
tuple<uint64_t,string,string,string>{0x8d17a0c2b38a2613,"E96","King's Indian","orthodox, 7...Nbd7, main line"},
tuple<uint64_t,string,string,string>{0xf64dd621d0625040,"E97","King's Indian","orthodox, Aronin-Taimanov variation (Yugoslav attack / Mar del Plata variation)"},
tuple<uint64_t,string,string,string>{0xe258c88fa5742128,"E97","King's Indian","orthodox, Aronin-Taimanov, bayonet attack"},
tuple<uint64_t,string,string,string>{0xdfc12ba3297d16ef,"E98","King's Indian","orthodox, Aronin-Taimanov, 9.Ne1"},
tuple<uint64_t,string,string,string>{0xdc58a8ad9af3ddb5,"E99","King's Indian","orthodox, Aronin-Taimanov, main line"},
tuple<uint64_t,string,string,string>{0x7f15a97b728630a8,"E99","King's Indian","orthodox, Aronin-Taimanov, Benko attack"}
};


EcoCodes::EcoCodes()
{
  for(auto t : ecocodes){
    uint64_t eco_hash=std::get<0>(t);
    string eco_code=std::get<1>(t);
    string eco_opening=std::get<2>(t);
    string eco_variation=std::get<3>(t);
    m_eco_code[eco_hash]=eco_code;
    m_eco_opening[eco_hash]=eco_opening;
    m_eco_variation[eco_hash]=eco_variation;
  }
}

string EcoCodes::eco_code(uint64_t hash)
{
  string r;
  if(m_eco_code.count(hash)){
    r=m_eco_code[hash];
  }
  return r;
}

string EcoCodes::eco_opening(uint64_t hash)
{
  string r;
  if(m_eco_code.count(hash)){
  r=m_eco_opening[hash];
  }
  return r;
}

string EcoCodes::eco_variation(uint64_t hash)
{
  string r;
  if(m_eco_code.count(hash)){
    r=m_eco_variation[hash];
  }
  return r;
}
